; Do not change filenames or add or remove FILEI/FILEO statements using an editor. Use Cube/Application Manager.
RUN PGM=MATRIX PRNFILE="C:\TRANSITMODEL\APPLICATIONS\TAMAT00C.PRN" MSG='4) Print transit assignment summary files'

; ***************************************************************************************************
; SCRIPT TO SUMMARIZE THE PEAK OFF-PEAK TRANSIT ASSIGNMENT BY ROUTE, MODE, OPERATOR, AND STOPS
;****************************************************************************************************


;****************************************************************************************************
; INPUT FILES: PEAK FILE              TLINKPK_{ALT}{YEAR}.PRN
;              OFF-PEAK FILE          TLINKOP_{ALT}{YEAR}.PRN

;OUTPUT FILES: ROUTE LEVEL SUMMARY   tasroute_{alt}{year}.prn
;              STOP LEVEL SUMMARY    tasum_{alt}{year}.prn
;              REPORT                tareport.out
;****************************************************************************************************


FILEO PRINTO[2] = "{SCENARIO_DIR}\OUTPUT\TASUM_{ALT}{YEAR}.PRN"
FILEO PRINTO[1] = "{SCENARIO_DIR}\OUTPUT\TASROUTE_{ALT}{YEAR}.PRN"
FILEI DBI[2] = "{SCENARIO_DIR}\OUTPUT\TLINKOP_{ALT}{YEAR}.DBF",
sort=NAME,index 
FILEI DBI[1] = "{SCENARIO_DIR}\OUTPUT\TLINKPK_{ALT}{YEAR}.DBF",
sort=NAME,index 

;********************************************************
; DEFINE ALL ROUTE-LEVEL ARRAYS WITH SIZE AS MAX. NO. OF ROUTES (500)
;********************************************************

array routename= 500-16
array routelname=500-40
array dist  = 500
array time = 500
array mode = 500
array operator = 500
array freq=500
array pax=500
array paxmi=500
array paxhr=500
array timeO = 500
array modeo = 500
array operatoro = 500
array freqo=500
array paxO=500
array paxmiO=500
array paxhrO=500
ARRAY MAXLD=dbi.1.numrecords
ARRAY MAXLDO=500
array routestart=500
array routeend=500

;********************************************************
; DEFINE ALL MODE-LEVEL ARRAYS WITH SIZE AS MAX. NO. OF MODES (200)
;********************************************************
array modelist1=200
array operlist1=200
ARRAY MODELIST=200
ARRAY MDIST=200
ARRAY MTIME=200
ARRAY MPAX=200
ARRAY MPAXMI=200
ARRAY MPAXHR=200
ARRAY MTIMEO=200
ARRAY MPAXO=200
ARRAY MPAXMIO=200
ARRAY MPAXHRO=200


;********************************************************
; DEFINE ALL OPERATOR-LEVEL ARRAYS WITH SIZE AS MAX. NO. OF OPERATORS (200)
;********************************************************

ARRAY OPERLIST=200
ARRAY ODIST=200
ARRAY OTIME=200
ARRAY OPAX=200
ARRAY OPAXMI=200
ARRAY OPAXHR=200
ARRAY OTIMEO=200
ARRAY OPAXO=200
ARRAY OPAXMIO=200
ARRAY OPAXHRO=200


;********************************************************
; DEFINE ALL STOP-LEVEL ARRAYS WITH SIZE AS NO. OF DATAPOINTS (dbi.(1 OR 2).numrecords
;********************************************************

array rtnumber=dbi.1.numrecords
array node=dbi.1.numrecords
array cumdist=dbi.1.numrecords
array tempdist=dbi.1.numrecords
array temptime=dbi.1.numrecords
array onasum=dbi.1.numrecords
array onarecord=dbi.1.numrecords
array offasum=dbi.1.numrecords
array offarecord=dbi.1.numrecords
array load=dbi.1.numrecords
array distan=dbi.1.numrecords
array timean=dbi.1.numrecords
array volrecord=dbi.1.numrecords

array rtnumbero=dbi.2.numrecords
array nodeo=dbi.2.numrecords
array cumdisto=dbi.2.numrecords
array tempdisto=dbi.2.numrecords
array temptimeo=dbi.2.numrecords
array onasumo=dbi.2.numrecords
array onarecordo=dbi.2.numrecords
array offasumo=dbi.2.numrecords
array offarecordo=dbi.2.numrecords
array loado=dbi.2.numrecords
array distano=dbi.2.numrecords
array timeano=dbi.2.numrecords
array volrecordo=dbi.2.numrecords

;************************************
; MAIN SCRIPT AREA
;************************************
zones=1
numroute = 1 
ROUTENUM=1
ROUTENUMO=1
NUMROUTEO=1
zero=0
;**********************************************
; BEGIN LOOP TO DETERMINE THE NUMBER OF ROUTES IN PEAK PERIOD
;**********************************************

LOOP k=1,DBI.1.NUMRECORDS
    x=DBIReadRecord(1,k)
;if(di.1.mode >20)
   
  if ( k =1 ) 
     prevroute=di.1.name
 endif

   IF  (prevroute = di.1.name)
        NUMROUTE=NUMROUTE
   ELSE
      
        NUMROUTE=NUMROUTE+1
        prevroute = di.1.name
   ENDIF
;endif
ENDLOOP

PRINT LIST=NUMROUTE
;********************************************
; END LOOP TO DETERMINE THE NUMBER OF ROUTES
;********************************************

;**********************************************
; BEGIN LOOP TO DETERMINE THE NUMBER OF ROUTES IN OFF-PEAK PERIOD
;**********************************************

LOOP k=1,DBI.2.NUMRECORDS
    x=DBIReadRecord(2,k)
;if(di.2.mode >20)   
  if ( k =1 ) 
     prevroute=di.2.name
 endif

   IF  (prevroute = di.2.name)
        NUMROUTEO=NUMROUTEO
   ELSE
      
        NUMROUTEO=NUMROUTEO+1
        prevroute = di.2.name
   ENDIF
;endif
ENDLOOP

;PRINT LIST=NUMROUTEO, "NUMROUTEO"
;********************************************
; END LOOP TO DETERMINE THE NUMBER OF ROUTES
;********************************************

;******************************************************************************************************
; BEGIN LOOP TO CALCULATE DIST, TIME, VOL, FREQUENCY, PAX, PAXMI, PAXHR, MAXLD FOR PEAK PERIOD BY ROUTE
;******************************************************************************************************

loop k=1,DBI.1.NUMRECORDS
     x=DBIReadRecord(1,k)

;if(di.1.mode >20)  
  _modenumber=di.1.mode
 
     if ( k =1 ) 
       prevroute=di.1.name
       routestart[k]=di.1.a      
     endif

     if ( prevroute = di.1.name)
       rtnumber[k]=routenum
       node[k]=di.1.a
       routename[ROUTENUM]=di.1.name
       routelname[ROUTENUM]=di.1.longname  
       mode[ROUTENUM]=di.1.mode
       operator[ROUTENUM]=di.1.operator
       freq[ROUTENUM]= di.1.headway
       dist[ROUTENUM]=dist[ROUTENUM]+di.1.dist       
       time[ROUTENUM]=time[ROUTENUM]+di.1.time
       pax[ROUTENUM]=pax[ROUTENUM]+di.1.ona1+di.1.ona2+di.1.ona3+di.1.ona4
       paxmi[ROUTENUM]=paxmi[ROUTENUM]+di.1.vol1*di.1.dist+di.1.vol2*di.1.dist+di.1.vol3*di.1.dist+di.1.vol4*di.1.dist
       paxhr[ROUTENUM]=paxhr[ROUTENUM]+(di.1.vol1*di.1.time+di.1.vol2*di.1.time+di.1.vol3*di.1.time+di.1.vol4*di.1.time)/60
         ; IF(MAXLD[ROUTENUM] < DI.1.VOL1+DI.1.VOL2+DI.1.VOL3) 
         ;        MAXLD[ROUTENUM]=DI.1.VOL1+DI.1.VOL2+DI.1.VOL3
         ; ENDIF
       routeend[routenum]=di.1.b
    else 
       ROUTENUM = ROUTENUM + 1
       routestart[routenum]=di.1.a       
       routename[ROUTENUM]=di.1.name 
       routelname[ROUTENUM]=di.1.longname
       node[k]=di.1.a
       rtnumber[k]=routenum
       prevroute = di.1.name
       dist[ROUTENUM]=di.1.dist      
       time[ROUTENUM]=di.1.time
       pax[ROUTENUM]=di.1.ona1+di.1.ona2+di.1.ona3+di.1.ona4
       paxmi[ROUTENUM]=di.1.vol1*di.1.dist+di.1.vol2*di.1.dist+di.1.vol3*di.1.dist+di.1.vol4*di.1.dist
       paxhr[ROUTENUM]=(di.1.vol1*di.1.time+di.1.vol2*di.1.time+di.1.vol3*di.1.timE+di.1.vol4*di.1.time)/60  
      ; MAXLD[ROUTENUM]=DI.1.VOL1+DI.1.VOL2+DI.1.VOL3  
    endif

;  MDIST[_modenumber]=MDIST[_modenumber]+di.1.DIST

  onarecord[k]=di.1.ona1+di.1.ona2+di.1.ona3+di.1.ona4
  offarecord[k]=di.1.offa1+di.1.offa2+di.1.offa3 +di.1.offa4
  volrecord[k]=di.1.vol1+di.1.vol2+di.1.vol3+di.1.vol4

  ;endif
endloop


;******************************************************************************************************
; END LOOP TO CALCULATE DIST, TIME, VOL, FREQUENCY, PAX, PAXMI, PAXHR, MAXLD FOR PEAK PERIOD BY ROUTE
;******************************************************************************************************

;******************************************************************************************************
; BEGIN LOOP TO CALCULATE DIST, TIME, VOL, FREQUENCY, PAX, PAXMI, PAXHR, MAXLD FOR OFF-PEAK PERIOD BY ROUTE
;******************************************************************************************************

loop k=1,DBI.2.NUMRECORDS
     x=DBIReadRecord(2,k)
 ;if(di.2.mode >20)    
     if ( k =1 ) 
       prevrouteO=di.2.name
      ; prevmode
     endif

     if ( prevrouteO = di.2.name)
      ; routename[ROUTENUM]=di.2.name 
      ; mode[ROUTENUM]=di.2.mode
      ; operator[ROUTENUM]=di.2.operator
       freqO[ROUTENUMO]= di.2.headway
     ;  dist[ROUTENUM]=dist[ROUTENUM]+di.2.dist
       timeO[ROUTENUMO]=timeO[ROUTENUMO]+di.2.time
       paxO[ROUTENUMO]=paxO[ROUTENUMO]+di.2.ona1+di.2.ona2+di.2.ona3+di.2.ona4
       paxmiO[ROUTENUMO]=paxmiO[ROUTENUMO]+di.2.vol1*di.2.dist+di.2.vol2*di.2.dist+di.2.vol3*di.2.dist+di.2.vol4*di.2.dist
       paxhrO[ROUTENUMO]=paxhrO[ROUTENUMO]+(di.2.vol1*di.2.time+di.2.vol2*di.2.time+di.2.vol3*di.2.time+di.2.vol4*di.2.time)/60
           ; IF(MAXLDO[ROUTENUMO] < DI.2.VOL1+DI.2.VOL2+DI.2.VOL3) 
           ;      MAXLDO[ROUTENUMO]=DI.2.VOL1+DI.2.VOL2+DI.2.VOL3
         ; ENDIF

    else 
       ROUTENUMO = ROUTENUMO + 1
       prevrouteO = di.2.name
       ;dist[ROUTENUM]=di.2.dist
       timeO[ROUTENUMO]=di.2.time
       paxO[ROUTENUMO]=di.2.ona1+di.2.ona2+di.2.ona3+di.2.ona4
       paxmiO[ROUTENUMO]=di.2.vol1*di.2.dist+di.2.vol2*di.2.dist+di.2.vol3*di.2.dist+di.2.vol4*di.2.dist
       paxhrO[ROUTENUMO]=(di.2.vol1*di.2.time+di.2.vol2*di.2.time+di.2.vol3*di.2.time+di.2.vol4*di.2.time)/60  
     ; MAXLDO[ROUTENUMO]=DI.2.VOL1+DI.2.VOL2+DI.2.VOL3  
    endif

  onarecordo[k]=di.2.ona1+di.2.ona2+di.2.ona3+di.2.ona4
  offarecordo[k]=di.2.offa1+di.2.offa2+di.2.offa3+di.2.offa4 
  volrecordo[k]=di.2.vol1+di.2.vol2+di.2.vol3+di.2.vol4

;endif
endloop

;********************************************************************************************************
; END LOOP TO CALCULATE DIST, TIME, VOL, FREQUENCY, PAX, PAXMI, PAXHR, MAXLD FOR OFF-PEAK PERIOD BY ROUTE
;********************************************************************************************************

;*********************************************************************************************************
; BEGIN LOOP TO CALCULATE DIST,TIME,PAX,PAXMI,PAXHR FOR PEAK PERIOD BY MODE
;*********************************************************************************************************

NUMMODE=1

LOOP k=1,NUMROUTE
 ;print list=k,routestart[k],routeend[k]  
;if( mode[k]>20) 
 if ( k =1 ) 
     MODELIST[NUMMODE]=MODE[K]
 endif

     FLAG=0

 LOOP Y=1,NUMMODE
     IF(MODELIST[Y] = MODE[K])
         FLAG=FLAG+1
         MDIST[Y]=MDIST[Y]+DIST[K]
         MTIME[Y]=MTIME[Y]+TIME[K]
         MPAX[Y]=MPAX[Y]+PAX[K]
         MPAXMI[Y]=MPAXMI[Y]+PAXMI[K]
         MPAXHR[Y]=MPAXHR[Y]+PAXHR[K]
         MTIMEO[Y]=MTIMEO[Y]+TIMEO[K]
         MPAXO[Y]=MPAXO[Y]+PAXO[K]
         MPAXMIO[Y]=MPAXMIO[Y]+PAXMIO[K]
         MPAXHRO[Y]=MPAXHRO[Y]+PAXHRO[K]

     ENDIF
 ENDLOOP


 IF (FLAG == 0) 
     NUMMODE=NUMMODE+1
     MODELIST[NUMMODE]=MODE[K]
     MDIST[NUMMODE]=DIST[K]
     MTIME[NUMMODE]=TIME[K]
     MPAX[NUMMODE]=PAX[K]
     MPAXMI[NUMMODE]=PAXMI[K]
     MPAXHR[NUMMODE]=PAXHR[K]
     MTIMEO[NUMMODE]=TIMEO[K]
     MPAXO[NUMMODE]=PAXO[K]
     MPAXMIO[NUMMODE]=PAXMIO[K]
     MPAXHRO[NUMMODE]=PAXHRO[K]

 ENDIF
;endif
 ENDLOOP

loop ind=1,nummode
    mdistsum=mdistsum+mdist[ind]
    mtimesum=mtimesum+mtime[ind]
    mpaxsum=mpaxsum+mpax[ind]
    mpaxmisum=mpaxmisum+mpaxmi[ind]
    mpaxhrsum=mpaxhrsum+mpaxhr[ind]
    mtimeosum=mtimeosum+mtimeo[ind]
    mpaxosum=mpaxosum+mpaxo[ind]
    mpaxmiosum=mpaxmiosum+mpaxmio[ind]
    mpaxhrosum=mpaxhrosum+mpaxhro[ind]

  endloop

loop k=1,nummode
modelist1[k]=modelist[k]
print list= k, modelist1[k]
endloop 

loop l=1,nummode
loop m=1,nummode-1
if(modelist1[m+1]<modelist1[m])
tempe=modelist1[m]
modelist1[m]=modelist1[m+1]
print list="modelist",m,l,nummode,tempe,modelist1[m],modelist1[m+1]
exec=m+1
modelist1[exec]=tempe
endif
endloop
endloop

;*********************************************************************************************************
; END LOOP TO CALCULATE DIST,TIME,PAX,PAXMI,PAXHR FOR PEAK PERIOD BY MODE
;*********************************************************************************************************

;*********************************************************************************************************
; BEGIN LOOP TO CALCULATE DIST,TIME,PAX,PAXMI,PAXHR FOR PEAK PERIOD BY OPERATOR
;*********************************************************************************************************

NUMOPER=1

LOOP k=1,NUMROUTE
  ; if(mode[k]>20)  
 if ( k =1 ) 
     OPERLIST[NUMoper]=OPERATOR[K]
 endif

     FLAG=0

 LOOP Y=1,NUMOPER
     IF(OPERLIST[Y] = OPERATOR[K])
         FLAG=FLAG+1
         ODIST[Y]=ODIST[Y]+DIST[K]
         OTIME[Y]=OTIME[Y]+TIME[K]
         OPAX[Y]=OPAX[Y]+PAX[K]
         OPAXMI[Y]=OPAXMI[Y]+PAXMI[K]
         OPAXHR[Y]=OPAXHR[Y]+PAXHR[K]
         OTIMEO[Y]=OTIMEO[Y]+TIMEO[K]
         OPAXO[Y]=OPAXO[Y]+PAXO[K]
         OPAXMIO[Y]=OPAXMIO[Y]+PAXMIO[K]
         OPAXHRO[Y]=OPAXHRO[Y]+PAXHRO[K]

     ENDIF
 ENDLOOP


 IF (FLAG == 0) 
     NUMOPER=NUMOPER+1
     OPERLIST[NUMOPER]=OPERATOR[K]    
     ODIST[NUMOPER]=DIST[K]
     OTIME[NUMOPER]=TIME[K]
     OPAX[NUMOPER]=PAX[K]
     OPAXMI[NUMOPER]=PAXMI[K]
     OPAXHR[NUMOPER]=PAXHR[K]
     OTIMEO[NUMOPER]=TIMEO[K]
     OPAXO[NUMOPER]=PAXO[K]
     OPAXMIO[NUMOPER]=PAXMIO[K]
     OPAXHRO[NUMOPER]=PAXHRO[K]


 ENDIF
;endif
ENDLOOP

loop ind=1,numoper
    odistsum=odistsum+odist[ind]
    otimesum=otimesum+otime[ind]
    opaxsum=opaxsum+opax[ind]
    opaxmisum=opaxmisum+opaxmi[ind]
    opaxhrsum=opaxhrsum+opaxhr[ind]
    otimeosum=otimeosum+otimeo[ind]
    opaxosum=opaxosum+opaxo[ind]
    opaxmiosum=opaxmiosum+opaxmio[ind]
    opaxhrosum=opaxhrosum+opaxhro[ind]

  endloop

loop k=1,numoper
operlist1[k]=operlist[k]
;print list= k, modelist1[k]
endloop 

loop l=1,numoper
loop m=1,numoper-1
if(operlist1[m+1]<operlist1[m])
tempe=operlist1[m]
operlist1[m]=operlist1[m+1]
;print list="modelist",m,l,nummode,tempe,modelist1[m],modelist1[m+1]
exec=m+1
operlist1[exec]=tempe
endif
endloop
endloop
;*********************************************************************************************************
; END LOOP TO CALCULATE DIST,TIME,PAX,PAXMI,PAXHR FOR PEAK PERIOD BY OPERATOR
;*********************************************************************************************************

;*********************************************************************************************************
; BEGIN LOOP TO CALCULATE CUMDIST,CUMTIME,ON,OFF,LOAD FOR PEAK PERIOD BY STOP
;*********************************************************************************************************
temproute=1



loop k=1,DBI.1.NUMRECORDS/2
 x=DBIReadRecord(1,(2*k-1))


;if(di.1.mode >20)  

              if ( (2*k-1) =1 )


               prevroute=di.1.name
               prevnode=0
               tempdist[k]=di.1.dist
               temptime[k]=di.1.time
               onasum[k]=di.1.ona1+di.1.ona2+di.1.ona3+di.1.ona4
               offasum[k]=di.1.offa1+di.1.offa2+di.1.offa3+di.1.offa4 


   load[k]=di.1.ona1+di.1.ona2+di.1.ona3+di.1.ona4+onarecord[2*k]-
           (di.1.offa1+di.1.offa2+di.1.offa3+offarecord[2*k])
 
           
               rtnumber[k]=temproute
               MAXLD[1]=load[k]
              endif 


  if (prevroute = di.1.name) 

      if(k != 1)
             rtnumber[k]=temproute
             tempdist[k]=tempdist[k-1]+di.1.dist 
             temptime[k]=temptime[k-1]+di.1.time 


             onasum[k]=di.1.ona1+di.1.ona2+di.1.ona3+di.1.ona4+onarecord[2*k]
             offasum[k]=di.1.offa1+di.1.offa2+di.1.offa3+di.1.offa4+offarecord[2*k]

    
         
             load[k]=load[k-1]+onasum[k]-offasum[k]
             node[k]=di.1.a
      endif
     
      IF(maxld[temproute] < load[k]) 
             maxld[temproute]=load[k]
          ENDIF
          

    else
       temproute = temproute + 1
       node[k]=di.1.a
       prevnode=node[k]
       rtnumber[k]=temproute
       prevroute = di.1.name
       tempdist[k]=di.1.dist
       temptime[k]=di.1.time       

 
       onasum[k]=di.1.ona1+di.1.ona2+di.1.ona3+di.1.ona4+onarecord[2*k]
       offasum[k]=di.1.offa1+di.1.offa2+di.1.offa3+di.1.offa4+offarecord[2*k]
 

    
      ;print list=rtnumber[k],routestart[rtnumber[k]],routeend[rtnumber[k]]
       if(routestart[rtnumber[k]]==routeend[rtnumber[k]])
      ; print list="in",rtnumber[k],volrecord[3*k-2],onasum[3*k-2],offasum[3*k-2]

       load[k]=volrecord[2*k-1]+onasum[k]-offasum[k]


       else
       load[k]=onasum[k]-offasum[k];+volrecord[3*k-2]
       endif
       MAXLD[temproute]=load[k]  
  endif

 distan[k]=di.1.dist
 timean[k]=di.1.time
 ;print list=k,rtnumber[k],load[k],maxld[k]

;endif
endloop


;*********************************************************************************************************
; END LOOP TO CALCULATE CUMDIST,CUMTIME,ON,OFF,LOAD FOR PEAK PERIOD BY STOP
;*********************************************************************************************************

;*********************************************************************************************************
; BEGIN LOOP TO CALCULATE CUMDIST,CUMTIME,ON,OFF,LOAD FOR OFF-PEAK PERIOD BY STOP
;*********************************************************************************************************
temprouteo=1



 loop k=1,DBI.2.NUMRECORDS/2
 x=DBIReadRecord(2,(2*k-1))

;if(di.2.mode >20)  

     if ( (2*k-1) =1 ) 


       prevrouteo=di.2.name
       prevnodeo=0
       tempdisto[k]=di.2.dist
       temptimeo[k]=di.2.time
       onasumo[k]=di.2.ona1+di.2.ona2+di.2.ona3+di.2.ona4
       offasumo[k]=di.2.offa1+di.2.offa2+di.2.offa3+di.2.offa4


      loado[k]=di.2.ona1+di.2.ona2+di.2.ona3+di.2.ona4+onarecordo[2*k]-
               (di.2.offa1+di.2.offa2+di.2.offa3+di.2.offa4+offarecordo[2*k])



       rtnumbero[k]=temprouteo
       MAXLDo[1]=loado[k]
     endif 




  if (prevrouteo = di.2.name) 

      if(k != 1)
             rtnumbero[k]=temprouteo
             tempdisto[k]=tempdisto[k-1]+di.2.dist 
             temptimeo[k]=temptimeo[k-1]+di.2.time 


            onasumo[k]=di.2.ona1+di.2.ona2+di.2.ona3+di.2.ona4+onarecordo[2*k]
            offasumo[k]=di.2.offa1+di.2.offa2+di.2.offa3+di.2.offa4+offarecordo[2*k]


             loado[k]=loado[k-1]+onasumo[k]-offasumo[k]
             nodeo[k]=di.2.a
             
      endif

      IF(maxldo[temprouteo] < loado[k]) 
             maxldo[temprouteo]=loado[k]
      ENDIF
         

  else
       temprouteo = temprouteo + 1
       nodeo[k]=di.2.a
       prevnodeo=nodeo[k]
       rtnumbero[k]=temprouteo
       prevrouteo = di.2.name
       tempdisto[k]=di.2.dist
       temptimeo[k]=di.2.time
       

 
      onasumo[k]=di.2.ona1+di.2.ona2+di.2.ona3+di.2.ona4+onarecordo[2*k]
       offasumo[k]=di.2.offa1+di.2.offa2+di.2.offa3+di.2.offa4+offarecordo[2*k]



      loado[k]=volrecordo[k];+onasumo[k]-offasumo[k]

       if(routestart[rtnumbero[k]]==routeend[rtnumbero[k]])
      ; print list="in",rtnumber[k],volrecord[3*k-2],onasum[3*k-2],offasum[3*k-2]

       loado[k]=volrecordo[2*k-1]+onasumo[k]-offasumo[k]

       else
       loado[k]=onasumo[k]-offasumo[k];+volrecord[3*k-2]
       endif
       MAXLDo[temprouteo]=loado[k]  

  endif

 distano[k]=di.2.dist
 timeano[k]=di.2.time
;endif
endloop

;loop k=1,numroute

;*********************************************************************************************************
; END LOOP TO CALCULATE CUMDIST,CUMTIME,ON,OFF,LOAD FOR OFF-PEAK PERIOD BY STOP
;*********************************************************************************************************


;*********************************************************************************************************
;*********************************************************************************************************
; ALL CALCULATIONS COMPLETE. PRINT OUT ALL RESULTS
;*********************************************************************************************************
;*********************************************************************************************************


;*******************************************************************************************
; BEGIN PRINTING ROUTE LEVEL OUTPUT FILE 
;*******************************************************************************************
PRINT LIST= "Transit Assignment Summary Report", printo=2
print list="\n\n",printo=2
print list="Title : ",'{title}',printo=2
print list="Alternative : ",'{alt}',printo=2
print list="Year : ",'{year}',printo=2
print list="\n",printo=2
print list='@date.rundate@', printo=2
print list='@time.runtime@',printo=2
;print list="\n",printo=2
;PRINT LIST= "Transit Assignment Summary Report", printo=2
;print list="Route Level Summary",printo=2
print list="\n\n",printo=2
print list="                                        ",
      list="------------------------ Peak ------------------------"(60.0R),
      list="---------------------- Off-peak ----------------------"(60.2R),
      list="-------------- Daily --------------"(40.0R),printo=2

print list="Route Name "(16.0R),"    ","Mode"(5.0R),"Optr"(5.0R),"Dist"(10.0R),
           "Time"(10.0R),"Freq"(10.0R),"Pax"(10.0R),"MaxLd"(10.0R),"PaxMi"(10.0R),"PaxHr"(10.0R),
           "Time"(10.0R),"Freq"(10.0R),"Pax"(10.0R),"MaxLd"(10.0R),"PaxMi"(10.0R),"PaxHr"(10.0R),
           "Pax"(10.0R),"MaxLd"(10.0R),"PaxMi"(10.0R),"PaxHr"(10.0R),
           "Route LongName                        "(40.0R),
           printo=2
print list="                              ",
           "(mi)"(10.0R),
           "(min)"(10.0R),"(min)"(10.0R)," "(10.0R)," "(10.0R)," "(10.0R)," "(10.0R),
           "(min)"(10.0R),"(min)"(10.0R)," "(10.0R)," "(10.0R)," "(10.0R)," "(10.0R),
           printo=2
           

loop k=1,NUMROUTE
print cform=16.0 list=routename[k],"    ",
      form=5.0 list=mode[k],operator[k],

     form=10.2 list=dist[k]/2,time[k]/2,

      form=10.1 list=freq[k],pax[k],maxld[k],paxmi[k],paxhr[k], 

      form=10.2 list=timeo[k]/2,

      form=10.1 list=freqo[k],paxo[k],maxldo[k],paxmio[k],paxhro[k],pax[k]+paxo[k],maxld[k]+maxldo[k],
                     paxmi[k]+paxmio[k],paxhr[k]+paxhro[k],
      "  ",
      cform=40.0R list=routelname[k],
      printo=2
endloop
  
print list="\n\n\n\n",printo=2

print list="\f",printo=2
print list="Title : ",'{title}',printo=2
print list="Alternative : ",'{alt}',printo=2
print list="Year : ",'{year}',printo=2
print list="\n",printo=2
print list='@date.rundate@', printo=2
print list='@time.runtime@',printo=2
print list="\n",printo=2
;PRINT LIST= "Transit Assignment Summary Report", printo=2
print list="Mode-Level summary"(40.0R),
      printo=2


print list="                                        ",
      list="------------------------ Peak ------------------------"(60.0R),
      list="---------------------- Off-peak ----------------------"(60.2R),
      list="-------------- Daily --------------"(40.0R),printo=2

print list="Route Name "(16.0R),"    ","Mode"(5.0R),"     ","Dist"(10.0R),
           "Time"(10.0R),"Freq"(10.0R),"Pax"(10.0R),"MaxLd"(10.0R),"PaxMi"(10.0R),"PaxHr"(10.0R),
           "Time"(10.0R),"Freq"(10.0R),"Pax"(10.0R),"MaxLd"(10.0R),"PaxMi"(10.0R),"PaxHr"(10.0R),
           "Pax"(10.0R),"MaxLd"(10.0R),"PaxMi"(10.0R),"PaxHr"(10.0R),
           ;"Route LongName                        "(40.0R),
           printo=2
print list="                              ",
           "(mi)"(10.0R),
           "(min)"(10.0R),"(min)"(10.0R)," "(10.0R)," "(10.0R)," "(10.0R)," "(10.0R),
           "(min)"(10.0R),"(min)"(10.0R)," "(10.0R)," "(10.0R)," "(10.0R)," "(10.0R),
           printo=2
 

 
LOOP yY=1,NUMMODE
;if( modelist[y] != 0)
loop y=1,nummode
if(modelist[y]=modelist1[yy])
           PRINT list="Mode"(20.0R),
           form=5.0 list=MODELIST[Y],
           "     ",

        FORM=10.2 LIST=MDIST[Y]/2,
        FORM=10.2 LIST=MTIME[Y]/2, 
 


           "          ",
           fORM=10.1 LIST=MPAX[Y],
           "          ",
           FORM=10.1 LIST=MPAXMI[Y],MPAXHR[Y],
 
       FORM=10.2 LIST=MTIMEO[Y]/2,

           "          ",
           fORM=10.1 LIST=MPAXO[Y],
           "          ",
           FORM=10.1 LIST=MPAXMIO[Y],MPAXHRO[Y],MPAX[Y]+MPAXO[Y],
           "          ",
           FORM=10.1 LIST=MPAXMI[Y]+MPAXMIO[Y],MPAXHR[Y]+MPAXHRO[Y],           
           printo=2
endif
ENDLOOP
endloop
 
      PRINT list="All Modes"(20.0R),
           "     ",
           "     ",

      FORM=10.2 LIST=mdistsum/2,
      FORM=10.2 LIST=MTIMEsum/2,


           "          ",
           fORM=10.1 LIST=MPAXsum,
           "          ",
           FORM=10.1 LIST=MPAXMIsum,MPAXHRsum,

           FORM=10.2 LIST=MTIMEOsum/2,

           "          ",
           fORM=10.1 LIST=MPAXOsum,
           "          ",
           FORM=10.1 LIST=MPAXMIOsum,MPAXHROsum,MPAXsum+MPAXOsum,
           "          ",
           FORM=10.1 LIST=MPAXMIsum+MPAXMIOsum,MPAXHRsum+MPAXHROsum,           
           printo=2


print list="\n\n\n\n",printo=2


print list="\f",printo=2
print list="Title : ",'{title}',printo=2
print list="Alternative : ",'{alt}',printo=2
print list="Year : ",'{year}',printo=2
print list="\n",printo=2
print list='@date.rundate@', printo=2
print list='@time.runtime@',printo=2
print list="\n",printo=2
print list="Operator-Level summary"(40.0R),
      printo=2

print list="                                        ",
      list="------------------------ Peak ------------------------"(60.0R),
      list="---------------------- Off-peak ----------------------"(60.2R),
      list="-------------- Daily --------------"(40.0R),printo=2

print list="Route Name "(16.0R),"    ","Optr"(5.0R),"     ","Dist"(10.0R),
           "Time"(10.0R),"Freq"(10.0R),"Pax"(10.0R),"MaxLd"(10.0R),"PaxMi"(10.0R),"PaxHr"(10.0R),
           "Time"(10.0R),"Freq"(10.0R),"Pax"(10.0R),"MaxLd"(10.0R),"PaxMi"(10.0R),"PaxHr"(10.0R),
           "Pax"(10.0R),"MaxLd"(10.0R),"PaxMi"(10.0R),"PaxHr"(10.0R),
           ;"Route LongName                        "(40.0R),
           printo=2
print list="                              ",
           "(mi)"(10.0R),
           "(min)"(10.0R),"(min)"(10.0R)," "(10.0R)," "(10.0R)," "(10.0R)," "(10.0R),
           "(min)"(10.0R),"(min)"(10.0R)," "(10.0R)," "(10.0R)," "(10.0R)," "(10.0R),
           printo=2
  

LOOP yY=1,NUMoper
;if( modelist[y] != 0)
loop y=1,numoper
if(operlist[y]=operlist1[yy])
;LOOP Y=1,NUMOPER
;if(operlist[y] !=0)
           PRINT list="Operator"(20.0R),
           form=5.0 list=OPERLIST[Y],
           "     ",

       FORM=10.2 LIST=ODIST[Y]/2,
       FORM=10.2 LIST=OTIME[Y]/2,


           "          ",
           fORM=10.1 LIST=OPAX[Y],
           "          ",
           FORM=10.1 LIST=OPAXMI[Y],OPAXHR[Y],

           FORM=10.2 LIST=OTIMEO[Y]/2,

           "          ",
           fORM=10.1 LIST=OPAXO[Y],
           "          ",
           FORM=10.1 LIST=OPAXMIO[Y],OPAXHRO[Y],OPAX[Y]+OPAXO[Y],
           "          ",
           FORM=10.1 LIST=OPAXMI[Y]+OPAXMIO[Y],OPAXHR[Y]+OPAXHRO[Y],           
           printo=2
endif
ENDLOOP
endloop

  PRINT list="All Operators"(20.0R),
           "     ",
           "     ",

      FORM=10.2 LIST=ODISTsum/2,
      FORM=10.2 LIST=OTIMEsum/2,
 

           "          ",
           fORM=10.1 LIST=OPAXsum,
           "          ",
           FORM=10.1 LIST=OPAXMIsum,OPAXHRsum,

           FORM=10.2 LIST=OTIMEOsum/2,


           "          ",
           fORM=10.1 LIST=OPAXOsum,
           "          ",
           FORM=10.1 LIST=OPAXMIOsum,OPAXHROsum,OPAXsum+OPAXOsum,
           "          ",
           FORM=10.1 LIST=OPAXMIsum+OPAXMIOsum,OPAXHRsum+OPAXHROsum,           
           printo=2
;*******************************************************************************************
; ROUTE LEVEL OUTPUT FILE COMPLETE
;*******************************************************************************************


;*******************************************************************************************
; BEGIN PRINTING STOP LEVEL OUTPUT FILE
;*******************************************************************************************
PRINT LIST= "Transit Assignment Route Level Report", printo=1
print list="\n\n",printo=1
print list="Title : ",'{title}',printo=1
print list="Alternative : ",'{alt}',printo=1
print list="Year : ",'{year}',printo=1
print list="\n",printo=1
print list='@date.rundate@', printo=1
print list='@time.runtime@',printo=1
;print list="\n",printo=1
;PRINT LIST= "Transit Assignment Route Level Report", printo=1
;print list="Route Level Report",printo=1
;print list="\n\n",printo=1
;print list="\n",printo=1



  loop k=1,dbi.1.numrecords/2

;if(mode[rtnumber[k]] !=0)
        if (k=1)
           prevrtnum=1
           



           print list="\n\n\n",printo=1
           print list="Route name : ", cform=16.0R list=routename[k],printo=1
           print list="Long name : ",routelname[k],"Mode :",form=3.0 list=mode[k]/1,"     ","Operator :",form=3.0 list=operator[k]/1,"     ",
                      "Peak Freq :",form=6.2 list=freq[k]/1," min  (",form=4.1 list=60/freq[k]," vph)","     ","Off-peak Freq :",form=6.2 list=freqo[k],
                       " min  (",form=4.1 list=60/freqo[k]," vph)",printo=1    
           print list="\n\n",printo=1                  
           print list="                           ","------------------- Peak -------------------"(50.0R),
                      "----------------- Off-peak -----------------"(50.0R),"--------- Daily ---------"(30.0R),printo=1
           print list="Node"(7.0R),"Dist"(10.0R),"CumDist"(10.0R),"Time"(10.0R),"CumTime"(10.0R),"On"(10.0R),"Off"(10.0R),"Load"(10.0R),
                      "Time"(10.0R),"CumTime"(10.0R),"On"(10.0R),"Off"(10.0R),"Load"(10.0R),"On"(10.0R),"Off"(10.0R),"Load"(10.0R),
                      printo=1
           print list="    "(7.0R),"(mi)"(10.0R),"   (mi)"(10.0R),"(min)"(10.0R),"(min)"(10.0R),""(10.0R),""(10.0R),""(10.0R),
                      "(min)"(10.0R),"(min)"(10.0R),""(10.0R),""(10.0R),""(10.0R),""(10.0R),""(10.0R),""(10.0R),
                       printo=1
       endif


  if(rtnumber[k] != prevrtnum)

   if( k!=1)

     print list="\n",printo=1
     print list="Totals"(7.0R),"          ",

           form=10.2 list=dist[rtnumber[k-1]]/2,

           "          ",

           form=10.2 list=time[rtnumber[k-1]]/2,

           "          ",
           form=10.1 list=pax[rtnumber[k-1]],maxld[rtnumber[k-1]],
           "          ",

           form=10.2 list=timeo[rtnumber[k-1]]/2,

           "          ",
           form=10.1 list=paxo[rtnumber[k-1]],maxldo[rtnumber[k-1]],
           "          ",
           form=10.1 list=pax[rtnumber[k-1]]+paxo[rtnumber[k-1]], maxld[rtnumber[k-1]]+maxldo[rtnumber[k-1]],
           printo=1
     print list="\n",printo=1
     print list="Passenger Miles"(27.0R),"                              ",
           form=10.2 list=paxmi[rtnumber[k-1]],
           "          ","                              ",
           form=10.2 list=paxmio[rtnumber[k-1]],"          ",
           form=10.2 list=paxmi[rtnumber[k-1]]+paxmio[rtnumber[k-1]],
           printo=1
    print list="Passenger Hours"(27.0R),"                              ",
           form=10.2 list=paxhr[rtnumber[k-1]],
           "          ","                              ",
           form=10.2 list=paxhro[rtnumber[k-1]],"          ",
           form=10.2 list=paxhr[rtnumber[k-1]]+paxhro[rtnumber[k-1]],
           printo=1  

    if((pax[rtnumber[k-1]]=0) & (paxo[rtnumber[k-1]]=0)) 

           print list="Ave Trip Length (miles)"(27.0R),"                              ",
           form=10.2 list=zero,
           "          ","                              ",
           form=10.2 list=zero,"          ",
           form=10.2 list=zero,
           printo=1  
           print list="Ave Trip Length (minutes)"(27.0R),"                              ",
           form=10.2 list=zero,
           "          ","                              ",
           form=10.2 list=zero,"          ",
           form=10.2 list=zero,
           printo=1 

    elseif((pax[rtnumber[k-1]]=0) &(paxo[rtnumber[k-1]]!=0))

           print list="Ave Trip Length (miles)"(27.0R),"                              ",
           form=10.2 list=zero,
           "          ","                              ",
           form=10.2 list=paxmio[rtnumber[k-1]]/paxo[rtnumber[k-1]],"          ",
           form=10.2 list=(paxmi[rtnumber[k-1]]+paxmio[rtnumber[k-1]])/(pax[rtnumber[k-1]]+paxo[rtnumber[k-1]]),
           printo=1  
           print list="Ave Trip Length (minutes)"(27.0R),"                              ",
           form=10.2 list=zero,
           "          ","                              ",
           form=10.2 list=(paxhro[rtnumber[k-1]]/paxo[rtnumber[k-1]])*60,"          ",
           form=10.2 list=((paxhr[rtnumber[k-1]]+paxhro[rtnumber[k-1]])/(pax[rtnumber[k-1]]+paxo[rtnumber[k-1]]))*60,
           printo=1 

    elseif((pax[rtnumber[k-1]]!=0) &(paxo[rtnumber[k-1]]=0))

           print list="Ave Trip Length (miles)"(27.0R),"                              ",
           form=10.2 list=paxmi[rtnumber[k-1]]/pax[rtnumber[k-1]],
           "          ","                              ",
           form=10.2 list=zero,"          ",
           form=10.2 list=(paxmi[rtnumber[k-1]]+paxmio[rtnumber[k-1]])/(pax[rtnumber[k-1]]+paxo[rtnumber[k-1]]),
           printo=1  
           print list="Ave Trip Length (minutes)"(27.0R),"                              ",
           form=10.2 list=(paxhr[rtnumber[k-1]]/pax[rtnumber[k-1]])*60,
           "          ","                              ",
           form=10.2 list=zero,"          ",
           form=10.2 list=((paxhr[rtnumber[k-1]]+paxhro[rtnumber[k-1]])/(pax[rtnumber[k-1]]+paxo[rtnumber[k-1]]))*60,
           printo=1 

    else

           print list="Ave Trip Length (miles)"(27.0R),"                              ",
           form=10.2 list=paxmi[rtnumber[k-1]]/pax[rtnumber[k-1]],
           "          ","                              ",
           form=10.2 list=paxmio[rtnumber[k-1]]/paxo[rtnumber[k-1]],"          ",
           form=10.2 list=(paxmi[rtnumber[k-1]]+paxmio[rtnumber[k-1]])/(pax[rtnumber[k-1]]+paxo[rtnumber[k-1]]),
           printo=1  
           print list="Ave Trip Length (minutes)"(27.0R),"                              ",
           form=10.2 list=(paxhr[rtnumber[k-1]]/pax[rtnumber[k-1]])*60,
           "          ","                              ",
           form=10.2 list=(paxhro[rtnumber[k-1]]/paxo[rtnumber[k-1]])*60,"          ",
           form=10.2 list=((paxhr[rtnumber[k-1]]+paxhro[rtnumber[k-1]])/(pax[rtnumber[k-1]]+paxo[rtnumber[k-1]]))*60,
           printo=1
    ;endif 
    
   endif
    
   endif
           print list="\f",printo=1
           print list="\n\n\n\n\n",printo=1 
           ;print list="_____________________________________________________",printo=1         
           print list="Title : ",'{title}',printo=1
           print list="Alternative : ",'{alt}',printo=1
           print list="Year : ",'{year}',printo=1
           print list="\n",printo=1
           print list='@date.rundate@', printo=1
           print list='@time.runtime@',printo=1
           print list="\n",printo=1
          
          print list="Route name : ", cform=16.0R list=routename[rtnumber[k]],printo=1
          print list="Long name : ",routelname[rtnumber[k]],"Mode :",form=3.0 list=mode[rtnumber[k]],"     ","Operator :",form=3.0 list=operator[rtnumber[k]],"     ",
                     "Peak Freq :",form=6.2 list=freq[rtnumber[k]]," min  (",form=4.1 list=60/freq[rtnumber[k]]," vph)","     ","Off-peak Freq :",form=6.2 list=freqo[rtnumber[k]],
                     " min  (",form=4.1 list=60/freqo[rtnumber[k]]," vph)",printo=1                      
          print list="                           ","------------------- Peak -------------------"(50.0R),
                     "----------------- Off-peak -----------------"(50.0R),"--------- Daily ---------"(30.0R),
                        printo=1
          print list="Node"(7.0R),"Dist"(10.0R),"CumDist"(10.0R),"Time"(10.0R),"CumTime"(10.0R),"On"(10.0R),"Off"(10.0R),"Load"(10.0R),
                      "Time"(10.0R),"CumTime"(10.0R),"On"(10.0R),"Off"(10.0R),"Load"(10.0R),"On"(10.0R),"Off"(10.0R),"Load"(10.0R),
                        printo=1
          print list="    "(7.0R),"(mi)"(10.0R),"   (mi)"(10.0R),"(min)"(10.0R),"(min)"(10.0R),""(10.0R),""(10.0R),""(10.0R),
                     "(min)"(10.0R),"(min)"(10.0R),""(10.0R),""(10.0R),""(10.0R),""(10.0R),""(10.0R),""(10.0R),
                       printo=1
  endif


     print form=7.0 list=node[k],
           form=10.2 list=distan[k],tempdist[k],timean[k],temptime[k],
           form=10.1 list=onasum[k],offasum[k],load[k],
           form=10.2 list=timeano[k],temptimeo[k],
           form=10.2 list=onasumo[k],offasumo[k],loado[k],
                          onasum[k]+onasumo[k],offasum[k]+offasumo[k],load[k]+loado[k],
                          printo=1

;print list= tempdist[k],(dist[rtnumber[k]])/3,k
 
     FORM=10.2 LIST=OTIMEOsum/2,
    
     
   

           prevrtnum=rtnumber[k]
;endif
endloop


;*******************************************************************************************
; END PRINTING STOP LEVEL OUTPUT FILE
;*******************************************************************************************

;*******************************************************************************************
; REACHED END OF SCRIPT
;*******************************************************************************************

; The MATRIX module does not have any explicit phases.  The module does run within an implied ILOOP
; where I is the origin zones.  All user statements in the module are processed once for each origin.
; Matrix computation (MW[#]=) are solved for all values of J for each I.  Thus for a given origin zone I
; the values for all destination zones J are automatically computed.  The user can control the computations
; at each J by using a JLOOP.

ENDRUN
