; Do not change filenames or add or remove FILEI/FILEO statements using an editor. Use Cube/Application Manager.
RUN PGM=NETWORK PRNFILE="{SCENARIO_DIR}\output\TPNET00C.PRN" MSG='Transit speed for peak period'
FILEI LINKI[1] = "{SCENARIO_DIR}\output\PREASSGN_{alt}{year}.NET"
FILEI LOOKUPI[1] = "{CATALOG_DIR}\Base\TSPDPK.CSV"
FILEO NETO = "{SCENARIO_DIR}\output\PRELOAD2_{Alt}{Year}.NET"

PROCESS PHASE=LINKMERGE

  ;If auto travel time is not present or is zero, a default value of 15 mph is used.
  IF (TIME_1>0)
    _AUTOSPEED=60*DISTANCE/TIME_1
  ELSE
    _AUTOSPEED=15
  ENDIF

;**************************************************************
;BEGIN POTENTIAL SCRIPT ADJUSTMENT
;**************************************************************

;************************************************************************************************
;* DEFAULT TRANSIT SPEEDS SET EQUAL TO AUTO SPEEDS. APPLY APPROPRIATE TRANSIT SPEED CURVES HERE.*
;************************************************************************************************

 IF (_AUTOSPEED>0)
      _TSPD21=_AUTOSPEED  ; bus speeds
      _TSPD22=_AUTOSPEED  ;
      _TSPD23=_AUTOSPEED  ;
      _TSPD24=_AUTOSPEED  ;
      _TSPD25=_AUTOSPEED  ;
      _TSPD26=_AUTOSPEED  ;
      _TSPD27=_AUTOSPEED  ;
      _TSPD31=_AUTOSPEED  ; bus speeds
      _TSPD32=_AUTOSPEED  ;
      _TSPD33=_AUTOSPEED  ;
      _TSPD34=_AUTOSPEED  ;
      _TSPD35=_AUTOSPEED  ;
      _TSPD36=_AUTOSPEED  ;
      _TSPD37=_AUTOSPEED  ;

      M21TIMEPK=60*DISTANCE/_AUTOSPEED
      M22TIMEPK=60*DISTANCE/_AUTOSPEED
      M23TIMEPK=60*DISTANCE/_AUTOSPEED
      M24TIMEPK=60*DISTANCE/_AUTOSPEED
      M25TIMEPK=60*DISTANCE/_AUTOSPEED
      M26TIMEPK=60*DISTANCE/_AUTOSPEED
      M27TIMEPK=60*DISTANCE/_AUTOSPEED
      M31TIMEPK=60*DISTANCE/_AUTOSPEED
      M32TIMEPK=60*DISTANCE/_AUTOSPEED
      M33TIMEPK=60*DISTANCE/_AUTOSPEED
      M34TIMEPK=60*DISTANCE/_AUTOSPEED
      M35TIMEPK=60*DISTANCE/_AUTOSPEED
      M36TIMEPK=60*DISTANCE/_AUTOSPEED
      M37TIMEPK=60*DISTANCE/_AUTOSPEED

 ENDIF

;**************************************************************
;END POTENTIAL SCRIPT ADJUSTMENT
;**************************************************************
      ; Bus time overrides
 IF   (TBSSPEED>0 && TBSTIME==0) TBSTIME = (DISTANCE/TBSSPEED)*60.0
 IF   (TBSTIME>0)
       M21TIMEPK=TBSTIME
       M22TIMEPK=TBSTIME
       M23TIMEPK=TBSTIME
 ENDIF

 ; Fixed-guideway time overrides
 IF (TFGSPEED>0 && TFGTIME==0) TFGTIME = (DISTANCE/TFGSPEED)*60.0
 IF (TFGTIME>0&&TFGMODE=21) M21TIMEPK=TFGTIME
 IF (TFGTIME>0&&TFGMODE=22) M22TIMEPK=TFGTIME
 IF (TFGTIME>0&&TFGMODE=23) M23TIMEPK=TFGTIME
 IF (TFGTIME>0&&TFGMODE=24) M24TIMEPK=TFGTIME
 IF (TFGTIME>0&&TFGMODE=25) M25TIMEPK=TFGTIME
 IF (TFGTIME>0&&TFGMODE=26) M26TIMEPK=TFGTIME
 IF (TFGTIME>0&&TFGMODE=27) M27TIMEPK=TFGTIME
 IF (TFGTIME>0&&TFGMODE=31) M31TIMEPK=TFGTIME
 IF (TFGTIME>0&&TFGMODE=32) M32TIMEPK=TFGTIME
 IF (TFGTIME>0&&TFGMODE=33) M33TIMEPK=TFGTIME
 IF (TFGTIME>0&&TFGMODE=34) M34TIMEPK=TFGTIME
 IF (TFGTIME>0&&TFGMODE=35) M35TIMEPK=TFGTIME
 IF (TFGTIME>0&&TFGMODE=36) M36TIMEPK=TFGTIME
 IF (TFGTIME>0&&TFGMODE=37) M37TIMEPK=TFGTIME

      ; WALK CONTROLS
      WALKTIME=60*DISTANCE/{AVGWLKSPD}
      ADJDISTANCE=DISTANCE
 IF (FTYPE=10-19,70-99)
      WALKTIME=999.99
 ENDIF
 IF (FTYPE=59)
; this sets a default distance and time on the escalator links
; modify this part of the script to change the defaults
      WALKTIME=1
      DISTANCE=0.05
      ADJDISTANCE=DISTANCE
 ENDIF

 IF((A={FromNode}) && (B={ToNode}))

      list="\n\n"
      list="     An     Bn   Dist   ASpd   Atim   TSpd   Ttim    Crv"
      list=A(7.0),B(7.0),DISTANCE(7.2),_AUTOSPEED(7.2),TIME_1(7.2),_TSPD21(7.2),M21TIMEPK(7.2),_CURVEMODE21(7.0)," MODE21"
      list=A(7.0),B(7.0),DISTANCE(7.2),_AUTOSPEED(7.2),TIME_1(7.2),_TSPD22(7.2),M22TIMEPK(7.2),_CURVEMODE22(7.0)," MODE22"
      list=A(7.0),B(7.0),DISTANCE(7.2),_AUTOSPEED(7.2),TIME_1(7.2),_TSPD23(7.2),M23TIMEPK(7.2),_CURVEMODE23(7.0)," MODE23"
      list=A(7.0),B(7.0),DISTANCE(7.2),_AUTOSPEED(7.2),TIME_1(7.2),_TSPD24(7.2),M24TIMEPK(7.2),_CURVEMODE24(7.0)," MODE24"
      list=A(7.0),B(7.0),DISTANCE(7.2),_AUTOSPEED(7.2),TIME_1(7.2),_TSPD25(7.2),M25TIMEPK(7.2),_CURVEMODE25(7.0)," MODE25"
      list=A(7.0),B(7.0),DISTANCE(7.2),_AUTOSPEED(7.2),TIME_1(7.2),_TSPD26(7.2),M26TIMEPK(7.2),_CURVEMODE26(7.0)," MODE26"
      list=A(7.0),B(7.0),DISTANCE(7.2),_AUTOSPEED(7.2),TIME_1(7.2),_TSPD27(7.2),M27TIMEPK(7.2),_CURVEMODE27(7.0)," MODE27"
      list="\n\n"
 ENDIF

 ENDPROCESS

ENDRUN
