; Do not change filenames or add or remove FILEI/FILEO statements using an editor. Use Cube/Application Manager.
RUN PGM=MATRIX PRNFILE="C:\CopyofTransitModel\APPLICATIONS\TSMAT00F.PRN" MSG='Create auto-access vehicle trip table'

FILEI MATI[5] = "{SCENARIO_DIR}\output\STATIONOP2_{alt}{year}.DBF",
PATTERN=IJ:V, FIELDS=I,J,FROMNODE




FILEI MATI[2] = "{SCENARIO_DIR}\output\STATIONPK2_{alt}{year}.DBF",
PATTERN=IJ:V, FIELDS=I,J,FROMNODE


FILEI MATI[4] = "{SCENARIO_DIR}\output\tloadmd_{alt}{year}.mat"
FILEI LOOKUPI[1] = "{SCENARIO_DIR}\Output\STATION_{alt}{YEAR}.DAT"
FILEO RECO[1] = "{SCENARIO_DIR}\output\TTAAPK_{alt}{year}.DBF",
FIELDS=I,J,M,AutoBus,AutoProj

FILEO RECO[2] = "{SCENARIO_DIR}\output\TTAAOP_{alt}{year}.DBF",
FIELDS=I,J,M,AutoBus,AutoProj

FILEI MATI[1] = "{SCENARIO_DIR}\output\tloadam_{alt}{year}.mat"
  
DistributeINTRAStep ProcessID="CFRPMdist" ProcessList=1-4

PARAMETERS ZONEMSG=100

ARRAY buspk={ZONES} prjpk={ZONES} busop={ZONES} prjop={ZONES}

FILLMW MW[11]=MI.1.3,4
FILLMW MW[21]=MI.2.1
FILLMW MW[31]=MI.3.1
FILLMW MW[41]=MI.4.3,4
FILLMW MW[51]=MI.5.1
FILLMW MW[61]=MI.6.1

LOOKUP NAME=NearestZone,
   LOOKUP[1]=2, RESULT=3,
   INTERPOLATE=N, FAIL=0,0,0,
   LIST=T, LOOKUPI=1

LOOP x=1,{ZONES}
  buspk[x]=0, prjpk[x]=0
  busop[x]=0, prjop[x]=0
ENDLOOP

JLOOP
  IF (MW[11]>0)
    _statj=NearestZone(1,MW[21])
    IF (_statj>0) buspk[_statj] = buspk[_statj] + MW[11]
  ENDIF
  IF (MW[12]>0)
    _statj=NearestZone(1,MW[31])
    IF (_statj>0) buspk[_statj] = buspk[_statj] + MW[12]
  ENDIF
  IF (MW[41]>0)
    _statj=NearestZone(1,MW[51])
    IF (_statj>0) busop[_statj] = busop[_statj] + MW[41]
  ENDIF
  IF (MW[42]>0)
    _statj=NearestZone(1,MW[61])
    IF (_statj>0) busop[_statj] = busop[_statj] + MW[42]
  ENDIF
ENDJLOOP

LOOP x=1,{ZONES}
  IF (buspk[x]>0 || prjpk[x]>0)
    RO.I = I
    RO.J = x
    RO.AutoBus  = buspk[x] / {OCTA}
    RO.AutoProj = prjpk[x] / {OCTA}
    WRITE RECO=1
  ENDIF
  IF (busop[x]>0 || prjop[x]>0)
    RO.I = I
    RO.J = x
    RO.AutoBus  = busop[x] / {OCTA}
    RO.AutoProj = prjop[x] / {OCTA}
    WRITE RECO=2
  ENDIF
ENDLOOP


ENDRUN
