; Script for program NETWORK in file "C:\TransitModelTierA_Delivery\APPLICATIONS\TPNET00C.S"

; Do not change filenames or add or remove FILEI/FILEO statements using an editor. Use Cube/Application Manager.
RUN PGM=NETWORK PRNFILE="C:\TransitModelTierA_Delivery\APPLICATIONS\TPNET00C.PRN" MSG='Transit speed for peak period'
FILEI LINKI[1] = "{SCENARIO_DIR}\output\HWYLOAD_{Alt}{Year}.NET"
FILEI LOOKUPI[1] = "{CATALOG_DIR}\Base\TSPDPK.CSV"
FILEO NETO = "{SCENARIO_DIR}\output\HWYLOAD2_{Alt}{Year}.NET"

PROCESS PHASE=LINKMERGE

  ;If auto travel time is not present or is zero, a default value of 15 mph is used.
  IF (TIME_1>0)
    _AUTOSPEED=60*DISTANCE/TIME_1
  ELSE
    _AUTOSPEED=15
  ENDIF


;**************************************************************
;BEGIN POTENTIAL SCRIPT ADJUSTMENT
;**************************************************************

;************************************************************************************************
;* DEFAULT TRANSIT SPEEDS SET EQUAL TO AUTO SPEEDS. APPLY APPROPRIATE TRANSIT SPEED CURVES HERE.*
;************************************************************************************************

 IF (_AUTOSPEED>0)
      _TSPD21=_AUTOSPEED  ; bus speeds
      _TSPD22=_AUTOSPEED  ;
      _TSPD23=_AUTOSPEED  ;
      _TSPD24=_AUTOSPEED  ;
      _TSPD25=_AUTOSPEED  ;
      _TSPD26=_AUTOSPEED  ; 
      _TSPD27=_AUTOSPEED  ;

      M21TIMEPK=60*DISTANCE/_AUTOSPEED
      M22TIMEPK=60*DISTANCE/_AUTOSPEED
      M23TIMEPK=60*DISTANCE/_AUTOSPEED
      M24TIMEPK=60*DISTANCE/_AUTOSPEED
      M25TIMEPK=60*DISTANCE/_AUTOSPEED
      M26TIMEPK=60*DISTANCE/_AUTOSPEED
      M27TIMEPK=60*DISTANCE/_AUTOSPEED

 ENDIF

;**************************************************************
;END POTENTIAL SCRIPT ADJUSTMENT
;**************************************************************
      ; Bus time overrides
 IF   (TBSSPEED>0 && TBSTIME==0) TBSTIME = (DISTANCE/TBSSPEED)*60.0
 IF   (TBSTIME>0)
       M21TIMEPK=TBSTIME
       M22TIMEPK=TBSTIME
       M23TIMEPK=TBSTIME
 ENDIF

 ; Fixed-guideway time overrides
 IF (TFGSPEED>0 && TFGTIME==0) TFGTIME = (DISTANCE/TFGSPEED)*60.0
 IF (TFGTIME>0&&TFGMODE=21) M21TIMEPK=TFGTIME
 IF (TFGTIME>0&&TFGMODE=22) M22TIMEPK=TFGTIME
 IF (TFGTIME>0&&TFGMODE=23) M23TIMEPK=TFGTIME
 IF (TFGTIME>0&&TFGMODE=24) M24TIMEPK=TFGTIME
 IF (TFGTIME>0&&TFGMODE=25) M25TIMEPK=TFGTIME
 IF (TFGTIME>0&&TFGMODE=26) M26TIMEPK=TFGTIME
 IF (TFGTIME>0&&TFGMODE=27) M27TIMEPK=TFGTIME
 
      ; WALK CONTROLS
      WALKTIME=60*DISTANCE/{AVGWLKSPD}
 IF (FACILITY_TYPE=10-19,70-99)
      WALKTIME=999.99
 ENDIF
 IF (FACILITY_TYPE=59)
      WALKTIME=1
      DISTANCE=0.05
      ADJDISTANCE=DISTANCE
 ENDIF

 IF((A={FromNode}) && (B={ToNode}))

      list="\n\n"
      list="     An     Bn   Dist   ASpd   Atim   TSpd   Ttim    Crv"
      list=A(7.0),B(7.0),DISTANCE(7.2),_AUTOSPEED(7.2),TIME_1(7.2),_TSPD21(7.2),M21TIMEPK(7.2),_CURVEMODE21(7.0)," MODE21"
      list=A(7.0),B(7.0),DISTANCE(7.2),_AUTOSPEED(7.2),TIME_1(7.2),_TSPD22(7.2),M22TIMEPK(7.2),_CURVEMODE22(7.0)," MODE22"
      list=A(7.0),B(7.0),DISTANCE(7.2),_AUTOSPEED(7.2),TIME_1(7.2),_TSPD23(7.2),M23TIMEPK(7.2),_CURVEMODE23(7.0)," MODE23"
      list=A(7.0),B(7.0),DISTANCE(7.2),_AUTOSPEED(7.2),TIME_1(7.2),_TSPD24(7.2),M24TIMEPK(7.2),_CURVEMODE24(7.0)," MODE24"
      list=A(7.0),B(7.0),DISTANCE(7.2),_AUTOSPEED(7.2),TIME_1(7.2),_TSPD25(7.2),M25TIMEPK(7.2),_CURVEMODE25(7.0)," MODE25"
      list=A(7.0),B(7.0),DISTANCE(7.2),_AUTOSPEED(7.2),TIME_1(7.2),_TSPD26(7.2),M26TIMEPK(7.2),_CURVEMODE26(7.0)," MODE26"
      list=A(7.0),B(7.0),DISTANCE(7.2),_AUTOSPEED(7.2),TIME_1(7.2),_TSPD27(7.2),M27TIMEPK(7.2),_CURVEMODE27(7.0)," MODE27"
      list="\n\n"
 ENDIF

 ENDPROCESS

ENDRUN


