; Do not change filenames or add or remove FILEI/FILEO statements using an editor. Use Cube/Application Manager.
RUN PGM=MATRIX PRNFILE="{SCENARIO_DIR}\output\MCMAT00A3.PRN" MSG='Preparation for mode choice model'
FILEI ZDATI[3] = "{SCENARIO_DIR}\output\ZONESAT.DAT",
Z=1-10,A1=11-20
FILEI LOOKUPI[1] = "{SCENARIO_DIR}\input\TERMTIME.CSV"
FILEI ZDATI[2] = "{SCENARIO_DIR}\output\PCWALK_{alt}{year}.DAT",
Z=1-5,A1=6-11,A2=12-17,A3=18-23,A4=24-29
FILEI ZDATI[1] = "{SCENARIO_DIR}\input\ZDATA_{year}{alt}.DBF"
FILEO RECO[1] = "{SCENARIO_DIR}\output\TAZDATA_{alt}{year}.DBF",
   FIELDS= TAZ,DESCR,SFDU,SFSEAS,SFVAC,SFPOP,SF0CAR,SF1CAR,SF2CAR,SF3CAR,MFDU,MFSEAS,
           MFVAC,MFPOP,MF0CAR,MF1CAR,MF2CAR,MF3CAR,HMUNITS,HMPCTOCC,HMPOP,EMPMFG,EMPIND,EMPCOM,EMPSVC,EMPTOT,SCHENR,STPKCST,LTPKCST,
           PCWPRDPK,PCWATTPK,PCWPRDOP,PCWATTOP,AREA_TYPE,CBD_DUMMY,EXU_DUMMY,TERMTIME,PERCAUTO0,PERCAUTO1,PERCAUTO2

PAR ZONES={ZONESI} ZONEMSG=100


LOOKUP, NAME=TERM, LOOKUP[1]=1, RESULT=2, INTERPOLATE=N, LOOKUPI=1, FAIL=0

RO.TAZ=ZI.1.TAZ
RO.DESCR=ZI.1.DESCRIPTIO
RO.SFDU=ZI.1.SFDU
RO.SFSEAS=ZI.1.SFSEAS
RO.SFVAC=ZI.1.SFVAC
RO.SFPOP=ZI.1.SFPOP 
RO.SF0CAR=ZI.1.SF0CAR
RO.SF1CAR=ZI.1.SF1CAR
RO.SF2CAR=ZI.1.SF2CAR
RO.SF3CAR=ZI.1.SF3CAR
RO.MFDU=ZI.1.MFDU
RO.MFSEAS=ZI.1.MFSEAS
RO.MFVAC=ZI.1.MFVAC
RO.MFPOP=ZI.1.MFPOP
RO.MF0CAR=ZI.1.MF0CAR
RO.MF1CAR=ZI.1.MF1CAR
RO.MF2CAR=ZI.1.MF2CAR
RO.MF3CAR=ZI.1.MF3CAR
RO.HMUNITS=ZI.1.HMUNITS
RO.HMPCTOCC=ZI.1.HMPCTOCC
RO.HMPOP=ZI.1.HMPOP
RO.EMPMFG=ZI.1.EMPMFG
RO.EMPIND=ZI.1.EMPIND
RO.EMPCOM=ZI.1.EMPCOM
RO.EMPSVC=ZI.1.EMPSVC
RO.EMPTOT=ZI.1.EMPTOT
RO.SCHENR=ZI.1.SCHENR
RO.STPKCST=ZI.1.STPKCST
RO.LTPKCST=ZI.1.LTPKCST

RO.PCWPRDPK=ZI.2.A1   ; percent walk at production end for peak period
RO.PCWATTPK=ZI.2.A2
RO.PCWPRDOP=ZI.2.A3
RO.PCWATTOP=ZI.2.A4

RO.AREA_TYPE=ZI.3.A1
RO.TERMTIME=TERM(1,ZI.3.A1)

CBD_DUMMY=0
EXU_DUMMY=0
; define CBD zones for mode chocie
if (ZI.3.A1>10 & ZI.3.A1<20) CBD_DUMMY=1
; define EXURBAN zones for mode choice
if (ZI.3.A1>40 & ZI.3.A1<50) EXU_DUMMY=1


; Percent 0car, 1 car and 2+car percentages 
_pop1car = (ZI.1.SFPOP * ZI.1.SF1CAR * 0.01) + (ZI.1.MFPOP * ZI.1.MF1CAR * 0.01)
_pop2car = (ZI.1.SFPOP * (ZI.1.SF2CAR + ZI.1.SF3CAR) * 0.01) + (ZI.1.MFPOP * (ZI.1.MF2CAR + ZI.1.MF3CAR) * 0.01) 
_pop0car = (ZI.1.SFPOP + ZI.1.MFPOP - _pop1car - _pop2car)

if (_pop0car < -0.01) print list=" ************** Error in calculating 2 car population. *********", I(5.0),_pop0car(10.2),_pop1car(10.2),_pop2car(10.2)

_poptot = _pop0car + _pop1car + _pop2car


if (_poptot > 0) then
 PERCAUTO0 = _pop0car/_poptot
 PERCAUTO1 = _pop1car/_poptot
 PERCAUTO2 = _pop2car/_poptot
else
 PERCAUTO0 = 1.00  ; set 100% to the 0 car
 PERCAUTO1 = 0
 PERCAUTO2 = 0
endif

WRITE RECO=1

ENDRUN
