; PILOT Script



*echo Date: %date% >"{SCENARIO_DIR}\output\ModelRun_{alt}{year}.prn"
*echo Time: %time% >>"{SCENARIO_DIR}\output\ModelRun_{alt}{year}.prn"
*echo NERPM Model Run - {SCENARIO_FULLNAME}>>"{SCENARIO_DIR}\output\ModelRun_{alt}{year}.prn"
*echo Input Directory {SCENARIO_DIR}\input >>"{SCENARIO_DIR}\output\ModelRun_{alt}{year}.prn"
*echo ======================================================================================>>"{SCENARIO_DIR}\output\ModelRun_{alt}{year}.prn"

*del "{SCENARIO_DIR}\output\ModeDebug.TXT"
*del "{SCENARIO_DIR}\output\ModeSum.TXT"
*del "{SCENARIO_DIR}\output\CalibSum.TXT"
*del "{SCENARIO_DIR}\output\modeshares.csv"
*del "{SCENARIO_DIR}\output\NEW_MCCONSTS.CSV"
*del "{SCENARIO_DIR}\output\CBDSHARES.CSV"
; End of PILOT Script

; Script for program MATRIX in file "D:\Data\FDOT\TransitApp\TransitModelTierBC_Delivery\APPLICATIONS\MCMAT00C.S"
; Do not change filenames or add or remove FILEI/FILEO statements using an editor. Use Cube/Application Manager.
RUN PGM=MATRIX MSG='store time and date'
FILEI RECI = "{SCENARIO_DIR}\output\ModelRun_{alt}{year}.prn"

zones={ZONESA}

s1=strpos('Date:',reci)
s2=strpos('Time:',reci)

; get the date and time
IF (s1 > 0)
 rundate=substr(reci,s1,80)
 log prefix=date var=rundate
ENDIF
IF (s2 > 0) 
 runtime=substr(reci,s2,80)
 log prefix=time var=runtime
ENDIF

ENDRUN


RUN PGM="C:\Program Files\Citilabs\Cube\TRCOPY.bat" PARAMETERS='"{CATALOG_DIR}\parameters\MC_CONSTANTS.DBF" "{SCENARIO_DIR}\output\MC_CONSTANTS.DBF" '
ENDRUN

RUN PGM="C:\Program Files\Citilabs\Cube\TRCOPY.bat" PARAMETERS='"{CATALOG_DIR}\parameters\TRN_COEFFICIENTS.DBF" "{SCENARIO_DIR}\output\TRN_COEFFICIENTS.DBF" '
ENDRUN

; Script for program MATRIX in file "D:\Data\FDOT\TransitApp\TransitModelTierBC_Delivery\APPLICATIONS\MCPREP.S"

; Do not change filenames or add or remove FILEI/FILEO statements using an editor. Use Cube/Application Manager.
RUN PGM=MATRIX PRNFILE="{SCENARIO_DIR}\output\MCMAT00B.PRN" MSG='Auto ownership %age by TAZ'
FILEI ZDATI[2] = "{SCENARIO_DIR}\input\ZDATA2_{year}{alt}.DBF"
FILEO RECO[1] = "{SCENARIO_DIR}\output\A1DECK1.DBF",
fields=taz(4.0),ltp(4.0),stp(4.0),wksh0(4.0),wksh1(4.0),wksh2(4.0),nwsh0(4.0),nwsh1(4.0),nwsh2(4.0)
FILEI LOOKUPI[2] = "{SCENARIO_DIR}\output\DUWEIGHT_LKP.DBF"
FILEI LOOKUPI[1] = "{SCENARIO_DIR}\output\GRATE01_LKP.DBF"
FILEI ZDATI[1] = "{SCENARIO_DIR}\input\ZDATA1_{year}{alt}.DBF"

PARAMETERS ZONEMSG=100 ZONES={ZONESA}

ARRAY DRANGE=16, SFDUM1=5, SFDUM2=5, SFDUM3=5, MFDUM1=5, MFDUM2=5, MFDUM3=5, HMDUM=5, SFTOT=3, MFTOT=3, TERM=5

_seli={SelOrigin}

LOOKUP LOOKUPI=1,
       NAME=RATES1,
         LOOKUP[1]=COUNTER, RESULT=PPDU,
         LOOKUP[2]=COUNTER, RESULT=APDU,
         LOOKUP[3]=COUNTER, RESULT=DUTYPE,
         LOOKUP[4]=COUNTER, RESULT=HBWPR,
         LOOKUP[5]=COUNTER, RESULT=HBSHPR,
         LOOKUP[6]=COUNTER, RESULT=HBSRPR,
         LOOKUP[7]=COUNTER, RESULT=HBOPR,
       FAIL[1]=0,FAIL[2]=0,FAIL[3]=0
; example of use: v=RATES(7,25)
; look for 25 in the COUNTER field and returns the HBOPR value

LOOKUP LOOKUPI=2,
       NAME=DSHARE,
         LOOKUP[1]=CATEGORY, RESULT=HH1,
         LOOKUP[2]=CATEGORY, RESULT=HH2,
         LOOKUP[3]=CATEGORY, RESULT=HH3,
         LOOKUP[4]=CATEGORY, RESULT=HH4,
         LOOKUP[5]=CATEGORY, RESULT=HH5,
       FAIL[1]=0,FAIL[2]=0,FAIL[3]=0
; example of use: v=DUWEIGHT(5,25)
; look for 25 in the CATEGORY field and returns the HH5 value

;**************************************************************
;BEGIN POTENTIAL SCRIPT ADJUSTMENT
;**************************************************************


;LOOKUP LOOKUPI=3,
;       NAME=TYPE,
;         LOOKUP[4]=1, RESULT=5,         ; Two-digit area type
;         LOOKUP[5]=1, RESULT=6,         ; County
;         LOOKUP[6]=1, RESULT=7,         ; MPO
;       FAIL[1]=0,FAIL[2]=0,FAIL[3]=0


;LOOKUP LOOKUPI=4,
;       NAME=RATES2,
;         LOOKUP[1]=COUNTER, RESULT=PPDU,
;         LOOKUP[2]=COUNTER, RESULT=APDU,
;         LOOKUP[3]=COUNTER, RESULT=DUTYPE,
;         LOOKUP[4]=COUNTER, RESULT=HBWPR,
;         LOOKUP[5]=COUNTER, RESULT=HBSHPR,
;         LOOKUP[6]=COUNTER, RESULT=HBSRPR,
;         LOOKUP[7]=COUNTER, RESULT=HBOPR,
;       FAIL[1]=0,FAIL[2]=0,FAIL[3]=0

;LOOKUP LOOKUPI=5,
;       NAME=RATES3,
;         LOOKUP[1]=COUNTER, RESULT=PPDU,
;         LOOKUP[2]=COUNTER, RESULT=APDU,
;         LOOKUP[3]=COUNTER, RESULT=DUTYPE,
;         LOOKUP[4]=COUNTER, RESULT=HBWPR,
;         LOOKUP[5]=COUNTER, RESULT=HBSHPR,
;         LOOKUP[6]=COUNTER, RESULT=HBSRPR,
;         LOOKUP[7]=COUNTER, RESULT=HBOPR,
;       FAIL[1]=0,FAIL[2]=0,FAIL[3]=0

; Initialize DRANGE (DUWEIGHT categories) & TERM (terminal times by areatype)
DRANGE[1]=1.125
DRANGE[2]=1.375
DRANGE[3]=1.625
DRANGE[4]=1.875
DRANGE[5]=2.125
DRANGE[6]=2.375
DRANGE[7]=2.625
DRANGE[8]=2.875
DRANGE[9]=3.125
DRANGE[10]=3.375
DRANGE[11]=3.625
DRANGE[12]=3.875
DRANGE[13]=4.125
DRANGE[14]=4.375
DRANGE[15]=4.625
DRANGE[16]=5.995

; Initialize arrays & temporary variables here
LOOP x=1,5
  SFDUM1[x]=0, SFDUM2[x]=0, SFDUM3[x]=0
  MFDUM1[x]=0, MFDUM2[x]=0, MFDUM3[x]=0
ENDLOOP

LOOP x=1,3
  SFTOT[x]=0, MFTOT[x]=0
ENDLOOP

_xdum=0, _SFPPDU=0, _MFPPDU=0, _HMPPDU=0
_tmp=0, _HMTRIP=0, _HMTOT=0
_SFTRIP1=0, _SFTRIP2=0, _SFTRIP3=0
_MFTRIP1=0, _MFTRIP2=0, _MFTRIP3=0
_WKA0=0, _WKA1=0, _WKA2=0, _WKTOT=0
_NWA0=0, _NWA1=0, _NWA2=0, _NWTOT=0
_WKSHA0=0, _WKSHA1=0, _WKSHA2=0, _WKSHT=0
_NWSHA0=0, _NWSHA1=0, _NWSHA2=0, _NWSHT=0
_at=0, _area=0
_SFIDX = 1, _MFIDX=1, _HMIDX=1

; Calculations
_xdum = ZI.1.SFDU * (1.0 - 0.01*ZI.1.SF_PCTVNP)
IF (_xdum > 0) _SFPPDU = 1.0 * ZI.1.SFPOP/_xdum
_xdum = ZI.1.MFDU * (1.0 - 0.01*ZI.1.MF_PCTVNP)
IF (_xdum > 0) _MFPPDU = 1.0 * ZI.1.MFPOP/_xdum
_xdum = ZI.1.HMDU * (0.01*ZI.1.HMOCC)
IF (_xdum > 0) _HMPPDU = 1.0 * ZI.1.HMPOP/_xdum

; Debug
IF (I==_seli) LIST="2077 SFDU  ",ZI.1.SFDU(7.0)," SF_PCTVAC1 ",ZI.1.SF_SEAS(4.0)," SF_PCTVAC2 ",ZI.1.SF_PCTVAC(4.0)," SFPOP ",ZI.1.SFPOP
IF (I==_seli) LIST="2077 MFDU  ",ZI.1.MFDU(7.0)," MF_PCTVAC1 ",ZI.1.MF_SEAS(4.0)," MF_PCTVAC2 ",ZI.1.MF_PCTVAC(4.0)," MFPOP ",ZI.1.MFPOP
IF (I==_seli) LIST="2077 HMDU  ",ZI.1.HMDU(7.0)," HMOCC  ",ZI.1.HMOCC(4.0), " HMPOP  ",ZI.1.HMPOP(4.0)
IF (I==_seli) LIST="2077 SFPPDU",_SFPPDU(7.2)," MFPPDU ",_MFPPDU(7.2)," HMPPDU ",_HMPPDU(7.2)

; Find correct DUWEIGHT CATEGORY
LOOP x=1,16
  IF (_SFPPDU > DRANGE[x]) _SFIDX=x+1
  IF (_MFPPDU > DRANGE[x]) _MFIDX=x+1
  IF (_HMPPDU > DRANGE[x]) _HMIDX=x+1
ENDLOOP

; Debug
IF (I==_seli) LIST="2077 SFIDX",_SFIDX(3.0)," MFIDX ",_MFIDX(3.0)," HMIDX ",_HMIDX(3.0)

; Main computations
LOOP x=1,5
  HMDUM[x]=1.0*ZI.1.HMDU*0.01*ZI.1.HMOCC*DSHARE(x,_HMIDX)
  SFDUM1[x]=0.01*ZI.1.SFDU*(1.0-0.01*SF_PCTVAC)*ZI.1.SF_0AUTO*DSHARE(x,_SFIDX)
  SFDUM2[x]=0.01*ZI.1.SFDU*(1.0-0.01*SF_PCTVAC)*ZI.1.SF_1AUTO*DSHARE(x,_SFIDX)
  SFDUM3[x]=0.01*ZI.1.SFDU*(1.0-0.01*SF_PCTVAC)*(ZI.1.SF_2AUTO)*DSHARE(x,_SFIDX)
  MFDUM1[x]=0.01*ZI.1.MFDU*(1.0-0.01*MF_PCTVAC)*ZI.1.MF_0AUTO*DSHARE(x,_MFIDX)
  MFDUM2[x]=0.01*ZI.1.MFDU*(1.0-0.01*MF_PCTVAC)*ZI.1.MF_1AUTO*DSHARE(x,_MFIDX)
  MFDUM3[x]=0.01*ZI.1.MFDU*(1.0-0.01*MF_PCTVAC)*(ZI.1.MF_2AUTO)*DSHARE(x,_MFIDX)
ENDLOOP

; Identify Rate District (see page 18 of TM2-CFRPM4.0 Calibration & Validation Report)

;_mpo = TYPE(5,I)
;_gendist = 1
;IF (_mpo==1)          ; Region 1
;  _gendist = 1
;ELSEIF (_mpo==2)      ; Region 2
;  _gendist = 2
;ELSEIF (_mpo==3)   ; Region 3
;  _gendist = 3
;ENDIF

; Debug
IF (I==_seli) LIST="2077 MPO",_MPO(3.0)," GENDIST ",_GENDIST(3.0)

LOOP L=1,4

 _HMTOT=0
 SFTOT[1]=0, SFTOT[2]=0, SFTOT[3]=0
 MFTOT[1]=0, MFTOT[2]=0, MFTOT[3]=0

LOOP x=1,5
 _tmp1 = 9 * (x-1) + 6
 _tmp2 = 9 * (x-1) + 1
 _tmp3 = 9 * (x-1) + 4
 _tmp4 = 9 * (x-1) + 7
 _tmp5 = 9 * (x-1) + 2
 _tmp6 = 9 * (x-1) + 5
 _tmp7 = 9 * (x-1) + 8

 ;  IF (_gendist==1)
 _HMTRIP  = RATES1(L+3,_tmp1)*HMDUM[x]
 _SFTRIP1 = RATES1(L+3,_tmp2)*SFDUM1[x]
 _SFTRIP2 = RATES1(L+3,_tmp3)*SFDUM2[x]
 _SFTRIP3 = RATES1(L+3,_tmp4)*SFDUM3[x]
 _MFTRIP1 = RATES1(L+3,_tmp5)*MFDUM1[x]
 _MFTRIP2 = RATES1(L+3,_tmp6)*MFDUM2[x]
 _MFTRIP3 = RATES1(L+3,_tmp7)*MFDUM3[x]

;    ELSEIF (_gendist==2)
;      _HMTRIP  = RATES2(L+3,_tmp1)*HMDUM[x]
;      _SFTRIP1 = RATES2(L+3,_tmp2)*SFDUM1[x]
;      _SFTRIP2 = RATES2(L+3,_tmp3)*SFDUM2[x]
;      _SFTRIP3 = RATES2(L+3,_tmp4)*SFDUM3[x]
;      _MFTRIP1 = RATES2(L+3,_tmp5)*MFDUM1[x]
;      _MFTRIP2 = RATES2(L+3,_tmp6)*MFDUM2[x]
;      _MFTRIP3 = RATES2(L+3,_tmp7)*MFDUM3[x]
;    ELSEIF (_gendist==3)
;      _HMTRIP  = RATES3(L+3,_tmp1)*HMDUM[x]
;      _SFTRIP1 = RATES3(L+3,_tmp2)*SFDUM1[x]
;      _SFTRIP2 = RATES3(L+3,_tmp3)*SFDUM2[x]
;      _SFTRIP3 = RATES3(L+3,_tmp4)*SFDUM3[x]
;      _MFTRIP1 = RATES3(L+3,_tmp5)*MFDUM1[x]
;      _MFTRIP2 = RATES3(L+3,_tmp6)*MFDUM2[x]
;      _MFTRIP3 = RATES3(L+3,_tmp7)*MFDUM3[x]
; ENDIF

    _HMTOT = _HMTOT + _HMTRIP
    SFTOT[1] = SFTOT[1] + _SFTRIP1
    SFTOT[2] = SFTOT[2] + _SFTRIP2
    SFTOT[3] = SFTOT[3] + _SFTRIP3
    MFTOT[1] = MFTOT[1] + _MFTRIP1
    MFTOT[2] = MFTOT[2] + _MFTRIP2
    MFTOT[3] = MFTOT[3] + _MFTRIP3
  ENDLOOP
  IF (L==1)
    _WKA0 = SFTOT[1] + MFTOT[1]
    _WKA1 = SFTOT[2] + MFTOT[2] + _HMTOT
    _WKA2 = SFTOT[3] + MFTOT[3]
    _WKTOT = _WKA0 + _WKA1 + _WKA2
  ELSE
    _NWA0 = _NWA0 + SFTOT[1] + MFTOT[1]
    _NWA1 = _NWA1 + SFTOT[2] + MFTOT[2] + _HMTOT
    _NWA2 = _NWA2 + SFTOT[3] + MFTOT[3]
    _NWTOT = _NWA0 + _NWA1 + _NWA2
  ENDIF

  IF (I==_seli) LIST="2077 SFTOT L=",L(1.0)," ",SFTOT[1](7.1),SFTOT[2](7.1),SFTOT[3](7.1)
  IF (I==_seli) LIST="2077 MFTOT L=",L(1.0)," ",MFTOT[1](7.1),MFTOT[2](7.1),MFTOT[3](7.1)
  IF (I==_seli) LIST="2077 HMTOT L=",L(1.0)," ",_HMTOT(7.1)

ENDLOOP

; Debug
IF (I==_seli) LIST="2077 WKA0 ",_WKA0(7.1)," WKA1 ",_WKA1(7.1)," WKA2 ",_WKA2(7.2)," WKTOT ",_WKTOT(7.1)
IF (I==_seli) LIST="2077 NWA0 ",_NWA0(7.1)," NWA1 ",_NWA1(7.1)," NWA2 ",_NWA2(7.2)," NWTOT ",_NWTOT(7.1)

IF (_WKTOT > 0)
  _WKSHA0=ROUND(100.0*_WKA0/_WKTOT)
  _WKSHA1=ROUND(100.0*_WKA1/_WKTOT)
  _WKSHA2=ROUND(100.0*_WKA2/_WKTOT)
  _WKSHT=ROUND(_WKSHA0 + _WKSHA1 + _WKSHA2)
  IF (_WKSHT <> 100)
    IF (_WKSHA0 > _WKSHA1)
      IF (_WKSHA0 > _WKSHA2)
        _WKSHA0 = _WKSHA0 + 100 - _WKSHT
      ELSE
        _WKSHA2 = _WKSHA2 + 100 - _WKSHT
      ENDIF
    ELSE
      IF (_WKSHA1 > _WKSHA2)
        _WKSHA1 = _WKSHA1 + 100 - _WKSHT
      ELSE
        _WKSHA2 = _WKSHA2 + 100 - _WKSHT
      ENDIF
    ENDIF
  ENDIF
ENDIF

IF (_NWTOT > 0)
  _NWSHA0=ROUND(100.0*_NWA0/_NWTOT)
  _NWSHA1=ROUND(100.0*_NWA1/_NWTOT)
  _NWSHA2=ROUND(100.0*_NWA2/_NWTOT)
  _NWSHT=ROUND(_NWSHA0 + _NWSHA1 + _NWSHA2)
  IF (_NWSHT <> 100)
    IF (_NWSHA0 > _NWSHA1)
      IF (_NWSHA0 > _NWSHA2)
        _NWSHA0 = _NWSHA0 + 100 - _NWSHT
      ELSE
        _NWSHA2 = _NWSHA2 + 100 - _NWSHT
      ENDIF
    ELSE
      IF (_NWSHA1 > _NWSHA2)
        _NWSHA1 = _NWSHA1 + 100 - _NWSHT
      ELSE
        _NWSHA2 = _NWSHA2 + 100 - _NWSHT
      ENDIF
    ENDIF
  ENDIF
ENDIF

TAZ=i
ltp=zi.2.LTP
stp=zi.2.STP
wksh0=_WKSHA0
wksh1=_WKSHA1
wksh2=_WKSHA2
nwsh0=_NWSHA0
nwsh1=_NWSHA1
nwsh2=_NWSHA2
write reco=1

;**************************************************************
;END POTENTIAL SCRIPT ADJUSTMENT
;**************************************************************

ENDRUN


; Script for program MATRIX in file "D:\Data\FDOT\TransitApp\TransitModelTierBC_Delivery\APPLICATIONS\MCMAT00B.S"
; Do not change filenames or add or remove FILEI/FILEO statements using an editor. Use Cube/Application Manager.
RUN PGM=MATRIX PRNFILE="{SCENARIO_DIR}\output\MCMAT00A3.PRN" MSG='Preparation for mode choice model'
FILEI ZDATI[4] = "{SCENARIO_DIR}\output\PCWALK_{alt}{year}.DAT",
z=#1,pkprod=#2,pkattr=#3,opprod=#4,opattr=#5
FILEI ZDATI[3] = "{SCENARIO_DIR}\output\ZONESAT.DAT",
Z=6-10,A1=16-20
FILEI ZDATI[2] = "{SCENARIO_DIR}\input\ZDATA2_{year}{alt}.DBF"
;Z=1-5,A1=6-11,A2=12-17,A3=18-23,A4=24-29
FILEI ZDATI[1] = "{SCENARIO_DIR}\input\ZDATA1_{year}{alt}.DBF"
FILEO RECO[1] = "{SCENARIO_DIR}\output\TAZDATA_{alt}{year}.DBF",
   FIELDS= TAZ,DESCR,SFDU,SFSEAS,SFVAC,SFPOP,SF0CAR,SF1CAR,SF2CAR,SF3CAR,MFDU,MFSEAS,
           MFVAC,MFPOP,MF0CAR,MF1CAR,MF2CAR,MF3CAR,HMUNITS,HMPCTOCC,HMPOP,EMPMFG,EMPIND,EMPCOM,EMPSVC,EMPTOT,SCHENR,STPKCST,LTPKCST,
           PCWPRDPK,PCWATTPK,PCWPRDOP,PCWATTOP,AREA_TYPE,CBD_DUMMY,EXU_DUMMY,TERMTIME,PERCAUTO0,PERCAUTO1,PERCAUTO2

PAR ZONES={ZONESI,Spin-INTEGER,"Maximum internal zone number","3700",5,10000} ZONEMSG=100

RO.TAZ=ZI.1.TAZ
RO.SFDU=ZI.1.SFDU
RO.SF_PCTVNP=ZI.1.SF_PCTVNP
RO.SF_PCTVAC=ZI.1.SF_PCTVAC
RO.SFPOP=ZI.1.SFPOP
RO.SF_0AUTO=ZI.1.SF_0AUTO
RO.SF_1AUTO=ZI.1.SF_1AUTO
RO.SF_2AUTO=ZI.1.SF_2AUTO

RO.MFDU=ZI.1.MFDU
RO.MF_PCTVNP=ZI.1.MF_PCTVNP
RO.MF_PCTVAC=ZI.1.MF_PCTVAC
RO.MFPOP=ZI.1.MFPOP
RO.MF_0AUTO=ZI.1.MF_0AUTO
RO.MF_1AUTO=ZI.1.MF_1AUTO
RO.MF_2AUTO=ZI.1.MF_2AUTO

RO.HMDU=ZI.1.HMDU
RO.HMOCC=ZI.1.HMOCC
RO.HMPOP=ZI.1.HMPOP

RO.STPKCST=ZI.2.STP
RO.LTPKCST=ZI.2.LTP

RO.PCWPRDPK=ZI.4.PKPROD   ; percent walk at production end for peak period
RO.PCWATTPK=ZI.4.PKATTR
RO.PCWPRDOP=ZI.4.OPPROD
RO.PCWATTOP=ZI.4.OPATTR

RO.AREA_TYPE=ZI.3.A1
_atype=ROUND(ZI.3.A1/10)
if (_atype=1) RO.TERMTIME={TERM10}
if (_atype=2) RO.TERMTIME={TERM20}
if (_atype=3) RO.TERMTIME={TERM30}
if (_atype=4) RO.TERMTIME={TERM40}
if (_atype=5) RO.TERMTIME={TERM50}

CBD_DUMMY=0
EXU_DUMMY=0
; define CBD zones for mode chocie
if (ZI.3.A1>10 & ZI.3.A1<20) CBD_DUMMY=1
; define EXURBAN zones for mode choice
if (ZI.3.A1>40 & ZI.3.A1<50) EXU_DUMMY=1

WRITE RECO=1


ENDRUN


; Script for program MATRIX in file "D:\Data\FDOT\TransitApp\TransitModelTierBC_Delivery\APPLICATIONS\MCMAT00P.S"
; Do not change filenames or add or remove FILEI/FILEO statements using an editor. Use Cube/Application Manager.
RUN PGM=MATRIX PRNFILE="{SCENARIO_DIR}\output\MCMAT00A2.PRN" MSG='Calculate HOV time savings (to be used in mode choice model)'
FILEO MATO[3] = "{SCENARIO_DIR}\OUTPUT\RHSKIM.MAT",
mo=41-48,name=STOLL,SDISTANCE,STIME,STIME2,HTOLL,HDISTANCE,HTIME,HTIME2
FILEO MATO[2] = "{SCENARIO_DIR}\OUTPUT\FFSKIM.MAT",
mo=31-38,name=STOLL,SDISTANCE,STIME,STIME2,HTOLL,HDISTANCE,HTIME,HTIME2
FILEO MATO[1] = "{SCENARIO_DIR}\output\HOVSavings_{alt}{year}.MAT",
 MO=21-22,DEC=2*2,NAME=HOVsaveOP,HOVsavePK
FILEI MATI[3] = "{SCENARIO_DIR}\Output\FREESKIM_{ALT}{YEAR}_1.MAT"
FILEI MATI[1] = "{SCENARIO_DIR}\Output\CONGSKIM_{ALT}{YEAR}_1.MAT"

PAR ZONEMSG=100

DistributeINTRASTEP ProcessID="FSUTMSDist", ProcessList=1-3
FILLMW MW[1] =MI.1.4   ; note that time2 is used here (time2 contains both time and time-equivalent of toll)
FILLMW MW[2] =MI.1.8
FILLMW MW[11]=MI.3.4
FILLMW MW[12]=MI.3.8
FILLMW MW[31]=MI.3.4,2,1,5,8,7,6,9,3
FILLMW MW[41]=MI.1.4,2,1,5,8,7,6,9,3

MW[21]=MW[11] - MW[12] ; hov time savings during off-peak hours
MW[22]=MW[1] - MW[2]   ; hov time savings during peak hours

JLOOP
 IF (MW[21] > 0) MW[21]=0.0   ; IF less than HOVMIN zero out the savings
 IF (MW[22] > 0) MW[22]=0.0
 IF (MW[21] < {HOVMIN}) MW[21]=0.0   ; IF less than HOVMIN zero out the savings
 IF (MW[22] < {HOVMIN}) MW[22]=0.0
ENDJLOOP

ENDRUN


LOOP AMLoop_1 = 1, 1, 1

; PILOT Script


*del "{SCENARIO_DIR}\output\MODESHARES.CSV"
*del "{SCENARIO_DIR}\output\CBDSHARES.CSV"
; End of PILOT Script

  LOOP PURPOSE = 1, 3, 1

; PILOT Script
; Do not change filenames or add or remove FILEI/FILEO statements using an editor. Use Cube/Application Manager.

IF (PURPOSE=1) ; HBW purpose - requres peak skims
PERIOD='PK'
PURP='HBW'
PURPNO=2
SKIMFILE='RHSKIM'
STATPRKCOST='STPKCS1'
OCC3={hbw3p}
RUNDATE='@DATE.RUNDATE@'
RUNTIME=@TIME.RUNTIME@
PRK='LTPKCST'
STATION_TABLE='2,3,4,5,6,7,8'
isNHB=';'
noNHB=' '
isHBW=' '
noHBW=';'
copy, FILE = "{SCENARIO_DIR}\OUTPUT\HBWHEAD.VAR"
UBTRNCOEF=-0.0250
UBAUTOCOEF=-0.0250
UBPURPOSE='HBW'
UBTOD='ALL'
UBALTNAME='{SCENARIO_FULLNAME}'
endcopy

ELSEIF (PURPOSE=2) ; HBO purpose - requres off-peak skims
PERIOD='OP'
PURP='HBO'
PURPNO=3
SKIMFILE='FFSKIM'
STATPRKCOST='STPKCS2'
OCC3={hbo3p}
PRK='STPKCST'
STATION_TABLE='10,11,12,13,14,15,16'
isNHB=';'
noNHB=' '
isHBW=';'
noHBW=' '

copy, FILE = "{SCENARIO_DIR}\OUTPUT\HBOHEAD.VAR"
UBTRNCOEF=-0.0125
UBAUTOCOEF=-0.0125
UBPURPOSE='HBO'
UBTOD='ALL'
UBALTNAME='{SCENARIO_FULLNAME}'
endcopy

ELSEIF (PURPOSE=3) ; NHB purpose - requres off-peak skims
PERIOD='OP'
PURP='NHB'
PURPNO=4
SKIMFILE='FFSKIM'
STATPRKCOST='STPKCS2'
OCC3={nhb3p}
PRK='STPKCST'
STATION_TABLE='10,11,12,13,14,15,16'
isNHB=' '
noNHB=';'
isHBW=';'
noHBW=' '

copy, FILE = "{SCENARIO_DIR}\OUTPUT\NHBHEAD.VAR"
UBTRNCOEF=-0.0250
UBAUTOCOEF=-0.0250
UBPURPOSE='NHB'
UBTOD='ALL'
UBALTNAME='{SCENARIO_FULLNAME}'
endcopy

ENDIF
; End of PILOT Script

; Script for program MATRIX in file "D:\Data\FDOT\TransitApp\TransitModelTierBC_Delivery\APPLICATIONS\MCMAT00A.S"
; Do not change filenames or add or remove FILEI/FILEO statements using an editor. Use Cube/Application Manager.
RUN PGM=MATRIX PRNFILE="{SCENARIO_DIR}\output\MCMAT00D.PRN" MSG='Utilities and XCHOICE'

FILEO MATO[12] = "{SCENARIO_DIR}\output\farexfer_tmp.mat",
MO=211-216,220-225,DEC=12*2,NAME=farewb,farewp,farepb,farepp,farekb,farekp,xferwb,xferwp,xferpb,xferpp,xferkb,xferkp
FILEO MATO[11] = "{SCENARIO_DIR}\output\expautoutil_tmp.mat",
MO=56-58,36-38,DEC=6*D,NAME=EXPA_0CAR,EXPA_1CAR,EXPA_2CAR,SPLITCMP_0CAR,SPLITCMP_1CAR,SPLITCMP_2CAR
FILEO MATO[10] = "{SCENARIO_DIR}\output\@PURP@Trip.MAT",
MO=601-609,621-629,641-649,251-254,261-269,DEC=49*S
FILEO MATO[9] = "{SCENARIO_DIR}\output\@PURP@Trip_NT_2CAR.MAT",
MO=773-781,DEC=9*s,NAME=DANT2CAR,SR2NT2CAR,SR3NT2CAR,WBNT2CAR,WPNT2CAR,PBNT2CAR,PPNT2CAR,KBNT2CAR,KPNT2CAR;
FILEO MATO[8] = "{SCENARIO_DIR}\output\@PURP@Trip_NT_1CAR.MAT",
MO=764-772,DEC=9*s,NAME=DANT1CAR,SR2NT1CAR,SR3NT1CAR,WBNT1CAR,WPNT1CAR,PBNT1CAR,PPNT1CAR,KBNT1CAR,KPNT1CAR;
FILEO MATO[7] = "{SCENARIO_DIR}\output\@PURP@Trip_NT_0CAR.MAT",
MO=755-763,DEC=9*s,NAME=DANT0CAR,SR2NT0CAR,SR3NT0CAR,WBNT0CAR,WPNT0CAR,PBNT0CAR,PPNT0CAR,KBNT0CAR,KPNT0CAR;
FILEO MATO[6] = "{SCENARIO_DIR}\output\@PURP@Trip_MD_2CAR.MAT",
MO=746-754,DEC=9*s,NAME=DAMD2CAR,SR2MD2CAR,SR3MD2CAR,WBMD2CAR,WPMD2CAR,PBMD2CAR,PPMD2CAR,KBMD2CAR,KPMD2CAR;
FILEO MATO[5] = "{SCENARIO_DIR}\output\@PURP@Trip_MD_1CAR.MAT",
MO=737-745,DEC=9*s,NAME=DAMD1CAR,SR2MD1CAR,SR3MD1CAR,WBMD1CAR,WPMD1CAR,PBMD1CAR,PPMD1CAR,KBMD1CAR,KPMD1CAR;
FILEO MATO[4] = "{SCENARIO_DIR}\output\@PURP@Trip_MD_0CAR.MAT",
MO=728-736,DEC=9*s,NAME=DAMD0CAR,SR2MD0CAR,SR3MD0CAR,WBMD0CAR,WPMD0CAR,PBMD0CAR,PPMD0CAR,KBMD0CAR,KPMD0CAR;
FILEO MATO[3] = "{SCENARIO_DIR}\output\@PURP@Trip_CW_2CAR.MAT",
MO=719-727,DEC=9*s,NAME=DACW2CAR,SR2CW2CAR,SR3CW2CAR,WBCW2CAR,WPCW2CAR,PBCW2CAR,PPCW2CAR,KBCW2CAR,KPCW2CAR;
FILEO MATO[2] = "{SCENARIO_DIR}\output\@PURP@Trip_CW_1CAR.MAT",
MO=710-718,DEC=9*s,NAME=DACW1CAR,SR2CW1CAR,SR3CW1CAR,WBCW1CAR,WPCW1CAR,PBCW1CAR,PPCW1CAR,KBCW1CAR,KPCW1CAR;
FILEO MATO[1] = "{SCENARIO_DIR}\output\@PURP@Trip_CW_0CAR.MAT",
MO=701-709,DEC=9*s,NAME=DACW0CAR,SR2CW0CAR,SR3CW0CAR,WBCW0CAR,WPCW0CAR,PBCW0CAR,PPCW0CAR,KBCW0CAR,KPCW0CAR;
FILEO PRINTO[2] = "{SCENARIO_DIR}\output\ModeSum.TXT",
append=t
FILEO PRINTO[1] = "{SCENARIO_DIR}\output\ModeDebug.TXT",
append=t

FILEI ZDATI[3] = "{SCENARIO_DIR}\output\A1DECK1.DBF"
FILEI ZDATI[2] = "{SCENARIO_DIR}\output\STATDATA_{alt}{year}.DBF"
FILEI ZDATI[1] = "{SCENARIO_DIR}\output\TAZDATA_{alt}{year}.DBF"
FILEI LOOKUPI[2] = "{SCENARIO_DIR}\output\TRN_COEFFICIENTS.DBF"
FILEI LOOKUPI[1] = "{SCENARIO_DIR}\output\MC_CONSTANTS.DBF"

FILEI MATI[13] = "{SCENARIO_DIR}\output\PSNTRIPS_{aLT}{yEAR}.MAT"
FILEI MATI[12] = "{SCENARIO_DIR}\output\ST2ST_{alt}{year}.MAT"
; Table 1-16:  PKStationTAZ_pnrb,PKParkCost_pnrb,PKTermTimepnrb,PKTermTimeknrb,
              ;PKStationTAZ_pnrp,PKParkCost_pnrp,PKTermtimepnrp,PKTermtimeknrp,
              ;OPStationTAZ_pnrb,OPParkCost_pnrb,OPTermtimepnrb,OPTermtimeknrb,
              ;OPStationTAZ_pnrp,OPParkCost_pnrp,OPTermtimepnrp,OPTermtimeknrp
FILEI MATI[11] = "{SCENARIO_DIR}\output\HOVSavings_{alt}{year}.MAT"
           ; Table 1 - HOV time savings for peak period
           ; Table 2 - HOV time savings for off-peak period
FILEI MATI[5] = "{SCENARIO_DIR}\output\TSKIM@PERIOD@4_{Alt}{year}.mat"
FILEI MATI[4] = "{SCENARIO_DIR}\output\TSKIM@PERIOD@3_{Alt}{year}.mat"
FILEI MATI[3] = "{SCENARIO_DIR}\output\TSKIM@PERIOD@2_{Alt}{year}.mat"
FILEI MATI[2] = "{SCENARIO_DIR}\output\TSKIM@PERIOD@1_{Alt}{year}.mat"
           ; Tables 1-6: 1-WalkTime, 2-AutoTime, 3-XferTime, 4-BusTime, 5-PRJBusTime, 6-CircTime
           ; Tables 7-10: 7-RailTime, 8-CommuterRailTime, 9-OtherModeTime, 10-ProjectModeTime
           ; Tables 11-15: 11-NumXfers, 12-InitialWaitTime, 13-XferWaitTime, 14-Fare, 15-Total time
FILEI MATI[1] = "{SCENARIO_DIR}\output\@SKIMFILE@.MAT"
           ; Tables 1-4 for SOV: 1-Toll, 2-Distance, 3-Time, 4-Weighted Time
           ; Tables 5-8 for HOV: 5-Toll, 6-Distance, 7-Time, 8-Weighted Time

zonemsg=100
ARRAY PARK={ZONESA}

DistributeINTRASTEP ProcessID="FSUTMSDist", ProcessList=1-3

;Constants
LOOKUP, NAME=CONSTANTS, LOOKUP[1]=1, RESULT=@PURPNO@, INTERPOLATE=N, , LIST=Y, LOOKUPI=1
;K=CONSTANT
IF (i=FirstZone)
 K_DA_AUTO0=CONSTANTS(1,1),         K_DA_AUTO1=CONSTANTS(1,13),        K_DA_AUTO2=CONSTANTS(1,25)
 K_SR1PASS_AUTO0=CONSTANTS(1,2),    K_SR1PASS_AUTO1=CONSTANTS(1,14),   K_SR1PASS_AUTO2=CONSTANTS(1,26)
 K_SR2PASS_AUTO0=CONSTANTS(1,3),    K_SR2PASS_AUTO1=CONSTANTS(1,15),   K_SR2PASS_AUTO2=CONSTANTS(1,27)
 K_WALKBUS_AUTO0=CONSTANTS(1,4),    K_WALKBUS_AUTO1=CONSTANTS(1,16),   K_WALKBUS_AUTO2=CONSTANTS(1,28)
 K_WALKPRJ_AUTO0=CONSTANTS(1,5),    K_WALKPRJ_AUTO1=CONSTANTS(1,17),   K_WALKPRJ_AUTO2=CONSTANTS(1,29)
 K_PNRBUS_AUTO0=CONSTANTS(1,6),     K_PNRBUS_AUTO1=CONSTANTS(1,18),    K_PNRBUS_AUTO2=CONSTANTS(1,30)
 K_PNRPRJ_AUTO0=CONSTANTS(1,7),     K_PNRPRJ_AUTO1=CONSTANTS(1,19),    K_PNRPRJ_AUTO2=CONSTANTS(1,31)
 K_KNRBUS_AUTO0=CONSTANTS(1,8),     K_KNRBUS_AUTO1=CONSTANTS(1,20),    K_KNRBUS_AUTO2=CONSTANTS(1,32)
 K_KNRPRJ_AUTO0=CONSTANTS(1,9),     K_KNRPRJ_AUTO1=CONSTANTS(1,21),    K_KNRPRJ_AUTO2=CONSTANTS(1,33)
ENDIF

;Coefficients
LOOKUP, NAME=COEFF, LOOKUP[1]=1, RESULT=@PURPNO@, INTERPOLATE=N, LIST=Y, LOOKUPI=2
;Coefficients
IF(i=FirstZone)
; Transit Coefficients
 COEFF_IVTT   = COEFF(1,1)
 COEFF_OVT    = COEFF(1,3)
 COEFF_COST   = COEFF(1,4)
 COEFF_AAT    = COEFF(1,5)
 COEFF_XFER   = COEFF(1,6)
 COEFF_DCBD   = COEFF(1,7)
 COEFF_DEXUP  = COEFF(1,8)
 COEFF_DEXUA  = COEFF(1,9)
 NC_TRNAC     = COEFF(1,10)
 NC_TRN       = COEFF(1,11)
 NC_AUTO      = COEFF(1,12)
 NC_AUTOSR    = COEFF(1,13)
 COEFF_DCBD_WALK   = COEFF(1,15)
 COEFF_DCBD_PNR    = COEFF(1,16)
 COEFF_DCBD_KNR    = COEFF(1,17)

; Nesting Coefficients
 NC_DriveAlone = NC_AUTO
 NC_SharedRide = NC_AUTO * NC_AUTOSR
 NC_WALKBUS = NC_TRN * NC_TRNAC
 NC_WALKPRJ = NC_TRN * NC_TRNAC
 NC_PNRBus = NC_TRN * NC_TRNAC
 NC_PNRPrj = NC_TRN * NC_TRNAC
 NC_KNRBus = NC_TRN * NC_TRNAC
 NC_KNRPrj = NC_TRN * NC_TRNAC
ENDIF

FILLMW MW[1]=MI.1.1,2,3,4,5,6,7,8            ; highway skims
FILLMW MW[11]=MI.11.HOVsave@PERIOD@          ; HOVsavePK for peak period (HBW) and HOVsaveOP for off-peak period (HBO and NHB)
FILLMW MW[21]=MI.2.1,2,3,4,5,6,7,8,9,10,11,12,13,14,15 ;tskim1
FILLMW MW[41]=MI.3.1,2,3,4,5,6,7,8,9,10,11,12,13,14,15 ;tskim2
FILLMW MW[61]=MI.4.1,2,3,4,5,6,7,8,9,10,11,12,13,14,15 ;tskim3
FILLMW MW[81]=MI.5.1,2,3,4,5,6,7,8,9,10,11,12,13,14,15 ;tskim4
FILLMW MW[211]=MI.2.14
FILLMW MW[212]=MI.3.14
FILLMW MW[213]=MI.4.14
FILLMW MW[214]=MI.5.14
FILLMW MW[215]=MI.4.14
FILLMW MW[216]=MI.5.14
FILLMW MW[220]=MI.2.11
FILLMW MW[221]=MI.3.11
FILLMW MW[222]=MI.4.11
FILLMW MW[223]=MI.5.11
FILLMW MW[224]=MI.4.11
FILLMW MW[225]=MI.5.11

FILLMW MW[251]=MI.13.@PURP@    ; person trip table
FILLMW MW[291]=MI.12.@STATION_TABLE@         ; 4 tables - stations zones for pnr-bus,knr-bus,pnr-prj,knr-prj paths

if (I=1)
; DEBUG MODE CHOICE
 IF ({DebugMC}>0)
   print list='MODE CHOICE TRACE @PURP@-@PERIOD@','\n\n',printo=1
   print list='-- @DATE.RUNDATE@     ',printo=1
   print list='-- @TIME.RUNTIME@     ','\n\n',printo=1
   print list='NERPM \n\nSelected Interchange for Tracing:    ',{SelOrigin}(4.0),'-',{SelDest}(4.0),'\n\n',printo=1
   print list='PURPOSE -           @PURP@  ',printo=1
   print list='SKIMS/PERIOD        @PERIOD@',printo=1
   print list='\nCoefficients                ',printo=1
   print list='       IVTT                 ',COEFF_IVTT(7.4),printo=1
   print list='       OVT                  ',COEFF_OVT(7.4),printo=1
   print list='       AAT                  ',COEFF_AAT(7.4),printo=1
   print list='       XFER                 ',COEFF_XFER(7.4),printo=1
   print list='       COST                 ',COEFF_COST(7.4),printo=1
   PRINT LIST='       DUM_CBD_WALK         ',COEFF_DCBD_WALK(7.4),printo=1
   PRINT LIST='       DUM_CBD_PNR          ',COEFF_DCBD_PNR(7.4),printo=1
   PRINT LIST='       DUM_CBD_KNR          ',COEFF_DCBD_KNR(7.4),printo=1
   print list='\n\nNesting Coeffcient      ',printo=1
   print list='        NC_TRNAC            ',NC_TRNAC(7.4),printo=1
   print list='        NC_TRN              ',NC_TRN(7.4),printo=1
   print list='        NC_AUTOSR           ',NC_AUTOSR(7.4),printo=1
   print list='        NC_AUTO             ',NC_AUTO(7.4),printo=1
   print list='\n\nConstants               ',printo=1
   print list='        Drive alone (0 car) ',K_da_auto0(8.4),printo=1
   print list='        Drive alone (1 car) ',K_da_auto1(8.4),printo=1
   print list='        Drive alone (2 car) ',K_da_auto2(8.4),printo=1
   print list='        HOV2 (0 car)        ',K_sr1pass_auto0(8.4),printo=1
   print list='        HOV2 (1 car)        ',K_sr1pass_auto1(8.4),printo=1
   print list='        HOV2 (2 car)        ',K_sr1pass_auto2(8.4),printo=1
   print list='        HOV3+ (0 car)       ',K_sr2pass_auto0(8.4),printo=1
   print list='        HOV3+ (1 car)       ',K_sr2pass_auto1(8.4),printo=1
   print list='        HOV3+ (2 car)       ',K_sr2pass_auto2(8.4),printo=1
   print list='        Walk Bus (0 car)    ',K_walkbus_auto0(8.4),printo=1
   print list='        Walk Bus (1 car)    ',K_walkbus_auto1(8.4),printo=1
   print list='        Walk Bus (2 car)    ',K_walkbus_auto2(8.4),printo=1
   print list='        Walk Prj (0 car)    ',K_WALKPRJ_auto0(8.4),printo=1
   print list='        Walk Prj (1 car)    ',K_WALKPRJ_auto1(8.4),printo=1
   print list='        PNR Bus (0 car)     ',K_PNRBUS_auto0(8.4),printo=1
   print list='        PNR Bus (1 car)     ',K_PNRBUS_auto1(8.4),printo=1
   print list='        PNR Bus (2 car)     ',K_PNRBUS_auto2(8.4),printo=1
   print list='        PNR Prj (1 car)     ',K_PNRPRJ_auto1(8.4),printo=1
   print list='        PNR Prj (2 car)     ',K_PNRPRJ_auto2(8.4),printo=1
   print list='        KNR Bus (0 car)     ',K_KNRBUS_auto0(8.4),printo=1
   print list='        KNR Bus (1 car)     ',K_KNRBUS_auto1(8.4),printo=1
   print list='        KNR Bus (2 car)     ',K_KNRBUS_auto2(8.4),printo=1
   print list='        KNR Prj (0 car)     ',K_KNRPRJ_auto0(8.4),printo=1
   print list='        KNR Prj (1 car)     ',K_KNRPRJ_auto1(8.4),printo=1
   print list='        KNR Prj (2 car)     ',K_KNRPRJ_auto2(8.4),printo=1
   print list='        ProjectModeFlag     ',{IsProjectMode}(8.0),printo=1
   print list='\n\nParameters used in disutility calculations:', printo=1
   print list='Highway Operating Cost (cents/mi)   ',{hwyopcost}(5.3),printo=1
   print list='CTOLL Multiplier (toll to time)     ',{CTOLL}(5.3),printo=1
   print list='Value of ZAPZERO                    ',{ZAPZERO}(5.3),printo=1
   print list='Auto Occupancy 3+ (HBW)             ',{hbw3p}(5.3),printo=1
   print list='Auto Occupancy 3+ (HBO)             ',{hbo3p}(5.3),printo=1
   print list='Auto Occupancy 3+ (NHB)             ',{nhb3p}(5.3),printo=1
   print list='Inflation factor - Tolls            ',{InflationToll}(5.3),printo=1
   print list='Inflation factor - Auto Op Cost     ',{InflationAOC}(5.3),printo=1
   print list='Inflation factor - Parking Cost     ',{InflationParkCost}(5.3),printo=1
   print list='Inflation factor - Transit Fare     ',{InflationFare}(5.3),printo=1
   print list='Auto Access Auto Occupancy Factor   ',{OCCPNRAccess}(5.3),printo=1
   print list='Times are in minutes. Costs are in cents.        ',printo=1
 endif

 ; Echo to Mode Choice summary file
 PRINT LIST="\f+++++ MODE XCHOICE SUMMARY +++++\n" PRINTO=2
 PRINT LIST='-- @DATE.RUNDATE@     ','-- @TIME.RUNTIME@     ','\n',PRINTO=2
 PRINT LIST="{SCENARIO_FULLNAME}" PRINTO=2
 PRINT LIST="{SCENARIO_SHORTNAME}\n" PRINTO=2
 PRINT LIST='PURPOSE -           @PURP@  ',printo=2
 PRINT LIST='SKIMS/PERIOD        @PERIOD@',printo=2
 PRINT LIST='\nCoefficients                ',printo=2
 PRINT LIST='       IVTT                 ',COEFF_IVTT(7.4),printo=2
 PRINT LIST='       OVT                  ',COEFF_OVT(7.4),printo=2
 PRINT LIST='       AAT                  ',COEFF_AAT(7.4),printo=2
 PRINT LIST='       XFER                 ',COEFF_XFER(7.4),printo=2
 PRINT LIST='       COST                 ',COEFF_COST(7.4),printo=2
 PRINT LIST='       DUM_CBD_WALK         ',COEFF_DCBD_WALK(7.4),printo=2
 PRINT LIST='       DUM_CBD_PNR          ',COEFF_DCBD_PNR(7.4),printo=2
 PRINT LIST='       DUM_CBD_KNR          ',COEFF_DCBD_KNR(7.4),printo=2
 PRINT LIST='\n\nNesting Coeffcient      ',printo=2
 PRINT LIST='        NC_TRNAC            ',NC_TRNAC(7.4),printo=2
 PRINT LIST='        NC_TRN              ',NC_TRN(7.4),printo=2
 PRINT LIST='        NC_AUTOSR           ',NC_AUTOSR(7.4),printo=2
 PRINT LIST='        NC_AUTO             ',NC_AUTO(7.4),printo=2
 PRINT LIST='\n\nConstants               ',printo=2
 PRINT LIST='        Drive alone (0 car) ',K_da_auto0(8.4),printo=2
 PRINT LIST='        Drive alone (1 car) ',K_da_auto1(8.4),printo=2
 PRINT LIST='        Drive alone (2 car) ',K_da_auto2(8.4),printo=2
 PRINT LIST='        HOV2 (0 car)        ',K_sr1pass_auto0(8.4),printo=2
 PRINT LIST='        HOV2 (1 car)        ',K_sr1pass_auto1(8.4),printo=2
 PRINT LIST='        HOV2 (2 car)        ',K_sr1pass_auto2(8.4),printo=2
 PRINT LIST='        HOV3+ (0 car)       ',K_sr2pass_auto0(8.4),printo=2
 PRINT LIST='        HOV3+ (1 car)       ',K_sr2pass_auto1(8.4),printo=2
 PRINT LIST='        HOV3+ (2 car)       ',K_sr2pass_auto2(8.4),printo=2
 PRINT LIST='        Walk Bus (0 car)    ',K_walkbus_auto0(8.4),printo=2
 PRINT LIST='        Walk Bus (1 car)    ',K_walkbus_auto1(8.4),printo=2
 PRINT LIST='        Walk Bus (2 car)    ',K_walkbus_auto2(8.4),printo=2
 PRINT LIST='        Walk Prj (0 car)    ',K_WALKPRJ_auto0(8.4),printo=2
 PRINT LIST='        Walk Prj (1 car)    ',K_WALKPRJ_auto1(8.4),printo=2
 PRINT LIST='        Walk Prj (2 car)    ',K_WALKPRJ_auto2(8.4),printo=2
 PRINT LIST='        PNR Bus (0 car)     ',K_PNRBUS_auto0(8.4),printo=2
 PRINT LIST='        PNR Bus (1 car)     ',K_PNRBUS_auto1(8.4),printo=2
 PRINT LIST='        PNR Bus (2 car)     ',K_PNRBUS_auto2(8.4),printo=2
 PRINT LIST='        PNR Prj (0 car)     ',K_PNRPRJ_auto0(8.4),printo=2
 PRINT LIST='        PNR Prj (1 car)     ',K_PNRPRJ_auto1(8.4),printo=2
 PRINT LIST='        PNR Prj (2 car)     ',K_PNRPRJ_auto2(8.4),printo=2
 PRINT LIST='        KNR Bus (0 car)     ',K_KNRBUS_auto0(8.4),printo=2
 PRINT LIST='        KNR Bus (1 car)     ',K_KNRBUS_auto1(8.4),printo=2
 PRINT LIST='        KNR Bus (2 car)     ',K_KNRBUS_auto2(8.4),printo=2
 PRINT LIST='        KNR Prj (0 car)     ',K_KNRPRJ_auto0(8.4),printo=2
 PRINT LIST='        KNR Prj (2 car)     ',K_KNRPRJ_auto2(8.4),printo=2
 print list='        ProjectModeFlag     ',{IsProjectMode}(8.0),printo=2
 PRINT LIST='\n\nParameters used in disutility calculations:', printo=2
 PRINT LIST='Highway Operating Cost (cents/mi)   ',{hwyopcost}(5.3),printo=2
 PRINT LIST='CTOLL Multiplier (toll to time)     ',{CTOLL}(5.3),printo=2
 PRINT LIST='Value of ZAPZERO                    ',{ZAPZERO}(5.3),printo=2
 PRINT LIST='Auto Occupancy 3+ (HBW)             ',{hbw3p}(5.3),printo=2
 PRINT LIST='Auto Occupancy 3+ (HBO)             ',{hbo3p}(5.3),printo=2
 PRINT LIST='Auto Occupancy 3+ (NHB)             ',{nhb3p}(5.3),printo=2
 PRINT LIST='Inflation factor - Tolls            ',{InflationToll}(5.3),printo=2
 PRINT LIST='Inflation factor - Auto Op Cost     ',{InflationAOC}(5.3),printo=2
 PRINT LIST='Inflation factor - Parking Cost     ',{InflationParkCost}(5.3),printo=2
 PRINT LIST='Inflation factor - Transit Fare     ',{InflationFare}(5.3),printo=2
 PRINT LIST='Auto Access Auto Occupancy Factor   ',{OCCPNRAccess}(5.3),printo=2
 PRINT LIST='Times reflected in minutes.         ',printo=2
 PRINT LIST='Costs are in cents.                 ',printo=2

endif

; for debugging
;JLOOP
; if ({DebugMC}=1)
 ;  if (I>{SELORIGIN}) EXIT
  ;  if (I<>{SELDEST}) BREAK
  ;endif
;ENDJLOOP

; Divide person trip table into different markets

;zero car HHs
if('@PURP@'='HBW')
 MW[252]=MW[251] * ZI.3.wksh0[I]*0.01
else
 MW[252]=MW[251] * ZI.3.nwsh0[I]*0.01
endif
; for NHB purpose, there is no market segmentation and hence put all trips into zer-car household trip table
  if ('@PURP@'='NHB') MW[252]=MW[251]
  MW[261] = MW[252] * (ZI.1.PCWPRD@PERIOD@[I] * 0.01) * (ZI.1.PCWATT@PERIOD@[J] * 0.01)                 ; Can Walk
  MW[262] = MW[252] * (1 - (ZI.1.PCWPRD@PERIOD@[I] * 0.01)) * (ZI.1.PCWATT@PERIOD@[J] * 0.01)           ; Must Drive
  MW[263] = MW[252] - MW[261] - MW[262]                                                                 ; No Access

; One car HHs
if('@PURP@'='HBW')
 MW[253]=MW[251] * ZI.3.wksh1[I]*0.01
else
 MW[253]=MW[251] * ZI.3.nwsh1[I]*0.01
endif
  if ('@PURP@'='NHB') MW[253]=0
  MW[264] = MW[253] * (ZI.1.PCWPRD@PERIOD@[I] * 0.01) * (ZI.1.PCWATT@PERIOD@[J] * 0.01)                 ; Can Walk
  MW[265] = MW[253] * (1 - (ZI.1.PCWPRD@PERIOD@[I] * 0.01)) * (ZI.1.PCWATT@PERIOD@[J] * 0.01)           ; Must Drive
  MW[266] = MW[253] - MW[264] - MW[265]                                                                 ; No Access

;Two car HHs
if('@PURP@'='HBW')
 MW[254]=MW[251] * ZI.3.wksh2[I]*0.01
else
 MW[254]=MW[251] * ZI.3.nwsh2[I]*0.01
endif
  if ('@PURP@'='NHB') MW[254]=0
  MW[267] = MW[254] * (ZI.1.PCWPRD@PERIOD@[I] * 0.01) * (ZI.1.PCWATT@PERIOD@[J] * 0.01)                 ; Can Walk
  MW[268] = MW[254] * (1 - (ZI.1.PCWPRD@PERIOD@[I] * 0.01)) * (ZI.1.PCWATT@PERIOD@[J] * 0.01)           ; Must Drive
  MW[269] = MW[254] - MW[267] - MW[268]                                                                 ; No Access

JLOOP  ; highway skim checks - Needed to reduce ultra-high skims (NOACCESS zones) to zeros to keep utilities within range
   IF (MW[1]>=9999.00) MW[1]=0
   IF (MW[2]>=9999.00) MW[2]=0
   IF (MW[3]>=9999.00) MW[3]=0
   IF (MW[4]>=9999.00) MW[4]=0
   IF (MW[5]>=9999.00) MW[5]=0
   IF (MW[6]>=9999.00) MW[6]=0
   IF (MW[7]>=9999.00) MW[7]=0
   IF (MW[8]>=9999.00) MW[8]=0
ENDJLOOP

LOOP ACC=1,3

; ===================================================================================
; @PURP@ (@PERIOD@) TRIP PURPOSE
; ===================================================================================

; (1) Terminal Time (both at production-end and attraction-end)
; (2) Auto run time
; (3) highway operating cost
; (4) Toll (assumed in $)
; (5) Parking cost
; (6) CBD/EXURBAN dummy variables
; (7) Transit fare
; (8) Out-of vehicle time (walk/transfer time/wait)

   if (ACC==1) then
    ACC_NAME='CAN WALK TO TRANSIT'
    walk_acc_dum = 0.0            ; added to the utility
    auto_acc_dum = 0.0            ; added to the utility
   elseif (ACC==2)
    ACC_NAME='MUST DRIVE TO TRANSIT'
    walk_acc_dum = -9999.99
    auto_acc_dum = 0.0
   elseif (ACC==3)
    ACC_NAME='NO TRANSIT'
    walk_acc_dum = -9999.99
    auto_acc_dum = -9999.99
   endif

; ******************************** UTILITY CALCULATIONS ************************************
  ;   DRIVE ALONE ELEMENTS OF UTILITY ARE:
      MW[301]=COEFF_OVT * (ZI.1.TERMTIME[I] + ZI.1.TERMTIME[J]) +                                       ; Terminal time
              COEFF_IVTT * (MW[4] - ({InflationToll} * (MW[1] * {CTOLL} * 60))) +                       ; IVTT
              COEFF_COST * ({InflationToll} * MW[1]) +                                                  ; Toll converted to equivalent minutes
@noNHB@       COEFF_COST * ((({InflationParkCost} * ZI.1.@PRK@[J]) / 1.0) / 2.0) +                      ; Auto parking cost
@isNHB@       COEFF_COST * ((({InflationParkCost} * ZI.1.@PRK@[J]) / 1.0) / 1.0) +                      ; Auto parking cost (NHB)
              COEFF_COST * (({InflationAOC} * MW[2] * {hwyopcost}) / 1.0) +                             ; Auto operating cost
@isNHB@       COEFF_DCBD * (ZI.1.CBD_DUMMY[I] + ZI.1.CBD_DUMMY[J]) +                                      ; CBD dummy (NHB)
@noNHB@       COEFF_DCBD * ZI.1.CBD_DUMMY[J] +                                                          ; CBD dummy
              COEFF_DEXUP * ZI.1.EXU_DUMMY[I] +                                                         ; Exurban production dummy
              COEFF_DEXUA * ZI.1.EXU_DUMMY[J]                                                           ; Exurban attraction dummy

  ;   SHARED RIDE PERSONS/SHARE RIDE - ONE PASSENGER ELEMENTS OF UTILITY ARE:
      MW[302]=COEFF_OVT * (ZI.1.TERMTIME[I] + ZI.1.TERMTIME[J]) +                                       ; Terminal time
              COEFF_IVTT * (MW[4] - ({InflationToll} * (MW[5] * {CTOLL} * 60))) +                       ; IVTT
              COEFF_COST * (({InflationToll} * MW[5]) / 2.0) -                                          ; Toll converted to equivalent minutes
              COEFF_IVTT * (MAX (MW[11], 0)) +                                                          ; HOV time savings
@noNHB@       COEFF_COST * ((({InflationParkCost} * ZI.1.@PRK@[J]) / 2.0) / 2.0) +                      ; Auto parking cost
@isNHB@       COEFF_COST * ((({InflationParkCost} * ZI.1.@PRK@[J]) / 2.0) / 1.0) +                      ; Auto parking cost (NHB)
              COEFF_COST * (({InflationAOC} * MW[2] * {hwyopcost}) / 2.0) +                             ; Auto operating cost
@isNHB@       COEFF_DCBD * (ZI.1.CBD_DUMMY[I] + ZI.1.CBD_DUMMY[J]) +                                      ; CBD dummy (NHB)
@noNHB@       COEFF_DCBD * ZI.1.CBD_DUMMY[J] +                                                          ; CBD dummy
              COEFF_DEXUP * ZI.1.EXU_DUMMY[I] +                                                         ; Exurban production dummy
              COEFF_DEXUA * ZI.1.EXU_DUMMY[J]                                                           ; Exurban attraction dummy

  ;   SHARED RIDE - 2+ PASSENGER ELEMENTS OF UTILITY ARE:

      MW[303]=COEFF_OVT * (ZI.1.TERMTIME[I] + ZI.1.TERMTIME[J]) +                                       ; Terminal time
              COEFF_IVTT * (MW[4] - ({InflationToll} * (MW[5] * {CTOLL} * 60))) +                       ; IVTT
              COEFF_COST * (({InflationToll} * MW[5]) / @OCC3@) -                                       ; Toll converted to equivalent minutes
              COEFF_IVTT * (MAX (MW[11], 0)) +                                                          ; HOV time savings
@noNHB@       COEFF_COST * ((({InflationParkCost} * ZI.1.@PRK@[J]) / @OCC3@) / 2.0) +                   ; Auto parking cost
@isNHB@       COEFF_COST * ((({InflationParkCost} * ZI.1.@PRK@[J]) / @OCC3@) / 1.0) +                   ; Auto parking cost (NHB)
              COEFF_COST * (({InflationAOC} * MW[2] * {hwyopcost}) / @OCC3@) +                          ; Auto operating cost
@isNHB@       COEFF_DCBD * (ZI.1.CBD_DUMMY[I] + ZI.1.CBD_DUMMY[J]) +                                      ; CBD dummy (NHB)
@noNHB@       COEFF_DCBD * ZI.1.CBD_DUMMY[J] +                                                          ; CBD dummy
              COEFF_DEXUP * ZI.1.EXU_DUMMY[I] +                                                         ; Exurban production dummy
              COEFF_DEXUA * ZI.1.EXU_DUMMY[J]                                                           ; Exurban attraction dummy

 ;   WALK ACCESS - BUS ELEMENTS OF UTILITY ARE:
      MW[304]=COEFF_OVT * (MW[21] + MW[23]) +                                                   ; Walk & transfer time
              COEFF_OVT * (MW[32] + MW[33]) +                                                   ; Initial & transfer wait
              COEFF_IVTT * (MW[24] + MW[25] + MW[26] + MW[27] + MW[28] + MW[29] + MW[30]) +     ; IVTT
              COEFF_XFER * (MW[31]) +                                                           ; Number of transfers
              COEFF_COST * {InflationFare} * (MW[34]) +                                         ; Transit fare
@isNHB@       COEFF_DCBD_WALK * (ZI.1.CBD_DUMMY[I] + ZI.1.CBD_DUMMY[J]) +                       ; CBD dummy (NHB)
@noNHB@       COEFF_DCBD_WALK * ZI.1.CBD_DUMMY[J] +                                             ; CBD dummy
              COEFF_DEXUP * ZI.1.EXU_DUMMY[I] +                                                 ; Exurban production dummy
              COEFF_DEXUA * ZI.1.EXU_DUMMY[J]                                                   ; Exurban attraction dummy

  ;   WALK ACCESS - PROJECT ELEMENTS OF UTILITY ARE:
      MW[305]=COEFF_OVT * (MW[41] + MW[43]) +                                                   ; Walk & transfer time
              COEFF_OVT * (MW[52] + MW[53]) +                                                   ; Initial & transfer wait
              COEFF_IVTT * (MW[44] + MW[45] + MW[46] + MW[47] + MW[48] + MW[49] + MW[50]) +     ; IVTT
              COEFF_XFER * (MW[51]) +                                                           ; Number of transfers
              COEFF_COST * {InflationFare} * (MW[54]) +                                         ; Transit fare
@isNHB@       COEFF_DCBD_WALK * (ZI.1.CBD_DUMMY[I] + ZI.1.CBD_DUMMY[J]) +                       ; CBD dummy (NHB)
@noNHB@       COEFF_DCBD_WALK * ZI.1.CBD_DUMMY[J] +                                             ; CBD dummy
              COEFF_DEXUP * ZI.1.EXU_DUMMY[I] +                                                 ; Exurban production dummy
              COEFF_DEXUA * ZI.1.EXU_DUMMY[J]                                                   ; Exurban attraction dummy

  ;   PNR ACCESS - BUS ELEMENTS OF UTILITY ARE:
      MW[306]=COEFF_OVT * (MW[61] + MW[63]) +                                                   ; Walk & transfer time
              COEFF_OVT * (MW[72] + MW[73]) +                                                   ; Initial & transfer wait
              COEFF_IVTT * (MW[62]) +                                                           ; Auto access time
              COEFF_IVTT * (MW[64] + MW[65] + MW[66] + MW[67] + MW[68] + MW[69] + MW[70]) +     ; IVTT
              COEFF_XFER * (MW[71]) +                                                           ; Number of transfers
              COEFF_COST * {InflationFare} * (MW[74]) +                                         ; Transit fare
@isNHB@       COEFF_DCBD_PNR * (ZI.1.CBD_DUMMY[I] + ZI.1.CBD_DUMMY[J]) +                        ; CBD dummy (NHB)
@noNHB@       COEFF_DCBD_PNR * ZI.1.CBD_DUMMY[J] +                                              ; CBD dummy
              COEFF_DEXUP * ZI.1.EXU_DUMMY[I] +                                                 ; Exurban production dummy
              COEFF_DEXUA * ZI.1.EXU_DUMMY[J]                                                   ; Exurban attraction dummy

  ;   PNR ACCESS - PROJECT ELEMENTS OF UTILITY ARE:
      MW[307]=COEFF_OVT * (MW[81] + MW[83]) +                                                   ; Walk & transfer time
              COEFF_OVT * (MW[92] + MW[93]) +                                                   ; Initial & transfer wait
              COEFF_IVTT * (MW[82]) +                                                           ; Auto access time
              COEFF_IVTT * (MW[84] + MW[85] + MW[86] + MW[87] + MW[88] + MW[89] + MW[90]) +     ; IVTT
              COEFF_XFER * (MW[91]) +                                                           ; Number of transfers
              COEFF_COST * {InflationFare} * (MW[94]) +                                         ; Transit fare
@isNHB@       COEFF_DCBD_PNR * (ZI.1.CBD_DUMMY[I] + ZI.1.CBD_DUMMY[J]) +                        ; CBD dummy (NHB)
@noNHB@       COEFF_DCBD_PNR * ZI.1.CBD_DUMMY[J] +                                              ; CBD dummy
              COEFF_DEXUP * ZI.1.EXU_DUMMY[I] +                                                 ; Exurban production dummy
              COEFF_DEXUA * ZI.1.EXU_DUMMY[J]                                                   ; Exurban attraction dummy

  ;   KNR ACCESS - BUS ELEMENTS OF UTILITY ARE:
      MW[308]=COEFF_OVT * (MW[61] + MW[63]) +                                                 ; Walk & transfer time
              COEFF_OVT * (MW[72] + MW[73]) +                                                 ; Initial & transfer wait
              COEFF_IVTT * (MW[62]-({InflationFare}*(COEFF(1,4)/COEFF(1,1))*MW[291])+(COEFF(1,3)/COEFF(1,1))*(-mw[292]+mw[293])) +                                 ; Auto access time
              COEFF_IVTT * (MW[64] + MW[65] + MW[66] + MW[67] + MW[68] + MW[69] + MW[70]) +    ; IVTT
              COEFF_XFER * (MW[71]) +                                                          ; Number of transfers
              COEFF_COST * {InflationFare} * (MW[74]) +                                        ; Transit fare
@isNHB@       COEFF_DCBD_KNR * (ZI.1.CBD_DUMMY[I] + ZI.1.CBD_DUMMY[J]) +                        ; CBD dummy (NHB)
@noNHB@       COEFF_DCBD_KNR * ZI.1.CBD_DUMMY[J] +                                              ; CBD dummy
              COEFF_DEXUP * ZI.1.EXU_DUMMY[I] +                                                 ; Exurban production dummy
              COEFF_DEXUA * ZI.1.EXU_DUMMY[J]                                                   ; Exurban attraction dummy

  ;   KNR ACCESS - PROJECT ELEMENTS OF UTILITY ARE:
      MW[309]=COEFF_OVT * (MW[81] + MW[83]) +                                                 ; Walk & transfer time
              COEFF_OVT * (MW[92] + MW[93]) +                                                 ; Initial & transfer wait
              COEFF_IVTT * (MW[82]-({InflationFare}*(COEFF(1,4)/COEFF(1,1))*MW[295])+(COEFF(1,3)/COEFF(1,1))*(-mw[296]+mw[297])) +                                  ; Auto access time
              COEFF_IVTT * (MW[84] + MW[85] + MW[86] + MW[87] + MW[88] + MW[89] + MW[90]) +    ; IVTT
              COEFF_XFER * (MW[91]) +                                                          ; Number of transfers
              COEFF_COST * {InflationFare} * (MW[94]) +                                        ; Transit fare
@isNHB@       COEFF_DCBD_KNR * (ZI.1.CBD_DUMMY[I] + ZI.1.CBD_DUMMY[J]) +                        ; CBD dummy (NHB)
@noNHB@       COEFF_DCBD_KNR * ZI.1.CBD_DUMMY[J] +                                              ; CBD dummy
              COEFF_DEXUP * ZI.1.EXU_DUMMY[I] +                                                 ; Exurban production dummy
              COEFF_DEXUA * ZI.1.EXU_DUMMY[J]                                                   ; Exurban attraction dummy

;******************************** END UTILITY CALCULATIONS ************************************

      JLOOP
; For PNR paths, determine the parking zone. This is used to get the station parking cost for NHB paths, as
;               we need to add in the other half of station parking costs.
; Check if the IVT times on the transit path exist (this avoids having a jloop in the utility calculations)
        IF ((MW[24] + MW[26]) == 0) MW[304]=-9999.99                                                                       ; walk-bus path
        IF ((MW[45] + MW[47] + MW[48] + MW[49] + MW[50]) == 0) MW[305]=-9999.99                                            ; walk-proj path
        IF ((MW[64] + MW[66]) == 0)                                                                                        ; pnr-bus path
          MW[306]=-9999.99
        ELSE
@isNHB@   MW[306]=MW[306] + COEFF_COST * ((({InflationFare}*mw[291])/{OCCPNRAccess})/2.0)                             ; add in other half of NHB PNR parking cost
        ENDIF
        IF ((MW[85] + MW[87] + MW[88] + MW[89] + MW[90]) == 0)                                                             ; pnr proj path
          MW[307]=-9999.99
        ELSE
@isNHB@   MW[307]=MW[307] + COEFF_COST * ((({InflationFARE}*mw[295])/{OCCPNRAccess})/2.0)                             ; add in other half of NHB PNR parking cost
        ENDIF

        IF ((MW[64] + MW[66]) == 0) MW[308]=-9999.99                                                                     ; knr bus path
        IF ((MW[85] + MW[87] + MW[88] + MW[89] + MW[90]) == 0) MW[309]=-9999.99                                       ; knr proj path

 ; Minimum distance criteria on paths
        IF (MW[2] < {MinDistWalkAcc})
                MW[304]=-9999.99
                MW[305]=-9999.99
        ENDIF
        IF (MW[2] < {MinDistAutoAcc})
                MW[306]=-9999.99
                MW[307]=-9999.99
                MW[308]=-9999.99
                MW[309]=-9999.99
        ENDIF
; NOTE: no min distance criteria for fringe parking
; For PNR paths, determine the parking zone. This is used to get the station parking cost for NHB paths, as
; We need to add in the other half of station parking costs.
 ; debug report
        if (ACC=1 & ({DebugMC} > 0) && (I={SelOrigin}) && (J={SelDest}))
         print list='\n\nPercent walk at Production zone               ',(ZI.1.PCWPRD@PERIOD@[I] * 0.01),printo=1
         print list='Percent walk at Attraction zone               ',(ZI.1.PCWPRD@PERIOD@[J] * 0.01),printo=1
         print list='Percent 0 car household at Production zone    ',ZI.1.PERCAUTO0[I],printo=1
         print list='Percent 1 car household at Production zone    ',ZI.1.PERCAUTO1[I],printo=1
         print list='Percent 2 car household at Production zone    ',ZI.1.PERCAUTO2[I],printo=1
       endif
      ENDJLOOP

;******************************** FINAL UTILITY CALCULATIONS ************************************
  ;   COMPOSITE UTILITY for drive alone
      MW[401]=(MW[301]+K_DA_AUTO0)/NC_DriveAlone
      MW[421]=(MW[301]+K_DA_AUTO1)/NC_DriveAlone
      MW[441]=(MW[301]+K_DA_AUTO2)/NC_DriveAlone
  ;   COMPOSITE UTILITY for shared ride 2
      MW[402]=(MW[302]+K_SR1PASS_AUTO0)/NC_SharedRide
      MW[422]=(MW[302]+K_SR1PASS_AUTO1)/NC_SharedRide
      MW[442]=(MW[302]+K_SR1PASS_AUTO2)/NC_SharedRide
  ;   COMPOSITE UTILITY for shared ride 2+
      MW[403]=(MW[303]+K_SR2PASS_AUTO0)/NC_SharedRide
      MW[423]=(MW[303]+K_SR2PASS_AUTO1)/NC_SharedRide
      MW[443]=(MW[303]+K_SR2PASS_AUTO2)/NC_SharedRide
  ;   COMPOSITE UTILITY for walk to bus
      MW[404]=((MW[304]+K_WALKBUS_AUTO0)/NC_WALKBUS + walk_acc_dum)
      MW[424]=((MW[304]+K_WALKBUS_AUTO1)/NC_WALKBUS + walk_acc_dum)
      MW[444]=((MW[304]+K_WALKBUS_AUTO2)/NC_WALKBUS + walk_acc_dum)
  ;   COMPOSITE UTILITY for walk to project
      MW[405]=((MW[305]+K_WALKPRJ_AUTO0)/NC_WALKPRJ + walk_acc_dum)
      MW[425]=((MW[305]+K_WALKPRJ_AUTO1)/NC_WALKPRJ + walk_acc_dum)
      MW[445]=((MW[305]+K_WALKPRJ_AUTO2)/NC_WALKPRJ + walk_acc_dum)
  ;   COMPOSITE UTILITY for PNR to bus
      MW[406]=((MW[306]+K_PNRBUS_AUTO0)/NC_PNRBus + auto_acc_dum)
      MW[426]=((MW[306]+K_PNRBUS_AUTO1)/NC_PNRBus + auto_acc_dum)

      MW[446]=((MW[306]+K_PNRBUS_AUTO2)/NC_PNRBus + auto_acc_dum)
  ;   COMPOSITE UTILITY for PNR to project
      MW[407]=((MW[307]+K_PNRPRJ_AUTO0)/NC_PNRPrj + auto_acc_dum)
      MW[427]=((MW[307]+K_PNRPRJ_AUTO1)/NC_PNRPrj + auto_acc_dum)
      MW[447]=((MW[307]+K_PNRPRJ_AUTO2)/NC_PNRPrj + auto_acc_dum)
  ;   COMPOSITE UTILITY for KNR to bus
      MW[408]=((MW[308]+K_KNRBUS_AUTO0)/NC_KNRBus + auto_acc_dum)
      MW[428]=((MW[308]+K_KNRBUS_AUTO1)/NC_KNRBus + auto_acc_dum)
      MW[448]=((MW[308]+K_KNRBUS_AUTO2)/NC_KNRBus + auto_acc_dum)
  ;   COMPOSITE UTILITY for KNR to project
      MW[409]=((MW[309]+K_KNRPRJ_AUTO0)/NC_KNRPrj + auto_acc_dum)
      MW[429]=((MW[309]+K_KNRPRJ_AUTO1)/NC_KNRPrj + auto_acc_dum)
      MW[449]=((MW[309]+K_KNRPRJ_AUTO2)/NC_KNRPrj + auto_acc_dum)

; use ZAPZERO here to zero out the drive alone and PNR access trips for zero-car households
      if ( ({ZAPZERO} = 1) && (('@PURP@'=='HBW') || ('@PURP@'=='HBO')) )
        MW[401] = -9999.99     ; drive alone for 0car households
        MW[406] = -9999.99     ; PNR-bus trips for 0car households
        MW[407] = -9999.99     ; PNR-prj trips for 0car households
     endif

 JLOOP
 if (ACC=1-3)
  if (({DebugMC} > 0) && (I={SelOrigin}) && (J={SelDest}))
   print list='\n\n********************************************************************************************', printo=1
   print list=' Access Type: ',ACC(1.0),'. ',ACC_NAME, printo=1
   print list='********************************************************************************************','\n' printo=1
   print list='Value of CBD dummy at attraction-end (1 or 0)                     ',ZI.1.CBD_DUMMY[J],printo=1
   print list='Value of EXURBAN dummy at production-end (1 or 0)                 ',ZI.1.EXU_DUMMY[I],printo=1
   print list='Value of EXURBAN dummy at attraction-end (1 or 0)                 ',ZI.1.EXU_DUMMY[J],printo=1

   print list='\n\n\nElements used in Drive Alone disutility calculations: ***************************', printo=1
   print list='In-Vehicle time                                                   ',MW[3][J],printo=1
   print list='Out of Vehicle time (Terminal time at production-end)             ',ZI.1.TERMTIME[I],printo=1
   print list='Out of Vehicle time (Terminal time at attraction-end)             ',ZI.1.TERMTIME[J],printo=1
   print list='Parking Cost                                                      ',ZI.1.@PRK@[J],printo=1
   print list='Highway Distance (in miles)                                       ',MW[2][J],printo=1
   print list='Highway Toll (in $)                                               ',MW[1][J],printo=1
   print list='\nDrive alone disutility                                          ',MW[301][J](12.4),printo=1
   print list='\nDrive alone composite disutility (0 car)                        ',MW[401][J](12.4),printo=1
   print list='Drive alone composite disutility (1 car)                        ',MW[421][J](12.4),printo=1
   print list='Drive alone composite disutility (2 car)                        ',MW[441][J](12.4),printo=1
   print list='\nExponentiated drive alone composite disutility (0 car)        ',exp(MW[401][J])(14.12),printo=1
   print list='Exponentiated drive alone composite disutility (1 car)        ',exp(MW[421][J])(14.12),printo=1
   print list='Exponentiated drive alone composite disutility (2 car)        ',exp(MW[441][J])(14.12),printo=1

   print list='\n\n\nElements used in Shared Ride 2 disutility calculations: ***************************', printo=1
   print list='In-Vehicle time                                                   ',MW[3][J],printo=1
   print list='In-Vehicle time savings by using HOV lanes                        ',MAX((MW[7][J]-MW[3][J]), 0),printo=1
   print list='Out of Vehicle time (Terminal time at production-end)             ',ZI.1.TERMTIME[I],printo=1
   print list='Out of Vehicle time (Terminal time at attraction-end)             ',ZI.1.TERMTIME[J],printo=1
   print list='Parking Cost                                                      ',ZI.1.@PRK@[J],printo=1
   print list='Highway Distance (in miles)                                       ',MW[6][J],printo=1
   print list='Highway Toll (in $)                                               ',MW[1][J],printo=1
   print list='\nShared ride 2 disutility                                        ',MW[302][J](12.4),printo=1
   print list='\nShared ride 2 composite disutility (0 car)                      ',MW[402][J](12.4),printo=1
   print list='Shared ride 2 composite disutility (1 car)                      ',MW[422][J](12.4),printo=1
   print list='Shared ride 2 composite disutility (2 car)                      ',MW[442][J](12.4),printo=1
   print list='\nExponentiated shared ride composite disutility (0 car)        ',exp(MW[402][J])(14.12),printo=1
   print list='Exponentiated shared ride 2 composite disutility (1 car)      ',exp(MW[422][J])(14.12),printo=1
   print list='Exponentiated shared ride 2 composite disutility (2 car)      ',exp(MW[442][J])(14.12),printo=1

   print list='\n\n\nElements used in Shared Ride 2+ disutility calculations: ***************************', printo=1
   print list='In-Vehicle time                                                   ',MW[3][J],printo=1
   print list='In-Vehicle time savings by using HOV lanes                        ',MAX((MW[7][J]-MW[3][J]), 0),printo=1
   print list='Out of Vehicle time (Terminal time at production-end)             ',ZI.1.TERMTIME[I],printo=1
   print list='Out of Vehicle time (Terminal time at attraction-end)             ',ZI.1.TERMTIME[J],printo=1
   print list='Parking Cost                                                      ',ZI.1.@PRK@[J],printo=1
   print list='Highway Distance (in miles)                                       ',MW[6][J],printo=1
   print list='Occupancy rate for 2+ car market                                  ',@OCC3@,printo=1
   print list='Highway Toll (in $)                                               ',MW[1][J],printo=1
   print list='\nShared ride 2+ disutility                                       ',MW[303][J](12.4),printo=1
   print list='\nShared ride 2+ composite disutility (0 car)                     ',MW[403][J](12.4),printo=1
   print list='Shared ride 2+ composite disutility (1 car)                     ',MW[423][J](12.4),printo=1
   print list='Shared ride 2+ composite disutility (2 car)                     ',MW[443][J](12.4),printo=1
   print list='\nExponentiated shared ride 2+ composite disutility (0 car)     ',exp(MW[403][J])(14.12),printo=1
   print list='Exponentiated shared ride 2+ composite disutility (1 car)     ',exp(MW[423][J])(14.12),printo=1
   print list='Exponentiated shared ride 2+ composite disutility (2 car)     ',exp(MW[443][J])(14.12),printo=1

   print list='\n\n\nElements used in Walk Bus disutility calculations: ***************************', printo=1
   print list='In-Vehicle time (Bus)                                             ',MW[24][J],printo=1
   print list='In-Vehicle time (PRJ Bus)                                         ',MW[25][J],printo=1
   print list='In-Vehicle time (Circulator)                                      ',MW[26][J],printo=1
   print list='In-Vehicle time (Rail)                                            ',(MW[27][J]+MW[28][J]),printo=1
   print list='In-Vehicle time (Project Mode)                                    ',MW[30][J],printo=1
   print list='Out of Vehicle time (Walk)                                        ',MW[21][J],printo=1
   print list='Out of Vehicle time (Transfer Walk)                               ',MW[23][J],printo=1
   print list='Out of Vehicle time (IWAIT)                                       ',MW[32][J],printo=1
   print list='Out of Vehicle time (XWAIT)                                       ',MW[33][J],printo=1
   print list='Number of transfers                                               ',MW[31][J],printo=1
   print list='Transit Fare (in cents)                                           ',MW[34][J],printo=1
   print list='\nWalk Bus disutility                                             ',MW[304][J](12.4),printo=1
   print list='Walk access dummy (added to the utility)                          ',walk_acc_dum,printo=1
   print list='\nWalk Bus composite disutility (0 car)                           ',MW[404][J](12.4),printo=1
   print list='Walk Bus composite disutility (1 car)                           ',MW[424][J](12.4),printo=1
   print list='Walk Bus composite disutility (2+ car)                          ',MW[444][J](12.4),printo=1
   print list='\nExponentiated walk bus composite disutility (0 car)           ',exp(MW[404][J])(14.12),printo=1
   print list='Exponentiated walk bus composite disutility (1 car)           ',exp(MW[424][J])(14.12),printo=1
   print list='Exponentiated walk bus composite disutility (2 car)           ',exp(MW[444][J])(14.12),printo=1

   print list='\n\n\nElements used in Walk Prj disutility calculations: ***************************', printo=1
   print list='In-Vehicle time (Bus)                                             ',MW[44][J],printo=1
   print list='In-Vehicle time (PRJ Bus)                                         ',MW[45][J],printo=1
   print list='In-Vehicle time (Circulator)                                      ',MW[46][J],printo=1
   print list='In-Vehicle time (Rail)                                            ',(MW[47][J]+MW[48][J]),printo=1
   print list='In-Vehicle time (Project Mode)                                    ',MW[50][J],printo=1
   print list='Out of Vehicle time (Walk)                                        ',MW[41][J],printo=1
   print list='Out of Vehicle time (Transfer Walk)                               ',MW[43][J],printo=1
   print list='Out of Vehicle time (IWAIT)                                       ',MW[52][J],printo=1
   print list='Out of Vehicle time (XWAIT)                                       ',MW[53][J],printo=1
   print list='Number of transfers                                               ',MW[51][J],printo=1
   print list='Transit Fare (in cents)                                           ',MW[54][J],printo=1
   print list='\nWalk Prj disutility                                             ',MW[305][J](12.4),printo=1
   print list='Walk access dummy (added to the utility)                          ',walk_acc_dum,printo=1
   print list='\nWalk Prj composite disutility (0 car)                           ',MW[405][J](12.4),printo=1
   print list='Walk Prj composite disutility (1 car)                           ',MW[425][J](12.4),printo=1
   print list='Walk Prj composite disutility (2 car)                           ',MW[445][J](12.4),printo=1
   print list='\nExponentiated walk prj composite disutility (0 car)           ',exp(MW[405][J])(14.12),printo=1
   print list='Exponentiated walk prj composite disutility (1 car)           ',exp(MW[425][J])(14.12),printo=1
   print list='Exponentiated walk prj composite disutility (2 car)           ',exp(MW[445][J])(14.12),printo=1

   print list='\n\n\nElements used in PNR Bus disutility calculations: ***************************', printo=1
   print list='In-Vehicle time (Bus)                                             ',MW[64][J],printo=1
   print list='In-Vehicle time (PRJ Bus)                                         ',MW[65][J],printo=1
   print list='In-Vehicle time (Circulator)                                      ',MW[66][J],printo=1
   print list='In-Vehicle time (Rail)                                            ',(MW[67][J]+MW[68][J]),printo=1
   print list='In-Vehicle time (Project Mode)                                    ',MW[70][J],printo=1
   print list='Out of Vehicle time (Walk)                                        ',MW[61][J],printo=1
   print list='Out of Vehicle time (Auto access time in IVT min - weighted)      ',MW[62][J],printo=1
   print list='Out of Vehicle time (Transfer Walk)                               ',MW[63][J],printo=1
   print list='Out of Vehicle time (IWAIT)                                       ',MW[72][J],printo=1
   print list='Out of Vehicle time (XWAIT)                                       ',MW[73][J],printo=1
   print list='Number of transfers                                               ',MW[71][J],printo=1
   print list='Transit Fare (in cents)                                           ',MW[74][J],printo=1
   print list='\nPNR Bus disutility                                              ',MW[306][J](12.4),printo=1
   print list='Auto access dummy (added to the utility)                          ',auto_acc_dum,printo=1
   print list='\nPNR Bus composite disutility (0 car)                            ',MW[406][J](12.4),printo=1
   print list='PNR Bus composite disutility (1 car)                            ',MW[426][J](12.4),printo=1
   print list='PNR Bus composite disutility (2 car)                            ',MW[446][J](12.4),printo=1
   print list='\nExponentiated PNR Bus composite disutility (0 car)            ',exp(MW[406][J])(14.12),printo=1
   print list='Exponentiated PNR Bus composite disutility (1 car)            ',exp(MW[426][J])(14.12),printo=1
   print list='Exponentiated PNR Bus composite disutility (2 car)            ',exp(MW[446][J])(14.12),printo=1

   print list='\n\n\nElements used in PNR Prj disutility calculations: ***************************', printo=1
   print list='In-Vehicle time (Bus)                                             ',MW[84][J],printo=1
   print list='In-Vehicle time (PRJ Bus)                                         ',MW[85][J],printo=1
   print list='In-Vehicle time (Circulator)                                      ',MW[86][J],printo=1
   print list='In-Vehicle time (Rail)                                            ',(MW[87][J]+MW[88][J]),printo=1
   print list='In-Vehicle time (Project Mode)                                    ',MW[90][J],printo=1
   print list='Out of Vehicle time (Walk)                                        ',MW[81][J],printo=1
   print list='Out of Vehicle time (Auto access time in IVT min)                 ',MW[82][J],printo=1
   print list='Out of Vehicle time (Transfer Walk)                               ',MW[83][J],printo=1
   print list='Out of Vehicle time (IWAIT)                                       ',MW[92][J],printo=1
   print list='Out of Vehicle time (XWAIT)                                       ',MW[93][J],printo=1
   print list='Number of transfers                                               ',MW[91][J],printo=1
   print list='Transit Fare (in cents)                                           ',MW[94][J],printo=1
   print list='\nPNR Prj disutility                                              ',MW[307][J](12.4),printo=1
   print list='Auto access dummy (added to the utility)                          ',auto_acc_dum,printo=1
   print list='\nPNR Prj composite disutility (0 car)                            ',MW[407][J](12.4),printo=1
   print list='PNR Prj composite disutility (1 car)                            ',MW[427][J](12.4),printo=1
   print list='PNR Prj composite disutility (2 car)                            ',MW[447][J](12.4),printo=1
   print list='\nExponentiated PNR prj composite disutility (0 car)            ',exp(MW[407][J])(14.12),printo=1
   print list='Exponentiated PNR prj composite disutility (1 car)            ',exp(MW[427][J])(14.12),printo=1
   print list='Exponentiated PNR prj composite disutility (2 car)            ',exp(MW[447][J])(14.12),printo=1

   print list='\n\n\nElements used in KNR Bus disutility calculations: ***************************', printo=1
   print list='In-Vehicle time (Bus)                                             ',MW[64][J],printo=1
   print list='In-Vehicle time (Circulator)                                      ',MW[66][J],printo=1
   print list='In-Vehicle time (Rail)                                            ',(MW[67][J]+MW[108][J]),printo=1
   print list='In-Vehicle time (Project Mode)                                    ',MW[70][J],printo=1
   print list='Out of Vehicle time (Walk)                                        ',MW[61][J],printo=1
   print list='Out of Vehicle time (Auto access time in IVT min)                 ',MW[62][J],printo=1
   print list='Out of Vehicle time (Transfer Walk)                               ',MW[63][J],printo=1
   print list='Out of Vehicle time (IWAIT)                                       ',MW[62][J],printo=1
   print list='Out of Vehicle time (XWAIT)                                       ',MW[73][J],printo=1
   print list='Transit Fare (in cents)                                           ',MW[74][J],printo=1
   print list='\nKNR Bus disutility                                              ',MW[308][J](12.4),printo=1
   print list='Auto access dummy (added to the utility)                          ',auto_acc_dum,printo=1
   print list='\nKNR Bus composite disutility (0 car)                            ',MW[408][J](12.4),printo=1
   print list='KNR Bus composite disutility (1 car)                            ',MW[428][J](12.4),printo=1
   print list='KNR Bus composite disutility (2 car)                            ',MW[448][J](12.4),printo=1
   print list='\nExponentiated KNR Bus composite disutility (0 car)            ',exp(MW[408][J])(14.12),printo=1
   print list='Exponentiated KNR Bus composite disutility (1 car)            ',exp(MW[428][J])(14.12),printo=1
   print list='Exponentiated KNR Bus composite disutility (2 car)            ',exp(MW[448][J])(14.12),printo=1
   print list='PNR Parking Cost                                                  ',(COEFF(1,4)/COEFF(1,1))*MW[291][J],printo=1
   print list='Terminal time difference between PNR and KNR                      ',(COEFF(1,3)/COEFF(1,1))*(-mw[292][J]+mw[293][J]),printo=1
   print list='Weighted time on the KNR connector                                ',(MW[62][J]-({InflationFare}*(COEFF(1,4)/COEFF(1,1))*MW[291][J])+(COEFF(1,3)/COEFF(1,1))*(-mw[292][J]+mw[293][J])),printo=1

   print list='\n\n\nElements used in KNR Prj disutility calculations: ***************************', printo=1
   print list='In-Vehicle time (Bus)                                             ',MW[84][J],printo=1
   print list='In-Vehicle time (PRJ Bus)                                         ',MW[85][J],printo=1
   print list='In-Vehicle time (Circulator)                                      ',MW[86][J],printo=1
   print list='In-Vehicle time (Rail)                                            ',(MW[87][J]+MW[128][J]),printo=1
   print list='In-Vehicle time (Project Mode)                                    ',MW[90][J],printo=1
   print list='Out of Vehicle time (Walk)                                        ',MW[81][J],printo=1
   print list='Out of Vehicle time (Auto access time in IVT min)                 ',MW[82][J],printo=1
   print list='Out of Vehicle time (Transfer Walk)                               ',MW[83][J],printo=1
   print list='Out of Vehicle time (IWAIT)                                       ',MW[92][J],printo=1
   print list='Out of Vehicle time (XWAIT)                                       ',MW[93][J],printo=1
   print list='Number of transfers                                               ',MW[91][J],printo=1
   print list='Transit Fare (in cents)                                           ',MW[94][J],printo=1
   print list='Auto access dummy (added to the utility)                          ',auto_acc_dum,printo=1
   print list='\nKNR Prj composite disutility (0 car)                            ',MW[409][J](12.4),printo=1
   print list='KNR Prj composite disutility (1 car)                            ',MW[429][J](12.4),printo=1
   print list='KNR Prj composite disutility (2 car)                            ',MW[449][J](12.4),printo=1
   print list='\nExponentiated KNR prj composite disutility (0 car)            ',exp(MW[409][J])(14.12),printo=1
   print list='Exponentiated KNR prj composite disutility (2 car)            ',exp(MW[449][J])(14.12),printo=1

  endif
 endif
 ENDJLOOP

; ############################# XCHOICE SETUP ###################################

; AUTO0
      DMD=260+ACC
      XCHOICE ALTERNATIVES=da,hov2,hov3,walkbus,walkprj,pnrbus,pnrprj,knrbus,knrprj,
      UTILITIESMW=401,402,403,404,405,406,407,408,409,
      DEMANDMW=DMD,
      ODEMANDMW=501,502,503,504,505,506,507,508,509,,
      STARTMW=900,
;     Model Structure
;     Top level nest
      SPLIT=Total NC_AUTO Auto NC_TRN Transit,
;     Auto nest
      SPLIT=Auto 1.0 da NC_AUTOSR hov, SPLITCOMP=36,
;     HOV nest
      SPLIT=hov 1.0 hov2 1.0 hov3,
;     Transit nest
      SPLIT= Transit NC_TRNAC Walk NC_TRNAC PNR NC_TRNAC KNR,
;     Walk nest
      SPLIT= Walk 1.0 walkbus 1.0 walkprj,
;     PNR nest
      SPLIT= PNR 1.0 pnrbus 1.0 pnrprj,
;     KNR nest
      SPLIT= KNR 1.0 knrbus 1.0 knrprj

; AUTO1
      DMD=263+ACC
      XCHOICE ALTERNATIVES=da,hov2,hov3,walkbus,walkprj,pnrbus,pnrprj,knrbus,knrprj,
      UTILITIESMW=421,422,423,424,425,426,427,428,429,
      DEMANDMW=DMD,
      ODEMANDMW=521,522,523,524,525,526,527,528,529,
      STARTMW=900,
;     Model Structure
;     Top level nest
      SPLIT=Total NC_AUTO Auto NC_TRN Transit,
;     Auto nest
      SPLIT=Auto 1.0 da NC_AUTOSR hov, SPLITCOMP=37,
;     HOV nest
      SPLIT=hov 1.0 hov2 1.0 hov3,
;     Transit nest
      SPLIT= Transit NC_TRNAC Walk NC_TRNAC PNR NC_TRNAC KNR,
;     Walk nest
      SPLIT= Walk 1.0 walkbus 1.0 walkprj,
;     PNR nest
      SPLIT= PNR 1.0 pnrbus 1.0 pnrprj,
;     KNR nest
      SPLIT= KNR 1.0 knrbus 1.0 knrprj


; AUTO2
      DMD=266+ACC
      XCHOICE ALTERNATIVES=da,hov2,hov3,walkbus,walkprj,pnrbus,pnrprj,knrbus,knrprj,
      UTILITIESMW=441,442,443,444,445,446,447,448,449,
      DEMANDMW=DMD,
      ODEMANDMW=541,542,543,544,545,546,547,548,549,
      STARTMW=900,
;     Model Structure
;     Top level nest
      SPLIT=Total NC_AUTO Auto NC_TRN Transit,
;     Auto nest
      SPLIT=Auto 1.0 da NC_AUTOSR hov, SPLITCOMP=38,
;     HOV nest
      SPLIT=hov 1.0 hov2 1.0 hov3,
;     Transit nest
      SPLIT= Transit NC_TRNAC Walk NC_TRNAC PNR NC_TRNAC KNR,
;     Walk nest
      SPLIT= Walk 1.0 walkbus 1.0 walkprj,
;     PNR nest
      SPLIT= PNR 1.0 pnrbus 1.0 pnrprj,
;     KNR nest
      SPLIT= KNR 1.0 knrbus 1.0 knrprj

; user benefit table - exponentiated auto utility
      MW[56]=exp(NC_AUTOSR * MW[36])
      MW[57]=exp(NC_AUTOSR * MW[37])
      MW[58]=exp(NC_AUTOSR * MW[38])

; Aggregate trips for all access categories (can walk, must drive and no transit)
; For example... MW[601]=MW[601]+MW[501]
;                MW[621]=MW[621]+MW[521]

      LOOP MARKET=1,3
       LOOP CHOICE=1,9
        _idx1 = 600+CHOICE+(MARKET-1)*20
        _idx2 = 500+CHOICE+(MARKET-1)*20
        COMP total = ROWADD(_idx1,_idx1,_idx2)     ; refer to xchoice.prn for MW listing
        _idx3 = 700+CHOICE+(MARKET-1)*9+(ACC-1)*27
        COMP total = ROWADD(_idx3,_idx2)
       ENDLOOP
      ENDLOOP

; ############################################ END XCHOICE #################################

 ; now some debuging
   LOOP MARKET=1,3
    if (MARKET=1) MARKET_NAME='Zero Car HHs     '
    if (MARKET=2) MARKET_NAME='One Car HHs      '
    if (MARKET=3) MARKET_NAME='Two+ Car HHs     '

    _cnt=(MARKET-1)*20
    _cnt1=260+ACC+(MARKET-1)*3
    M1=501+_cnt,M2=502+_cnt,M3=503+_cnt,M4=504+_cnt,M5=505+_cnt,M6=506+_cnt,M7=507+_cnt,M8=508+_cnt,M9=509+_cnt;,M12=512+_cnt

    IF ({DebugMC}>0)
     JLOOP
      if ((I={SelOrigin}) && (J={SelDest}))

; ################### SHARES (HAND CALCULATION - check it against XCHOICE RESULTS) ###########################################
       _konn = 0.0000000000000001

       print list='\n\nMARKET:           ',MARKET_NAME,printo=1
       print list='***************************************************',printo=1
       if ((exp(MW[404+_cnt][J])+exp(MW[405+_cnt][J]))>_konn)
         shrwkb=exp(MW[404+_cnt][J])/(exp(MW[404+_cnt][J])+exp(MW[405+_cnt][J]))
         shrwkp=exp(MW[405+_cnt][J])/(exp(MW[404+_cnt][J])+exp(MW[405+_cnt][J]))
         eutilwk=exp(NC_TRNAC*ln(exp(MW[404+_cnt][J])+exp(MW[405+_cnt][J])))
       else
         shrwkb=0
         shrwkp=0
         eutilwk=0
       endif
       print list='\nExponentiated Walk mode nest disutility       ',eutilwk(14.12),printo=1
       ; PNR mode nest
       if ((exp(MW[406+_cnt][J])+exp(MW[407+_cnt][J]))>_konn)
         shrpnrb=exp(MW[406+_cnt][J])/(exp(MW[406+_cnt][J])+exp(MW[407+_cnt][J]))
         shrpnrp=exp(MW[407+_cnt][J])/(exp(MW[406+_cnt][J])+exp(MW[407+_cnt][J]))
         eutilpnr=exp(NC_TRNAC*ln(exp(MW[406+_cnt][J])+exp(MW[407+_cnt][J])))
       else
         shrpnrb=0
         shrpnrp=0
         eutilpnr=0
       endif
       print list='\nExponentiated PNR mode nest disutility        ',eutilpnr(14.12),printo=1
       ; KNR mode nest
       if ((exp(MW[408+_cnt][J])+exp(MW[409+_cnt][J]))>_konn)
         shrknrb=exp(MW[408+_cnt][J])/(exp(MW[408+_cnt][J])+exp(MW[409+_cnt][J]))
         shrknrp=exp(MW[409+_cnt][J])/(exp(MW[408+_cnt][J])+exp(MW[409+_cnt][J]))
         eutilknr=exp(NC_TRNAC*ln(exp(MW[408+_cnt][J])+exp(MW[409+_cnt][J])))
       else
         shrknrb=0
         shrknrp=0
         eutilknr=0
       endif
       print list='\nExponentiated KNR mode nest disutility        ',eutilknr(14.12),printo=1
         if ((eutilwk+eutilpnr+eutilknr)>_konn))

         shrwkt=eutilwk/(eutilwk+eutilpnr+eutilknr)

         shrpnrt=eutilpnr/(eutilwk+eutilpnr+eutilknr)
         shrknrt=eutilknr/(eutilwk+eutilpnr+eutilknr)

         eutilt=exp(NC_TRN*ln(eutilwk+eutilpnr+eutilknr))
       else
         shrwkt=0
         shrpnrt=0
         shrknrt=0

         eutilt=0
       endif
       print list='\nExponentiated Transit disutility              ',eutilt(14.12),printo=1
       ; hov nest
       if ((exp(MW[402+_cnt][J])+exp(MW[403+_cnt][J]))>_konn)
         shrhov2sr=exp(MW[402+_cnt][J])/(exp(MW[402+_cnt][J])+exp(MW[403+_cnt][J]))
         shrhov3sr=exp(MW[403+_cnt][J])/(exp(MW[402+_cnt][J])+exp(MW[403+_cnt][J]))
         eutilsr=exp(NC_AUTOSR*ln(exp(MW[402+_cnt][J])+exp(MW[403+_cnt][J])))
       else
         shrhov2sr=0
         shrhov3sr=0
         eutilsr=0
       endif
       ; auto nest
       if ((exp(MW[401+_cnt][J])+eutilsr)>_konn)
         shrdaa=exp(MW[401+_cnt][J])/(exp(MW[401+_cnt][J])+eutilsr)
         shrsra=eutilsr/(exp(MW[401+_cnt][J])+eutilsr)
         eutila=exp(NC_AUTO*ln(exp(MW[401+_cnt][J])+eutilsr))
       else
         shrdaa=0
         shrsra=0
         eutila=0
       endif
       print list='\nExponentiated Auto disutility                 ',eutila(14.12),printo=1
       ; top nest
       if ((eutila+eutilt)>_konn)
         shra=eutila/(eutila+eutilt)
         shrt=eutilt/(eutila+eutilt)
         eutil=(eutila+eutilt)
       else
         shra=0
         shrt=0

         eutil=0
       endif
       print list='\nExponentiated total disutility                ',eutil(14.12),printo=1
       ; individual shares
       shrda=shrdaa*shra
       shrhov2=shrhov2sr*shrsra*shra
       shrhov3=shrhov3sr*shrsra*shra
       shrwalkbus=shrwkb*shrwkt*shrt
       shrwalkprj=shrwkp*shrwkt*shrt
       shrpnrbus=shrpnrb*shrpnrt*shrt
       shrpnrprj=shrpnrp*shrpnrt*shrt
       shrknrbus=shrknrb*shrknrt*shrt
       shrknrprj=shrknrp*shrknrt*shrt

       ; print shares
       print list='\n\nTrips by mode:                       Share',printo=1
       print list='    Drive Alone                    ',shrda(7.8),printo=1
       print list='    HOV2                           ',shrhov2(7.8),printo=1
       print list='    HOV3                           ',shrhov3(7.8),printo=1
       print list='    Walk Bus                       ',shrwalkbus(7.8),printo=1
       print list='    Walk Prj                       ',shrwalkprj(7.8),printo=1
       print list='    PNR Bus                        ',shrpnrbus(7.8),printo=1
       print list='    PNR Prj                        ',shrpnrprj(7.8),printo=1
       print list='    KNR Bus                        ',shrknrbus(7.8),printo=1
       print list='    KNR Prj                        ',shrknrprj(7.8),printo=1

       print list='\n\nCalculated shares using the utility equations:       ', printo=1
       print list='   Top Nest:                                         ', printo=1
       print list='        Auto Share               ',shra(6.4), printo=1
       print list='        Transit Share            ',shrt(6.4), printo=1

       print list='\n\n   Auto Nest:                                    ', printo=1
       print list='        Drive Alone Share        ',shrdaa(6.4), printo=1
       print list='        Shared Ride Share        ',shrsra(6.4), printo=1
       print list='\n\n   Shared Ride Nest:                             ', printo=1
       print list='        HOV2 Share               ',shrhov2sr(6.4), printo=1
       print list='        HOV3 Share               ',shrhov3sr(6.4), printo=1
       print list='\n\n   Transit Nest:                                 ', printo=1
       print list='        Walk Transit Share       ',shrwkt(6.4), printo=1
       print list='        PNR Transit Share        ',shrpnrt(6.4), printo=1
       print list='        KNR Transit Share        ',shrknrt(6.4), printo=1
       print list='\n\n   Walk Nest:                                 ', printo=1
       print list='        Walk Bus Share           ',shrwkb(6.4), printo=1
       print list='        Walk Prj Share           ',shrwkp(6.4), printo=1
       print list='\n\n   PNR Nest:                                 ', printo=1
       print list='        PNR Bus Share            ',shrpnrb(6.4), printo=1
       print list='        PNR Prj Share            ',shrpnrp(6.4), printo=1
       print list='\n\n   KNR Nest:                                 ', printo=1
       print list='        KNR Bus Share            ',shrknrb(6.4), printo=1
       print list='        KNR Prj Share            ',shrknrp(6.4), printo=1

; ######################### END HAND CALCULATIONS ########################################
; ##################### XCHOICE RESULTS###############################

       print list='\n\n\nCUBE UTILITY BASED XCHOICE MODEL\n',printo=1
       print list='*******************************************************************',printo=1
       print list='\nTotal demand between the interchange:  ',MW[251][J](10.2),printo=1
       print list='Demand from 0-car households           ',MW[_cnt1][J](10.2),printo=1
     IF ((MW[M1][J]+MW[M2][J]+MW[M3][J]+MW[M4][J]+MW[M5][J]+MW[M6][J]+MW[M7][J]+MW[M8][J]+MW[M9][J])>0)
       xcshrda  =(MW[M1][J]/(MW[M1][J]+MW[M2][J]+MW[M3][J]+MW[M4][J]+MW[M5][J]+MW[M6][J]+MW[M7][J]+MW[M8][J]+MW[M9][J]))
       xcshrhov2=(MW[M2][J]/(MW[M1][J]+MW[M2][J]+MW[M3][J]+MW[M4][J]+MW[M5][J]+MW[M6][J]+MW[M7][J]+MW[M8][J]+MW[M9][J]))
       xcshrhov3=(MW[M3][J]/(MW[M1][J]+MW[M2][J]+MW[M3][J]+MW[M4][J]+MW[M5][J]+MW[M6][J]+MW[M7][J]+MW[M8][J]+MW[M9][J]))
       xcshrwkb =(MW[M4][J]/(MW[M1][J]+MW[M2][J]+MW[M3][J]+MW[M4][J]+MW[M5][J]+MW[M6][J]+MW[M7][J]+MW[M8][J]+MW[M9][J]))
       xcshrwkp =(MW[M5][J]/(MW[M1][J]+MW[M2][J]+MW[M3][J]+MW[M4][J]+MW[M5][J]+MW[M6][J]+MW[M7][J]+MW[M8][J]+MW[M9][J]))
       xcshrpnrb=(MW[M6][J]/(MW[M1][J]+MW[M2][J]+MW[M3][J]+MW[M4][J]+MW[M5][J]+MW[M6][J]+MW[M7][J]+MW[M8][J]+MW[M9][J]))
       xcshrpnrp=(MW[M7][J]/(MW[M1][J]+MW[M2][J]+MW[M3][J]+MW[M4][J]+MW[M5][J]+MW[M6][J]+MW[M7][J]+MW[M8][J]+MW[M9][J]))
       xcshrknrb=(MW[M8][J]/(MW[M1][J]+MW[M2][J]+MW[M3][J]+MW[M4][J]+MW[M5][J]+MW[M6][J]+MW[M7][J]+MW[M8][J]+MW[M9][J]))
       xcshrknrp=(MW[M9][J]/(MW[M1][J]+MW[M2][J]+MW[M3][J]+MW[M4][J]+MW[M5][J]+MW[M6][J]+MW[M7][J]+MW[M8][J]+MW[M9][J]))

       xcshrtot=xcshrda+xcshrhov2+xcshrhov3+xcshrwkb+xcshrwkp+xcshrpnrb+xcshrpnrp+xcshrknrb+xcshrknrp
       print list='\n\nTrips by mode:                          Trips      Share',printo=1
       print list='    Drive Alone                    ',MW[M1][J](10.2),'    ',xcshrda(7.4),printo=1
       print list='    HOV2                           ',MW[M2][J](10.2),'    ',xcshrhov2(7.4),printo=1
       print list='    HOV3                           ',MW[M3][J](10.2),'    ',xcshrhov3(7.4),printo=1
       print list='    Walk Bus                       ',MW[M4][J](10.2),'    ',xcshrwkb(7.4),printo=1
       print list='    Walk Prj                       ',MW[M5][J](10.2),'    ',xcshrwkp(7.4),printo=1
       print list='    PNR Bus                        ',MW[M6][J](10.2),'    ',xcshrpnrb(7.4),printo=1
       print list='    KNR Bus                        ',MW[M8][J](10.2),'    ',xcshrknrb(7.4),printo=1
       print list='    KNR Prj                        ',MW[M9][J](10.2),'    ',xcshrknrp(7.4),printo=1

       print list='\n\n\nOutput shares by XCHOICE:                             ', printo=1
       print list='   Top Nest:                                         ', printo=1
       print list='        Auto Share               ',(xcshrda+xcshrhov2+xcshrhov3)(7.4), printo=1
       print list='        Transit Share            ',(xcshrwkb+xcshrwkp+xcshrpnrb+xcshrpnrp+xcshrknrb+xcshrknrp)(7.4), printo=1

       print list='\n\n   Auto Nest:                                    ', printo=1
       print list='        Drive Alone Share        ',(xcshrda/(xcshrda+xcshrhov2+xcshrhov3))(7.4), printo=1
       print list='        Shared Ride Share        ',((xcshrhov2+xcshrhov3)/(xcshrda+xcshrhov2+xcshrhov3))(7.4), printo=1
       print list='\n\n   Shared Ride Nest:                             ', printo=1
       print list='        HOV2 Share               ',(xcshrhov2/(xcshrhov2+xcshrhov3))(7.4), printo=1
       print list='        HOV3 Share               ',(xcshrhov3/(xcshrhov2+xcshrhov3))(7.4), printo=1
       print list='\n\n   Transit Nest:                                 ', printo=1
       print list='        Walk Transit Share       ',((xcshrwkb+xcshrwkp)/(xcshrwkb+xcshrwkp+xcshrpnrb+xcshrpnrp+xcshrknrb+xcshrknrp))(7.4), printo=1
       print list='        PNR Transit Share        ',((xcshrpnrb+xcshrpnrp)/(xcshrwkb+xcshrwkp+xcshrpnrb+xcshrpnrp+xcshrknrb+xcshrknrp))(7.4), printo=1
       print list='        KNR Transit Share        ',((xcshrknrb+xcshrpnrp)/(xcshrwkb+xcshrwkp+xcshrpnrb+xcshrpnrp+xcshrknrb+xcshrknrp))(7.4), printo=1
       print list='\n\n   Walk Nest:                                 ', printo=1
       print list='        Walk Bus Share           ',(xcshrwkb/(xcshrwkb+xcshrwkp))(7.4), printo=1
       print list='        Walk Prj Share           ',(xcshrwkp/(xcshrwkb+xcshrwkp))(7.4), printo=1
       print list='\n\n   PNR Nest:                                 ', printo=1
       print list='        PNR Bus Share            ',(xcshrpnrb/(xcshrpnrb+xcshrpnrp))(7.4), printo=1
       print list='        PNR Prj Share            ',(xcshrpnrp/(xcshrpnrb+xcshrpnrp))(7.4), printo=1
       print list='\n\n   KNR Nest:                                 ', printo=1
       print list='        KNR Bus Share            ',(xcshrknrb/(xcshrknrb+xcshrknrp))(7.4), printo=1
       print list='        KNR Prj Share            ',(xcshrknrp/(xcshrknrb+xcshrknrp))(7.4), printo=1

       print list='\n\n',printo=1

       IF (MARKET=3)
        print list='\n\n\n','END TRACE @PURP@-@PERIOD@','\n',printo=1
        print list='========================================================================================',printo=1
       ENDIF

      ELSE
       print list='No demand (input trips) from this access type and market segment............... ',printo=1
       print list='\n\n',printo=1

      ENDIF

      ENDIF
     ENDJLOOP
    ENDIF

   ENDLOOP ; end market loop created for reporting purposes

; ###############################################################################

ENDLOOP      ; end access loop

ENDRUN


; Script for program MATRIX in file "D:\Data\FDOT\TransitApp\TransitModelTierBC_Delivery\APPLICATIONS\MCMAT00Z.S"
; Do not change filenames or add or remove FILEI/FILEO statements using an editor. Use Cube/Application Manager.
RUN PGM=MATRIX PRNFILE="{SCENARIO_DIR}\output\MCMAT00A.PRN" MSG='Mode Choice Reporting'
FILEI MATI[1] = "{SCENARIO_DIR}\output\@PURP@Trip_CW_0CAR.MAT"
FILEI MATI[2] = "{SCENARIO_DIR}\output\@PURP@Trip_CW_1CAR.MAT"
FILEI MATI[3] = "{SCENARIO_DIR}\output\@PURP@Trip_CW_2CAR.MAT"
FILEI MATI[4] = "{SCENARIO_DIR}\output\@PURP@Trip_MD_0CAR.MAT"
FILEI MATI[5] = "{SCENARIO_DIR}\output\@PURP@Trip_MD_1CAR.MAT"
FILEI MATI[6] = "{SCENARIO_DIR}\output\@PURP@Trip_MD_2CAR.MAT"
FILEI MATI[7] = "{SCENARIO_DIR}\output\@PURP@Trip_NT_0CAR.MAT"
FILEI MATI[8] = "{SCENARIO_DIR}\output\@PURP@Trip_NT_1CAR.MAT"
FILEI MATI[9] = "{SCENARIO_DIR}\output\@PURP@Trip_NT_2CAR.MAT"
FILEI MATI[10] = "{SCENARIO_DIR}\output\@PURP@Trip.MAT"
FILEI MATI[11] = "{SCENARIO_DIR}\output\expautoutil_tmp.mat"
FILEI MATI[12] = "{SCENARIO_DIR}\output\farexfer_tmp.mat"
FILEI ZDATI[1] = "{SCENARIO_DIR}\output\TAZDATA_{alt}{year}.DBF"
FILEI LOOKUPI[1] = "{SCENARIO_DIR}\output\TRN_COEFFICIENTS.DBF"

FILEO PRINTO[4] = "{SCENARIO_DIR}\output\CBDSHARES.CSV",
append=t
FILEO PRINTO[3] = "{SCENARIO_DIR}\output\MODESHARES.CSV",
append=t
FILEO PRINTO[2] = "{SCENARIO_DIR}\output\ModeSum.TXT",
append=t
FILEO PRINTO[1] = "{SCENARIO_DIR}\output\ModeDebug.TXT",
append=t
FILEO MATO[2] = "{SCENARIO_DIR}\output\@PURP@UTIL_{alt}{year}.MAT",
MO=401-407,421-427,441-447, DEC=21*D,
NAME=PerTrip1,AutoTrnTrip1,AutoPrice1,WalkFrac1,WalkShare1,DriveFrac1,DriveShare1,
     PerTrip2,AutoTrnTrip2,AutoPrice2,WalkFrac2,WalkShare2,DriveFrac2,DriveShare2,
     PerTrip3,AutoTrnTrip3,AutoPrice3,WalkFrac3,WalkShare3,DriveFrac3,DriveShare3
FILEO MATO[1] = "{SCENARIO_DIR}\output\@PURP@_{alt}{year}.MAT",
MO=501-509,DEC=12*s,NAME=DA,SR2,SR3,WALKBUS,WALKPRJ,PNRBUS,PNRPRJ,KNRBUS,KNRPRJ

zonemsg=100

FILLMW MW[1]  =MI.1.1,2,3,4,5,6,7,8,9     ; can walk 0 car
FILLMW MW[21] =MI.2.1,2,3,4,5,6,7,8,9     ; can walk 1 car
FILLMW MW[41] =MI.3.1,2,3,4,5,6,7,8,9     ; can walk 2 car
FILLMW MW[61] =MI.4.1,2,3,4,5,6,7,8,9     ; must drive 0 car
FILLMW MW[81] =MI.5.1,2,3,4,5,6,7,8,9     ; must drive 1 car
FILLMW MW[101]=MI.6.1,2,3,4,5,6,7,8,9     ; must drive 2 car
FILLMW MW[121]=MI.7.1,2,3,4,5,6,7,8,9     ; no transit 0 car
FILLMW MW[141]=MI.8.1,2,3,4,5,6,7,8,9     ; no transit 1 car
FILLMW MW[161]=MI.9.1,2,3,4,5,6,7,8,9     ; no transit 2 car
FILLMW MW[201]=MI.10.1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27   ; 0 car, 1 car, 2 car households
FILLMW MW[251]=MI.11.1,2,3
FILLMW MW[261]=MI.12.1,2,3,4,5,6,7,8,9,10,11,12   ; fare and xfer matrix for the nine paths

array _tripsDA=3, _tripsHOV2=3, _tripsHOV3=3, _tripsWalkbus=3, _tripsWalkprj=3, _tripsPNRbus=3,
      _tripsPNRprj=3, _tripsKNRbus=3, _tripsKNRprj=3, _SUMtrips=3,
      CBDA=4,TOTACC=4

if (i=FirstZone)
  loop xx=1,3
    _tripsDA[xx]=0
    _tripsHOV2[xx]=0
    _tripsHOV3[xx]=0
    _tripsWalkBus[xx]=0
    _tripsWalkPrj[xx]=0
    _tripsPNRBus[xx]=0
    _tripsPNRPrj[xx]=0
    _tripsKNRBus[xx]=0
    _tripsKNRPrj[xx]=0
    _SUMtrips[xx]=0
  endloop
endif

 ; Total person trips for each market segment
 COMP total = ROWADD(301,201,202,203,204,205,206,207,208,209)    ; Person trips Market Segment 1
 COMP total = ROWADD(302,210,211,212,213,214,215,216,217,218)    ; Person trips Market Segment 2
 COMP total = ROWADD(303,219,220,221,222,223,224,225,226,227)    ; Person trips Market Segment 3

 ; Person trip for assignment
 COMP total = ROWADD(501,1,21,41,61,81,101,121,141,161)              ; DA Person trips
 COMP total = ROWADD(502,2,22,42,62,82,102,122,142,162)              ; HOV2 Person trips
 COMP total = ROWADD(503,3,23,43,63,83,103,123,143,163)              ; HOV3 Person trips
 COMP total = ROWADD(504,4,24,44,64,84,104,124,144,164)              ; walk-bus Person trips
 COMP total = ROWADD(505,5,25,45,65,85,105,125,145,165)              ; walk-prj Person trips
 COMP total = ROWADD(506,6,26,46,66,86,106,126,146,166)              ; pnr-bus Person trips
 COMP total = ROWADD(507,7,27,47,67,87,107,127,147,167)              ; pnr-prj Person trips
 COMP total = ROWADD(508,8,28,48,68,88,108,128,148,168)              ; knr-bus Person trips
 COMP total = ROWADD(509,9,29,49,69,89,109,129,149,169)              ; knr-prj Person trips

; ********************************* BEGIN USER BENEFIT AND MODE CHOICE SUMMARY ********************************************
LOOP MARKET=1,3                    ; UB data generated for each market segment separately

 if (MARKET=1) MARKET_NAME='Zero Car HHs       '
 if (MARKET=2) MARKET_NAME='One Car HHs        '
 if (MARKET=3) MARKET_NAME='Two+ Car HHs       '

 _idx1 = (200 + 9*(MARKET-1))
 _idx2 = 20*(MARKET-1)

 JLOOP
  _tripsDA[MARKET] = _tripsDA[MARKET] + MW[_idx1+1]
  _tripsHOV2[MARKET] = _tripsHOV2[MARKET] + MW[_idx1+2]
  _tripsHOV3[MARKET] = _tripsHOV3[MARKET] + MW[_idx1+3]
  _tripsWalkBus[MARKET] = _tripsWalkBus[MARKET] + MW[_idx1+4]
  _tripsWalkPrj[MARKET] = _tripsWalkPrj[MARKET] + MW[_idx1+5]
  _tripsPNRBus[MARKET] = _tripsPNRBus[MARKET] + MW[_idx1+6]
  _tripsPNRPrj[MARKET] = _tripsPNRPrj[MARKET] + MW[_idx1+7]
  _tripsKNRBus[MARKET] = _tripsKNRBus[MARKET] + MW[_idx1+8]
  _tripsKNRPrj[MARKET] = _tripsKNRPrj[MARKET] + MW[_idx1+9]

  ; For reporting access categories
  _cw1 = _cw1 + MW[_idx2+1]     ;da
  _cw2 = _cw2 + MW[_idx2+2]     ;hov2
  _cw3 = _cw3 + MW[_idx2+3]     ;hov3
  _cw4 = _cw1 + _cw2 + _cw3     ;auto
  _cw5 = _cw5 + MW[_idx2+4]
  _cw6 = _cw6 + MW[_idx2+5]
  _cw7 = _cw7 + MW[_idx2+6]
  _cw8 = _cw8 + MW[_idx2+7]
  _cw9 = _cw9 + MW[_idx2+8]
  _cw10= _cw10+ MW[_idx2+9]
  _cw13= _cw5 + _cw6 + _cw7 + _cw8 + _cw9 + _cw10     ;transit
   _cw15= _cw4+ _cw13                       ;total
  _md1 = _md1 + MW[_idx2+61]
  _md2 = _md2 + MW[_idx2+62]
  _md3 = _md3 + MW[_idx2+63]
  _md4 = _md1 + _md2 + _md3
  _md5 = _md5 + MW[_idx2+64]
  _md6 = _md6 + MW[_idx2+65]
  _md7 = _md7 + MW[_idx2+66]
  _md8 = _md8 + MW[_idx2+67]
  _md9 = _md9 + MW[_idx2+68]
  _md10= _md10+ MW[_idx2+69]
  _md13= _md5 + _md6 + _md7 + _md8 + _md9 + _md10
  _md15= _md4+ _md13
  _na1 = _na1 + MW[_idx2+121]
  _na2 = _na2 + MW[_idx2+122]
  _na3 = _na3 + MW[_idx2+123]
  _na4 = _na1 + _na2 + _na3
  _na5 = _na5 + MW[_idx2+124]
  _na6 = _na6 + MW[_idx2+125]
  _na7 = _na7 + MW[_idx2+126]
  _na8 = _na8 + MW[_idx2+127]
  _na9 = _na9 + MW[_idx2+128]
  _na10= _na10+ MW[_idx2+129]
  _na13= _na5 + _na6 + _na7 + _na8 + _na9 + _na10
  _na15= _na4 + _na13
  _totacc1 = _cw1 + _md1 + _na1
  _totacc2 = _cw2 + _md2 + _na2
  _totacc3 = _cw3 + _md3 + _na3
  _totacc4 = _cw4 + _md4 + _na4    ;total auto
  _totacc5 = _cw5 + _md5 + _na5      ;wb
  _totacc6 = _cw6 + _md6 + _na6      ;wp
  _totacc7 = _cw7 + _md7 + _na7      ;pb
  _totacc8 = _cw8 + _md8 + _na8      ;pp
  _totacc9 = _cw9 + _md9 + _na9      ;kb
  _totacc10 = _cw10 + _md10 + _na10  ;kp
  _totacc13 = _cw13 + _md13 + _na13    ;total transit
  _totacc15 = _cw15 + _md15 + _na15    ;total trip

  ; For reporting prods/attrs
  if (ZI.1.CBD_DUMMY[i]==1)
    _cbdp1 = _cbdp1 + MW[_idx1+1]
    _cbdp2 = _cbdp2 + MW[_idx1+2]
    _cbdp3 = _cbdp3 + MW[_idx1+3]
    _cbdp4 = _cbdp1 + _cbdp2 + _cbdp3
    _cbdp5 = _cbdp5 + MW[_idx1+4]
    _cbdp6 = _cbdp6 + MW[_idx1+5]
    _cbdp7 = _cbdp7 + MW[_idx1+6]
    _cbdp8 = _cbdp8 + MW[_idx1+7]
    _cbdp9 = _cbdp9 + MW[_idx1+8]
    _cbdp10= _cbdp10+ MW[_idx1+9]
    _cbdp13= _cbdp5 + _cbdp6 + _cbdp7 + _cbdp8 + _cbdp9 + _cbdp10
    _cbdp15= _cbdp4 + _cbdp13
  elseif (ZI.1.EXU_DUMMY[i]==1)
    _exup1 = _exup1 + MW[_idx1+1]
    _exup2 = _exup2 + MW[_idx1+2]
    _exup3 = _exup3 + MW[_idx1+3]
    _exup4 = _exup1 + _exup2 + _exup3
    _exup5 = _exup5 + MW[_idx1+4]
    _exup6 = _exup6 + MW[_idx1+5]
    _exup7 = _exup7 + MW[_idx1+6]
    _exup8 = _exup8 + MW[_idx1+7]
    _exup9 = _exup9 + MW[_idx1+8]
    _exup10= _exup10+ MW[_idx1+9]
    _exup13= _exup5 + _exup6 + _exup7 + _exup8 + _exup9 + _exup10
    _exup15= _exup4 + _exup13
  else
    _othp1 = _othp1 + MW[_idx1+1]
    _othp2 = _othp2 + MW[_idx1+2]
    _othp3 = _othp3 + MW[_idx1+3]
    _othp4 = _othp1 + _othp2 + _othp3
    _othp5 = _othp5 + MW[_idx1+4]
    _othp6 = _othp6 + MW[_idx1+5]
    _othp7 = _othp7 + MW[_idx1+6]
    _othp8 = _othp8 + MW[_idx1+7]
    _othp9 = _othp9 + MW[_idx1+8]
    _othp10= _othp10+ MW[_idx1+9]
    _othp13= _othp5 + _othp6 + _othp7 + _othp8 + _othp9 + _othp10
    _othp15= _othp4 + _othp13
  endif
  if (ZI.1.CBD_DUMMY[j]==1)
    _cbda1 = _cbda1 + MW[_idx1+1]
    _cbda2 = _cbda2 + MW[_idx1+2]
    _cbda3 = _cbda3 + MW[_idx1+3]
    _cbda4 = _cbda1 + _cbda2 + _cbda3
    _cbda5 = _cbda5 + MW[_idx1+4]
    _cbda6 = _cbda6 + MW[_idx1+5]
    _cbda7 = _cbda7 + MW[_idx1+6]
    _cbda8 = _cbda8 + MW[_idx1+7]
    _cbda9 = _cbda9 + MW[_idx1+8]
    _cbda10= _cbda10+ MW[_idx1+9]
    _cbda13= _cbda5 + _cbda6 + _cbda7 + _cbda8 + _cbda9 + _cbda10
    _cbda15= _cbda4 + _cbda13
  elseif (ZI.1.EXU_DUMMY[j]==1)
    _exua1 = _exua1 + MW[_idx1+1]
    _exua2 = _exua2 + MW[_idx1+2]
    _exua3 = _exua3 + MW[_idx1+3]
    _exua4 = _exua1 + _exua2 + _exua3
    _exua5 = _exua5 + MW[_idx1+4]
    _exua6 = _exua6 + MW[_idx1+5]
    _exua7 = _exua7 + MW[_idx1+6]
    _exua8 = _exua8 + MW[_idx1+7]
    _exua9 = _exua9 + MW[_idx1+8]
    _exua10= _exua10+ MW[_idx1+9]
    _exua13= _exua5 + _exua6 + _exua7 + _exua8 + _exua9
    _exua15= _exua4 + _exua13
  else
    _otha1 = _otha1 + MW[_idx1+1]
    _otha2 = _otha2 + MW[_idx1+2]
    _otha3 = _otha3 + MW[_idx1+3]
    _otha4 = _otha1 + _otha2 + _otha3
    _otha5 = _otha5 + MW[_idx1+4]
    _otha6 = _otha6 + MW[_idx1+5]
    _otha7 = _otha7 + MW[_idx1+6]
    _otha8 = _otha8 + MW[_idx1+7]
    _otha9 = _otha9 + MW[_idx1+8]
    _otha10= _otha10+ MW[_idx1+9]
    _otha13= _otha5 + _otha6 + _otha7 + _otha8 + _otha9 + _otha10
    _otha15= _otha4 + _otha13
  endif
/*
  ; For reporting fare revenue
  _frev1 = _frev1 + ((MI.12.FareWB * MW[_idx1+4]) / 100.0)
  _frev2 = _frev2 + ((MI.12.FareWP * MW[_idx1+5]) / 100.0)
  _frev3 = _frev3 + ((MI.12.FareAB * MW[_idx1+6]) / 100.0)
  _frev4 = _frev4 + ((MI.12.FareAP * MW[_idx1+7]) / 100.0)
  _frev5 = _frev5 + ((MI.12.FareAB * MW[_idx1+8]) / 100.0)
  _frev6 = _frev6 + ((MI.12.FareAP * MW[_idx1+9]) / 100.0)
  _frev7 = _frev1 + _frev2 + _frev3 + _frev4 + _frev5 + _frev6
  _avef1 = 0
  if (_totacc5>0) _avef1 = _frev1 / _totacc5
    _avef2 = 0
  if (_totacc6>0) _avef2 = _frev2 / _totacc6
    _avef3 = 0
  if (_totacc7>0) _avef3 = _frev3 / _totacc7
    _avef4 = 0
  if (_totacc8>0) _avef4 = _frev4 / _totacc8
    _avef5 = 0
  if (_totacc9>0) _avef5 = _frev5 / _totacc9
    _avef6 = 0
  if (_totacc10>0) _avef6 = _frev6 / _totacc10
    _avef7 = 0

*/
 if (MARKET=3)
  ; For reporting transfers
  if (MW[267]==0)                          ;walk bus
    _xfer0_1 = _xfer0_1 + MW[504]
  elseif (MW[267]==1)
    _xfer1_1 = _xfer1_1 + MW[504]
  elseif (MW[267]==2)
    _xfer2_1 = _xfer2_1 + MW[504]
  else
    _xfer3_1 = _xfer3_1+ MW[504]
  endif
  if (MW[268]==0)                          ;walk prj
    _xfer0_2 = _xfer0_2 + MW[505]
  elseif (MW[268]==1)
    _xfer1_2 = _xfer1_2 + MW[505]
  elseif (MW[268]==2)
    _xfer2_2 = _xfer2_2 + MW[505]
  else
    _xfer3_2 = _xfer3_2 + MW[505]
  endif
  if (MW[269]==0)                          ;pnr bus
    _xfer0_3 = _xfer0_3 + MW[506]
  elseif (MW[269]==1)
    _xfer1_3 = _xfer1_3 + MW[506]
  elseif (MW[269]==2)
    _xfer2_3 = _xfer2_3 + MW[506]
  else
    _xfer3_3 = _xfer3_3 + MW[506]
  endif
  if (MW[270]==0)                          ;pnr prj
    _xfer0_4 = _xfer0_4 + MW[507]
  elseif (MW[270]==1)
    _xfer1_4 = _xfer1_4 + MW[507]
  elseif (MW[270]==2)
    _xfer2_4 = _xfer2_4 + MW[507]
  else
    _xfer3_4 = _xfer3_4 + MW[507]
  endif
  if (MW[271]==0)                          ;knr bus
    _xfer0_5 = _xfer0_5 + MW[508]
  elseif (MW[271]==1)
    _xfer1_5 = _xfer1_5 + MW[508]
  elseif (MW[271]==2)
    _xfer2_5 = _xfer2_5 + MW[508]
  else
    _xfer3_5 = _xfer3_5 + MW[508]
  endif
  if (MW[272]==0)                          ;knr prj
    _xfer0_6 = _xfer0_6 + MW[509]
  elseif (MW[272]==1)
    _xfer1_6 = _xfer1_6 + MW[509]
  elseif (MW[272]==2)
    _xfer2_6 = _xfer2_6 + MW[509]
  else
    _xfer3_6 = _xfer3_6 + MW[509]
  endif

  _xfer0_10 = _xfer0_1 + _xfer0_2 + _xfer0_3 + _xfer0_4 + _xfer0_5 + _xfer0_6
  _xfer1_10 = _xfer1_1 + _xfer1_2 + _xfer1_3 + _xfer1_4 + _xfer1_5 + _xfer1_6
  _xfer2_10 = _xfer2_1 + _xfer2_2 + _xfer2_3 + _xfer2_4 + _xfer2_5 + _xfer2_6
  _xfer3_10 = _xfer3_1 + _xfer3_2 + _xfer3_3 + _xfer3_4 + _xfer3_5 + _xfer3_6

 endif

  ; User benefit calculations are done for each market segment
  ; Determine can walk & must drive percentages for matrix for Summit for each market segment (1 for auto0, 2 for auto1 and 3 for auto2)
  ; person trips
  IF ({RunUB}==1)

  T1=401+_idx2, T2=402+_idx2, T3=403+_idx2, T4=404+_idx2, T5=405+_idx2, T6=406+_idx2, T7=407+_idx2

  if (MW[300+MARKET]>0)
    MW[T1] = MW[300+MARKET]                                                                     ; person trips in market segment
    MW[T2] = MW[T1]                                                                             ; motorized trips in market segment
    MW[T3] = MW[250+MARKET]                                                                     ; expotentied auto utility
    MW[601] = MW[1+_idx2] + MW[2+_idx2] + MW[3+_idx2] + MW[4+_idx2] + MW[5+_idx2] +
              MW[6+_idx2] + MW[7+_idx2] + MW[8+_idx2] + MW[9+_idx2]
                                                                                                 ; total trips that can walk in MS
    MW[602] = MW[4+_idx2] + MW[5+_idx2] + MW[6+_idx2] + MW[7+_idx2] + MW[8+_idx2] +
              MW[9+_idx2]                                                                        ; transit trips that can walk in MS
    MW[T4] = MW[601] / MW[T1]
    if (MW[601]>0)
        MW[T5] = MW[602] / MW[601]
    else
        MW[T5] = 0.00                                                                           ; transit share of trips that can walk
    endif

    MW[603] = MW[61+_idx2] + MW[62+_idx2] + MW[63+_idx2] + MW[64+_idx2] + MW[65+_idx2] +
              MW[66+_idx2] + MW[67+_idx2] + MW[68+_idx2] + MW[69+_idx2]                           ; total trips that must drive in MS
    MW[604] = MW[64+_idx2] + MW[65+_idx2] + MW[66+_idx2] + MW[67+_idx2] + MW[68+_idx2] +
              MW[69+_idx2]                                                                       ; transit trips that must drive in MS
    MW[T6] = MW[603] / MW[T1]                                                                   ; fraction of person trips that must drive
    if (MW[603]>0)
        MW[T7] = MW[604] / MW[603]                                                              ; transit share of trips that must drive
    else
        MW[T7] = 0.00
    endif
  else
    MW[T1] = 0.00
    MW[T2] = 0.00
    MW[T3] = 0.00
    MW[T4] = 0.00
    MW[T5] = 0.00
    MW[T6] = 0.00
    MW[T7] = 0.00
  endif
if (i=125)
if (j=751)
print list="questioned matrices",MW[601], MW[T1], MW[1+_idx2], MW[2+_idx2] , MW[3+_idx2] , MW[4+_idx2],MW[5+_idx2], MW[6+_idx2],MW[7+_idx2],MW[8+_idx2],MW[9+_idx2]
 ENDIF
ENDIF

 if (I={SelOrigin} && J={SelDest})
    print list="*UB Rec* ",i(5.0),j(5.0),MARKET(5.0),mw[T1](10.1),mw[T2](10.1),mw[T3](10.7),mw[T4](10.5),mw[T5](10.5),mw[T6](10.5),mw[T7](10.5)
  endif

  ENDIF

  ; MODE CHOICE SUMMARY
  IF (i=_zones & j=_zones)

   _SUMtrips[MARKET] = _tripsDA[MARKET] + _tripsHOV2[MARKET] + _tripsHOV3[MARKET] +
                       _tripsWalkBus[MARKET] + _tripsWalkPrj[MARKET] +
                       _tripsPNRBus[MARKET] + _tripsPNRPrj[MARKET] +
                       _tripsKNRBus[MARKET] + _tripsKNRPrj[MARKET]
   ; Total trips by purpose
   if (_SUMtrips[MARKET]=0) _SUMtrips[MARKET]=1

   if (MARKET==1)
     PRINT FORM=8.OC, LIST='\f\n\n@PURP@ - @PERIOD@ MODE XCHOICE RESULTS',
     '\n**************************************************************',
     '\n','                 ','     Total','     Drive','       One','      Two+','     Total','      Walk','      Walk','       PNR','       PNR','       KNR','       KNR','     Total',
     '\n','MARKET SEGMENT   ','    Person','     Alone','       Pax','       Pax','      Auto','       Bus','   Project','       Bus','   Project','       Bus','   Project','   Transit',
     '\n','--------------   ','   -------','    ------','    ------','    ------','    ------','    ------','   -------','    ------','   -------','    ------','   -------','   -------',PRINTO=2
   endif

   _aocp = _aocp + (_tripsDA[MARKET]+_tripsHOV2[MARKET]+_tripsHOV3[MARKET])
   _aocv = _aocv + (_tripsDA[MARKET]+_tripsHOV2[MARKET]/2.0+_tripsHOV3[MARKET]/@OCC3@)

   _trntemp = (_tripsWalkBus[MARKET]+_tripsWalkPrj[MARKET]+_tripsPNRBus[MARKET]+_tripsPNRPrj[MARKET]+_tripsKNRBus[MARKET]+_tripsKNRPrj[MARKET])

   PRINT LIST='\n',MARKET_NAME(17),_SUMtrips[MARKET](10.1),
                   _tripsDA[MARKET](10.1),_tripsHOV2[MARKET](10.1),_tripsHOV3[MARKET](10.1),_tripsDA[MARKET]+_tripsHOV2[MARKET]+_tripsHOV3[MARKET](10.1),
                   _tripsWalkBus[MARKET](10.1),_tripsWalkPrj[MARKET](10.1),
                   _tripsPNRBus[MARKET](10.1),_tripsPNRPrj[MARKET](10.1),
                   _tripsKNRBus[MARKET](10.1),_tripsKNRPrj[MARKET](10.1),_trntemp(10.1),PRINTO=2

   if (MARKET==3)
     PRINT LIST =  '\n\n',
                   'TOTAL            ',_totacc15(10.1),_totacc1(10.1),_totacc2(10.1),_totacc3(10.1),_totacc4(10.1),_totacc5(10.1),_totacc6(10.1),
                   _totacc7(10.1),_totacc8(10.1),_totacc9(10.1),_totacc10(10.1),_totacc13(10.1),
                   '\n\n',
                   'Can Walk         ',_cw15(10.1),_cw1(10.1),_cw2(10.1),_cw3(10.1),_cw4(10.1),_cw5(10.1),_cw6(10.1),
                   _cw7(10.1),_cw8(10.1),_cw9(10.1),_cw10(10.1),_cw13(10.1),'\n',
                   'Must Drive       ',_md15(10.1),_md1(10.1),_md2(10.1),_md3(10.1),_md4(10.1),_md5(10.1),_md6(10.1),
                   _md7(10.1),_md8(10.1),_md9(10.1),_md10(10.1),_md13(10.1),'\n',
                   'No Access        ',_na15(10.1),_na1(10.1),_na2(10.1),_na3(10.1),_na4(10.1),_na5(10.1),_na6(10.1),
                   _na7(10.1),_na8(10.1),_na9(10.1),_na10(10.1),_na13(10.1),'\n\n',
                   'TOTAL            ',_totacc15(10.1),_totacc1(10.1),_totacc2(10.1),_totacc3(10.1),_totacc4(10.1),_totacc5(10.1),_totacc6(10.1),
                   _totacc7(10.1),_totacc8(10.1),_totacc9(10.1),_totacc10(10.1),_totacc13(10.1),PRINTO=2
     PRINT LIST =  '\n\n',
                   'Productions:     ','\n',
                   'CBD              ',_cbdp15(10.1),_cbdp1(10.1),_cbdp2(10.1),_cbdp3(10.1),_cbdp4(10.1),_cbdp5(10.1),_cbdp6(10.1),
                   _cbdp7(10.1),_cbdp8(10.1),_cbdp9(10.1),_cbdp10(10.1),_cbdp13(10.1),'\n',
                   'Exurban          ',_exup15(10.1),_exup1(10.1),_exup2(10.1),_exup3(10.1),_exup4(10.1),_exup5(10.1),_exup6(10.1),
                   _exup7(10.1),_exup8(10.1),_exup9(10.1),_exup10(10.1),_exup13(10.1),'\n',
                   'Other            ',_othp15(10.1),_othp1(10.1),_othp2(10.1),_othp3(10.1),_othp4(10.1),_othp5(10.1),_othp6(10.1),
                   _othp7(10.1),_othp8(10.1),_othp9(10.1),_othp10(10.1),_othp13(10.1),PRINTO=2
     PRINT LIST =  '\n\n',
                   'Attractions:     ','\n',
                   'CBD              ',_cbda15(10.1),_cbda1(10.1),_cbda2(10.1),_cbda3(10.1),_cbda4(10.1),_cbda5(10.1),_cbda6(10.1),
                   _cbda7(10.1),_cbda8(10.1),_cbda9(10.1),_cbda10(10.1),_cbda13(10.1),'\n',
                   'Exurban          ',_exua15(10.1),_exua1(10.1),_exua2(10.1),_exua3(10.1),_exua4(10.1),_exua5(10.1),_exua6(10.1),
                   _exua7(10.1),_exua8(10.1),_exua9(10.1),_exua10(10.1),_exua13(10.1),'\n',
                   'Other            ',_otha15(10.1),_otha1(10.1),_otha2(10.1),_otha3(10.1),_otha4(10.1),_otha5(10.1),_otha6(10.1),
                   _otha7(10.1),_otha8(10.1),_otha9(10.1),_otha10(10.1),_otha13(10.1),PRINTO=2

     CBDA[1] = CBDA[1] + _cbda5
     CBDA[2] = CBDA[2] + _cbda7
     CBDA[3] = CBDA[3] + _cbda9

     TOTACC[1] = TOTACC[1] + _totacc5
     TOTACC[2] = TOTACC[2] + _totacc7
     TOTACC[3] = TOTACC[3] + _totacc9

/*
     PRINT LIST =  '\n\n',
                   'Fare Revenue ($) '," "(50),_frev1(10.2),_frev2(10.2),_frev3(10.2),_frev4(10.2),_frev5(10.2),
                                               _frev6(10.2),_frev7(10.2)," "(10),'\n',
                   'Average Fare ($) '," "(50),_avef1(10.2),_avef2(10.2),_avef3(10.2),_avef4(10.2),_avef5(10.2),
                                               _avef6(10.2),_avef7(10.2)," "(10),PRINTO=2
*/
     PRINT LIST =  '\n\n',
                   'Transfers:       ','\n',
                   'NONE             '," "(50),_xfer0_1(10.1),_xfer0_2(10.1),_xfer0_3(10.1),_xfer0_4(10.1),_xfer0_5(10.1),
                                               _xfer0_6(10.1),_xfer0_10(10.1),'\n',
                   'ONE              '," "(50),_xfer1_1(10.1),_xfer1_2(10.1),_xfer1_3(10.1),_xfer1_4(10.1),_xfer1_5(10.1),
                                               _xfer1_6(10.1),_xfer1_10(10.1),'\n',
                   'TWO              '," "(50),_xfer2_1(10.1),_xfer2_2(10.1),_xfer2_3(10.1),_xfer2_4(10.1),_xfer2_5(10.1),
                                               _xfer2_6(10.1),_xfer2_10(10.1),'\n',
                   'THREE +          '," "(50),_xfer3_1(10.1),_xfer3_2(10.1),_xfer3_3(10.1),_xfer3_4(10.1),_xfer3_5(10.1),
                                               _xfer3_6(10.1),_xfer3_10(10.1),PRINTO=2

     PRINT LIST =  '\n\n',
                   'Average Auto Occupancy      =',_aocp/_aocv(8.3),
                   '\n\n**************************************************************',PRINTO=2
   endif
abcd1=0
abcd2=0
   ; OUTPUT MODEL SHARES TO A CSV FILE FOR CALIBRATION


    PRINT CSV=T, LIST= (27*(@PURPNO@-2)+9*(MARKET-1)+1),@PURPOSE@,MARKET,_tripsDA[MARKET]/_SUMtrips[MARKET](12.6), PRINTO=3
    PRINT CSV=T, LIST= (27*(@PURPNO@-2)+9*(MARKET-1)+2),@PURPOSE@,MARKET,_tripsHOV2[MARKET]/_SUMtrips[MARKET](12.6), PRINTO=3
    PRINT CSV=T, LIST= (27*(@PURPNO@-2)+9*(MARKET-1)+3),@PURPOSE@,MARKET,_tripsHOV3[MARKET]/_SUMtrips[MARKET](12.6), PRINTO=3
    PRINT CSV=T, LIST= (27*(@PURPNO@-2)+9*(MARKET-1)+4),@PURPOSE@,MARKET,_tripsWalkBus[MARKET]/_SUMtrips[MARKET](12.6), PRINTO=3
    PRINT CSV=T, LIST= (27*(@PURPNO@-2)+9*(MARKET-1)+5),@PURPOSE@,MARKET,_tripsWalkPrj[MARKET]/_SUMtrips[MARKET](12.6), PRINTO=3
    PRINT CSV=T, LIST= (27*(@PURPNO@-2)+9*(MARKET-1)+6),@PURPOSE@,MARKET,_tripsPNRBus[MARKET]/_SUMtrips[MARKET](12.6), PRINTO=3
    PRINT CSV=T, LIST= (27*(@PURPNO@-2)+9*(MARKET-1)+7),@PURPOSE@,MARKET,_tripsPNRPrj[MARKET]/_SUMtrips[MARKET](12.6), PRINTO=3
    PRINT CSV=T, LIST= (27*(@PURPNO@-2)+9*(MARKET-1)+8),@PURPOSE@,MARKET,_tripsKNRBus[MARKET]/_SUMtrips[MARKET](12.6), PRINTO=3
    PRINT CSV=T, LIST= (27*(@PURPNO@-2)+9*(MARKET-1)+9),@PURPOSE@,MARKET,_tripsKNRPrj[MARKET]/_SUMtrips[MARKET](12.6), PRINTO=3

  ENDIF

 ENDJLOOP

ENDLOOP

IF (I == _ZONES)

if(totacc[1]=0)
  PRINT CSV=T, LIST=((@PURPNO@-2)*3+1),(@PURPNO@-1),abcd1(10.6), printo=4
else
  PRINT CSV=T, LIST=((@PURPNO@-2)*3+1),(@PURPNO@-1),(cbda[1]/totacc[1])(10.6), printo=4
endif

if(totacc[2]=0)
  PRINT CSV=T, LIST=((@PURPNO@-2)*3+2),(@PURPNO@-1),abcd1(10.6), printo=4
else
  PRINT CSV=T, LIST=((@PURPNO@-2)*3+2),(@PURPNO@-1),(cbda[2]/totacc[2])(10.6), printo=4
endif

if(totacc[3]=0)
  PRINT CSV=T, LIST=((@PURPNO@-2)*3+3),(@PURPNO@-1),abcd1(10.6), printo=4
else
  PRINT CSV=T, LIST=((@PURPNO@-2)*3+3),(@PURPNO@-1),(cbda[3]/totacc[3])(10.6), printo=4
endif

ENDIF
; ********************************* END USER BENEFIT AND MODE CHOICE SUMMARY ********************************************

ENDRUN


; PILOT Script

if ({RunUB}==1)

; End of PILOT Script

; Script for program TPP2UB in file "D:\Data\FDOT\TransitApp\TransitModelTierBC_Delivery\APPLICATIONS\MCTUB00B.S"
; Do not change filenames or add or remove FILEI/FILEO statements using an editor. Use Cube/Application Manager.
RUN PGM=TPP2UB PRNFILE="{SCENARIO_DIR}\output\MCMAT00F.PRN" MSG='Convert Voyager matrices to Summit Datafile'
FILEI VARI = "{SCENARIO_DIR}\output\@PURP@HEAD.VAR"
FILEI MATI = "{SCENARIO_DIR}\output\@PURP@UTIL_{alt}{year}.MAT"
FILEO MATO = "{SCENARIO_DIR}\output\@PURP@UTIL.UB"


ENDRUN


; PILOT Script


else
endif          ; RunUB flag
; End of PILOT Script

  ENDLOOP

; Script for program MATRIX in file "D:\Data\FDOT\TransitApp\TransitModelTierBC_Delivery\APPLICATIONS\MCMAT00G.S"
; Do not change filenames or add or remove FILEI/FILEO statements using an editor. Use Cube/Application Manager.
RUN PGM=MATRIX PRNFILE="{SCENARIO_DIR}\output\MCMAT00C.PRN" MSG='Convert modeshares and CBD shares to DBF'
FILEI LOOKUPI[2] = "{SCENARIO_DIR}\output\CBDSHARES.CSV"
FILEO RECO[2] = "{SCENARIO_DIR}\output\CBDSHARES.DBF",
FORM=10.6,FIELDS=N2,HBW1,HBNW1,NHB1
FILEI LOOKUPI[1] = "{SCENARIO_DIR}\output\MODESHARES.CSV"
FILEO RECO[1] = "{SCENARIO_DIR}\output\MODESHARES.DBF",
FORM=10.6,FIELDS=N1,HBW,HBNW,NHB

zones=1
array Pshr=108, Pcbdshr=12

; LOOKUP for previuos run shares
LOOKUP NAME=SHARES,
       LOOKUP[1]=1,
       RESULT=4,
       FAIL=0,0,0,
       LIST=Y,
       INTERPOLATE=N,
       LOOKUPI=1

LOOKUP NAME=CBDSHARES,
       LOOKUP[1]=1,
       RESULT=3,
       FAIL=0,0,0,
       LIST=Y, 
       INTERPOLATE=N, 
       LOOKUPI=2

; records 1 through 11 are for 11 choices for HBW purpose and 0 car households, next 11 is for HBW purpose and 1 car household....
LOOP _ww=1,81
 Pshr[_ww] = SHARES(1,_ww)
ENDLOOP

; 3 cbd targets (for walk, pnr,knr ) and 3 purposes
LOOP _ww=1,9
 Pcbdshr[_ww] = CBDSHARES(1,_ww)
ENDLOOP

; print REVISED modal constants
LOOP _ww=1,27
 _idx=_idx+1
 RO.N1=_ww
 RO.HBW=Pshr[_idx]
 RO.HBNW=Pshr[_idx+27]
 RO.NHB=Pshr[_idx+54]
 WRITE RECO=1
ENDLOOP

LOOP _xx=1,3
 RO.N2=_xx
 RO.HBW1=Pcbdshr[_xx]
 RO.HBNW1=Pcbdshr[_xx+3]
 RO.NHB1=Pcbdshr[_xx+7]
 WRITE RECO=2
ENDLOOP

ENDRUN


; PILOT Script


if ({MC_Calib}>0)
; End of PILOT Script

  LOOP PURPOSE = 1, 3, 1

; PILOT Script

IF (PURPOSE=1) ; HBW purpose
 PERIOD='PK'
 PURP='HBW'
 PURPNO=2
*del "{SCENARIO_DIR}\output\NEW_MCCONSTS.CSV"
*del "{SCENARIO_DIR}\output\NEW_TRNCOEFF.CSV"
ELSEIF (PURPOSE=2) ; HBO purpose
 PERIOD='OP'
 PURP='HBO'
 PURPNO=3
ELSEIF (PURPOSE=3) ; NHB purpose
 PERIOD='OP'
 PURP='NHB'
 PURPNO=4
ENDIF

; End of PILOT Script

; Script for program MATRIX in file "D:\Data\FDOT\TransitApp\TransitModelTierBC_Delivery\APPLICATIONS\MCMAT00F.S"
; Do not change filenames or add or remove FILEI/FILEO statements using an editor. Use Cube/Application Manager.
RUN PGM=MATRIX PRNFILE="{SCENARIO_DIR}\output\MCMAT00A1.PRN" MSG='Calibration'
FILEO PRINTO[3] = "{SCENARIO_DIR}\output\NEW_TRNCOEFF.CSV",
append=t
FILEI LOOKUPI[5] = "{SCENARIO_DIR}\output\CBDSHARES.DBF"
FILEO PRINTO[2] = "{SCENARIO_DIR}\output\CalibSum.TXT",
append=t
FILEO PRINTO[1] = "{SCENARIO_DIR}\output\NEW_MCCONSTS.CSV",
append=t
FILEI LOOKUPI[4] = "{SCENARIO_DIR}\output\TRN_COEFFICIENTS.DBF"
FILEI LOOKUPI[3] = "{SCENARIO_DIR}\output\MODESHARES.DBF"
FILEI LOOKUPI[2] = "{SCENARIO_DIR}\output\MC_CONSTANTS.DBF"
FILEI LOOKUPI[1] = "{CATALOG_DIR}\parameters\MC_TARGETS.DBF"

zones=1
numchoice=9
numchoice2=12

 ; LOOKUP for Coefficients
 LOOKUP, NAME=COEFF, LOOKUP[1]=1, RESULT=@PURPNO@, INTERPOLATE=N, LIST=Y, LOOKUPI=4
 ; Transit Coefficients
  COEFF_IVTT   = COEFF(1,1)
  COEFF_OVT    = COEFF(1,3)
  COEFF_COST   = COEFF(1,4)
  COEFF_AAT    = COEFF(1,5)
  COEFF_XFER   = COEFF(1,6)
  COEFF_DCBD   = COEFF(1,7)
  COEFF_DEXUP  = COEFF(1,8)
  COEFF_DEXUA  = COEFF(1,9)
  NC_TRNAC     = COEFF(1,10)
  NC_TRN       = COEFF(1,11)
  NC_AUTO      = COEFF(1,12)
  NC_AUTOSR    = COEFF(1,13)

  COEFF_DCBD_WALK   = COEFF(1,15)
  COEFF_DCBD_PNR    = COEFF(1,16)
  COEFF_DCBD_KNR    = COEFF(1,17)

 ; Nesting Coefficients
  NC_DriveAlone = NC_AUTO
  NC_SharedRide = NC_AUTO * NC_AUTOSR
  NC_Wlk = NC_TRN * NC_TRNAC
  NC_PNR = NC_TRN * NC_TRNAC
  NC_KNR = NC_TRN * NC_TRNAC

 LOOP MARKET=1,3  ; 0 car, 1 car, 2+ car household

  ; LOOKUP for previuos run shares
  _idx=numchoice*(MARKET-1)
  LOOKUP NAME=SHARES, LOOKUP[1]=1, RESULT=@PURPNO@,FAIL=0,0,0,LIST=Y,INTERPOLATE=N, LOOKUPI=3
  Eda=SHARES(1,_idx+1)         ; 1 - drive alone Previous share
  Ehov2=SHARES(1,_idx+2)       ; 2 - HOV2 Previous share
  Ehov3=SHARES(1,_idx+3)       ; 3 - HOV3+ Previous share
  Ewalkbus=SHARES(1,_idx+4)    ; 4 - Walk to bus Previous share
  Ewalkprj=SHARES(1,_idx+5)    ; 5 - Walk to prj Previous share
  Epnrbus=SHARES(1,_idx+6)     ; 6 - PNR to bus Previous share
  Epnrprj=SHARES(1,_idx+7)     ; 7 - PNR to prj Previous share
  Eknrbus=SHARES(1,_idx+8)     ; 8 - KNR to bus Previous share
  Eknrprj=SHARES(1,_idx+9)     ; 9 - KNR to prj Previous share
  Eshr  = Ehov2 + Ehov3
  Eauto = Eda + Eshr
  Ewalk = Ewalkbus + Ewalkprj
  Epnr  = Epnrbus + Epnrprj
  Eknr  = Eknrbus + Eknrprj
  Etran = Ewalk + Epnr + Eknr

  ; LOOKUP for previuos run shares of CBD targets
  _idx=numchoice*(MARKET-1)
  LOOKUP NAME=CBDSHARES, LOOKUP[1]=1, RESULT=@PURPNO@,FAIL=0,0,0,LIST=Y,INTERPOLATE=N, LOOKUPI=5
  Ecbdwalk=CBDSHARES(1,1)
  Ecbdpnr =CBDSHARES(1,2)
  Ecbdknr2 =CBDSHARES(1,3)

  ; LOOKUP for constants
  _idx=numchoice2*(MARKET-1)
  LOOKUP NAME=CONSTANTS, LOOKUP[1]=1, RESULT=@PURPNO@,FAIL=0,0,0,LIST=Y,INTERPOLATE=N, LOOKUPI=2
  Kda=CONSTANTS(1,_idx+1)         ; 1 - drive alone
  Khov2=CONSTANTS(1,_idx+2)       ; 2 - HOV2
  Khov3=CONSTANTS(1,_idx+3)       ; 3 - HOV3+
  Kwalkbus=CONSTANTS(1,_idx+4)    ; 4 - Walk to bus
  Kwalkprj=CONSTANTS(1,_idx+5)    ; 5 - Walk to prj
  Kpnrbus=CONSTANTS(1,_idx+6)     ; 6 - PNR to bus
  Kpnrprj=CONSTANTS(1,_idx+7)     ; 7 - KNR to prj
  Kknrbus=CONSTANTS(1,_idx+8)     ; 8 - PNR to bus
  Kknrprj=CONSTANTS(1,_idx+9)     ; 9 - KNR to prj

  ; LOOKUP for targets
  LOOKUP NAME=TARG, LOOKUP[1]=1, RESULT=@PURPNO@, FAIL=0,0,0,LIST=Y,INTERPOLATE=N, LOOKUPI=1
  Oda=TARG(1,_idx+1)              ; 1- drive alone target
  Ohov2=TARG(1,_idx+2)            ; 2- hov2 target
  Ohov3=TARG(1,_idx+3)            ; 3- hov3 target
  Owalkbus=TARG(1,_idx+4)         ; 4- walk to bus target
  Owalkprj=TARG(1,_idx+5)         ; 5- walk to prj target
  Opnrbus=TARG(1,_idx+6)          ; 6- PNR to bus target
  Opnrprj=TARG(1,_idx+7)          ; 7- PNR to prj target
  Oknrbus=TARG(1,_idx+8)          ; 8- KNR to bus target
  Oknrprj=TARG(1,_idx+9)          ; 9- KNR to prj target

; targets for CBD trips
  Ocbdwalk=TARG(1,37)
  Ocbdpnr=TARG(1,38)
  Ocbdknr2=TARG(1,39)
  Oshr  = Ohov2 + Ohov3
  Oauto = Oda + Oshr
  Owalk = Owalkbus + Owalkprj
  Opnr  = Opnrbus + Opnrprj
  Oknr  = Oknrbus + Oknrprj
  Otran = Owalk + Opnr + Oknr

;**************************************************************************************************
; MODE CHOICE CALIBRATION
;**************************************************************************************************
; following symbols used in this script
; E-previous share, K-previuos constant, O-target, L-logsum, R-revised constant

  D=+1.0    ; Dampening factor
  tiny=0.0000000000001

  ; Compute deltas
  dDA = 0
  dH2 = 0
  dH3 = 0
  dWB = 0
  dWP = 0
  dPB = 0
  dPP = 0
  dKB = 0
  dKP = 0

  dcbdwalk=0
  dcbdpnr=0
  dcbdknr=0

_dummy=0.000001
  if (Eda>_dummy)      dDA = LN(Eda / (Oda+tiny)) * NC_Auto
  if (Ehov2>_dummy)    dH2 = LN(Ehov2 / (Ohov2+tiny)) * NC_Auto * NC_AutoSR
  if (Ehov3>_dummy)    dH3 = LN(Ehov3 / (Ohov3+tiny)) * NC_Auto * NC_AutoSR
  if (Ewalkbus>_dummy) dWB = LN(Ewalkbus / (Owalkbus+tiny)) * NC_Trn * NC_TrnAC
  if (Ewalkprj>_dummy)
    dWP = LN(Ewalkprj / (Owalkprj+tiny)) * NC_Trn * NC_TrnAC
  else
    dWP = dWB
  endif

  if (Epnrbus>_dummy)  dPB = LN(Epnrbus  / (Opnrbus+tiny))  * NC_Trn * NC_TrnAC
  if (Epnrprj>_dummy)
    dPP = LN(Epnrprj  / (Opnrprj+tiny))  * NC_Trn * NC_TrnAC
  else
    dPP = dPB
  endif

  if (Eknrbus>_dummy)  dKB = LN(Eknrbus  / (Oknrbus+tiny))  * NC_Trn * NC_TrnAC
  if (Eknrprj>_dummy)
   dKP = LN(Eknrprj  / (Oknrprj+tiny))  * NC_Trn * NC_TrnAC
  else
   dKP = dKB
  endif

  if (Ecbdwalk>_dummy)    dcbdwalk = LN(Ecbdwalk / (Ocbdwalk+tiny)) * NC_Trn * NC_TrnAC
  if (Ecbdpnr>_dummy)     dcbdpnr = LN(Ecbdpnr / (Ocbdpnr+tiny)) * NC_Trn * NC_TrnAC
  if (Ecbdknr2>_dummy)     dcbdknr = LN(Ecbdknr2 / (Ocbdknr2+tiny)) * NC_Trn * NC_TrnAC

  ; Revise constants
  Rda      = Kda
  Rhov2    = Khov2    + (dDA - dH2)
  Rhov3    = Khov3    + (dDA - dH3)
  Rwalkbus = Kwalkbus + (dDA - dWB)
  Rwalkprj = Kwalkprj + (dDA - dWP)
  if (MARKET==1 & ('@PURP@'<> 'NHB'))
    Rpnrbus  = Kpnrbus
    Rpnrprj  = Kpnrprj
  else
    Rpnrbus  = Kpnrbus  + (dDA - dPB)
    Rpnrprj  = Kpnrprj  + (dDA - dPP)
  endif
  Rknrbus  = Kknrbus  + (dDA - dKB)
  Rknrprj  = Kknrprj  + (dDA - dKP)

  Rcbdwalk     = COEFF_DCBD_WALK + (dDA - dcbdwalk)
  Rcbdpnr      = COEFF_DCBD_PNR + (dDA - dcbdpnr)
  Rcbdknr      = COEFF_DCBD_KNR + (dDA - dcbdknr)

  if (Oda<_dummy)        Rda=-999.99
  if (Ohov2<_dummy)      Rhov2=-999.99
  if (Ohov3<_dummy)      Rhov3=-999.99
  if (Owalkbus<_dummy)   Rwalkbus=-999.99
                         Rwalkprj=Rwalkbus
  if (Opnrbus<_dummy)    Rpnrbus=-999.99
                         Rpnrprj=Rpnrbus
  if (Oknrbus<_dummy)    Rknrbus=-999.99
                         Rknrprj=Rknrbus
  if (Ocbdwalk<_dummy)   Rcbdwalk   =-999.99
  if (Ocbdpnr<_dummy)    Rcbdpnr    =-999.99
  if (Ocbdknr2<_dummy)    Rcbdknr   =-999.99

  ; print calibration summary
  if (market==1) print list='\n\n\nIteration ',@AMLoop_1@(2.0),printo=2
  if (market==1) _lab='Zero Car HHs'
  if (market==2) _lab='One Car HHs '
  if (market==3) _lab='Two+ Car HHs'
  print list='\n\n','@PURP@, ',_lab(12),'\n',printo=2
  print list='Category            ','   TargShare'(12),'    EstShare'(12),'   PrevConst'(12),'      Adjust'(12),'    RevConst'(12),printo=2
  print list='--------            ','   ---------'(12),'    --------'(12),'   ---------'(12),'      ------'(12),'    --------'(12),printo=2
  print list='Drive Alone         ',Oda(12.6)      ,Eda(12.6)     ,Kda(12.6)     ,(dDA-dDA)(12.6),Rda(12.6)     ,printo=2
  print list='One Pax             ',Ohov2(12.6)    ,Ehov2(12.6)   ,Khov2(12.6)   ,(dDA-dH2)(12.6),Rhov2(12.6)   ,printo=2
  print list='Two+ Pax            ',Ohov3(12.6)    ,Ehov3(12.6)   ,Khov3(12.6)   ,(dDA-dH3)(12.6),Rhov3(12.6)   ,printo=2
  print list='Walk-Bus            ',Owalkbus(12.6) ,Ewalkbus(12.6),Kwalkbus(12.6),(dDA-dWB)(12.6),Rwalkbus(12.6),printo=2
  print list='Walk-Project        ',Owalkprj(12.6) ,Ewalkprj(12.6),Kwalkprj(12.6),(dDA-dWP)(12.6),Rwalkprj(12.6),printo=2
  print list='PNR-Bus             ',Opnrbus(12.6)  ,Epnrbus(12.6) ,Kpnrbus(12.6) ,(dDA-dPB)(12.6),Rpnrbus(12.6) ,printo=2
  print list='PNR-Project         ',Opnrprj(12.6)  ,Epnrprj(12.6) ,Kpnrprj(12.6) ,(dDA-dPP)(12.6),Rpnrprj(12.6) ,printo=2
  print list='KNR-Bus             ',Oknrbus(12.6)  ,Eknrbus(12.6) ,Kknrbus(12.6) ,(dDA-dKB)(12.6),Rknrbus(12.6) ,printo=2
  print list='KNR-Project         ',Oknrprj(12.6)  ,Eknrprj(12.6) ,Kknrprj(12.6) ,(dDA-dKP)(12.6),Rknrprj(12.6) ,printo=2
  print list='Shared Ride         ',Oshr(12.6)     ,Eshr(12.6)    ,printo=2
  print list='Auto                ',Oauto(12.6)    ,Eauto(12.6)   ,printo=2
  print list='Walk                ',Owalk(12.6)    ,Ewalk(12.6)   ,' '(12),       printo=2
  print list='PNR                 ',Opnr(12.6)     ,Epnr(12.6)    ,' '(12),       printo=2
  print list='KNR                 ',Oknr(12.6)     ,Eknr(12.6)    ,' '(12),       printo=2
  print list='Transit             ',Otran(12.6)    ,Etran(12.6)   ,' '(12),       printo=2

  ; print REVISED modal constants
  PRINT CSV=T, LIST= (36*((@PURPNO@-1)-1)+12*(MARKET-1)+1),Rda(12.6),PRINTO=1
  PRINT CSV=T, LIST= (36*((@PURPNO@-1)-1)+12*(MARKET-1)+2),Rhov2(12.6),PRINTO=1
  PRINT CSV=T, LIST= (36*((@PURPNO@-1)-1)+12*(MARKET-1)+3),Rhov3(12.6),PRINTO=1
  PRINT CSV=T, LIST= (36*((@PURPNO@-1)-1)+12*(MARKET-1)+4),Rwalkbus(12.6),PRINTO=1
  PRINT CSV=T, LIST= (36*((@PURPNO@-1)-1)+12*(MARKET-1)+5),Rwalkprj(12.6),PRINTO=1
  PRINT CSV=T, LIST= (36*((@PURPNO@-1)-1)+12*(MARKET-1)+6),Rpnrbus(12.6),PRINTO=1
  PRINT CSV=T, LIST= (36*((@PURPNO@-1)-1)+12*(MARKET-1)+7),Rpnrprj(12.6),PRINTO=1
  PRINT CSV=T, LIST= (36*((@PURPNO@-1)-1)+12*(MARKET-1)+8),Rknrbus(12.6),PRINTO=1
  PRINT CSV=T, LIST= (36*((@PURPNO@-1)-1)+12*(MARKET-1)+9),Rknrprj(12.6),PRINTO=1
  PRINT CSV=T, LIST= (36*((@PURPNO@-1)-1)+12*(MARKET-1)+10),-999.99(12.6),PRINTO=1
  PRINT CSV=T, LIST= (36*((@PURPNO@-1)-1)+12*(MARKET-1)+11),-999.99(12.6),PRINTO=1
  PRINT CSV=T, LIST= (36*((@PURPNO@-1)-1)+12*(MARKET-1)+12),-999.99(12.6),PRINTO=1

ENDLOOP

  ; print REVISED modal coefficients (only CBD attraction-related ones)
  print list='CBD Attraction Coefficients',printo=2
  print list='CBD Attr Walk       ',Ocbdwalk(12.6) ,Ecbdwalk(12.6),COEFF_DCBD_WALK(12.6),(dDA-dcbdwalk)(12.6),Rcbdwalk(12.6),printo=2
  print list='CBD Attr PNR        ',OcbdPNR(12.6) ,EcbdPNR(12.6),COEFF_DCBD_PNR(12.6),(dDA-dcbdPNR)(12.6),RcbdPNR(12.6),printo=2
  print list='CBD Attr KNR        ',OcbdKNR2(12.6) ,EcbdKNR2(12.6),COEFF_DCBD_KNR(12.6),(dDA-dcbdKNR)(12.6),RcbdKNR(12.6),printo=2

  PRINT CSV=T, LIST=1+(18*(@PURPNO@-2)),  COEFF_IVTT(10.5)  ,PRINTO=3
  PRINT CSV=T, LIST=2+(18*(@PURPNO@-2)),  COEFF_IVTT(10.5)  ,PRINTO=3
  PRINT CSV=T, LIST=3+(18*(@PURPNO@-2)),  COEFF_OVT(10.5)   ,PRINTO=3
  PRINT CSV=T, LIST=4+(18*(@PURPNO@-2)),  COEFF_COST(10.5)  ,PRINTO=3
  PRINT CSV=T, LIST=5+(18*(@PURPNO@-2)),  COEFF_AAT(10.5)   ,PRINTO=3
  PRINT CSV=T, LIST=6+(18*(@PURPNO@-2)),  COEFF_XFER(10.5)  ,PRINTO=3
  PRINT CSV=T, LIST=7+(18*(@PURPNO@-2)),  COEFF_DCBD(10.5)  ,PRINTO=3
  PRINT CSV=T, LIST=8+(18*(@PURPNO@-2)),  COEFF_DEXUP(10.5) ,PRINTO=3
  PRINT CSV=T, LIST=9+(18*(@PURPNO@-2)),  COEFF_DEXUA(10.5) ,PRINTO=3
  PRINT CSV=T, LIST=10+(18*(@PURPNO@-2)), NC_TRNAC(10.5)    ,PRINTO=3
  PRINT CSV=T, LIST=11+(18*(@PURPNO@-2)), NC_TRN(10.5)      ,PRINTO=3
  PRINT CSV=T, LIST=12+(18*(@PURPNO@-2)), NC_AUTO(10.5)     ,PRINTO=3
  PRINT CSV=T, LIST=13+(18*(@PURPNO@-2)), NC_AUTOSR(10.5)   ,PRINTO=3
  PRINT CSV=T, LIST=15+(18*(@PURPNO@-2)), Rcbdwalk(10.5 )   ,PRINTO=3
  PRINT CSV=T, LIST=16+(18*(@PURPNO@-2)), Rcbdpnr(10.5)     ,PRINTO=3
  PRINT CSV=T, LIST=17+(18*(@PURPNO@-2)), Rcbdknr(10.5)     ,PRINTO=3

ENDRUN


  ENDLOOP

; Script for program MATRIX in file "D:\Data\FDOT\TransitApp\TransitModelTierBC_Delivery\APPLICATIONS\MCMAT00I.S"
; Do not change filenames or add or remove FILEI/FILEO statements using an editor. Use Cube/Application Manager.
RUN PGM=MATRIX PRNFILE="{SCENARIO_DIR}\output\MCMAT00I.PRN" MSG='Convert revised constants to DBF'
FILEO RECO[2] = "{SCENARIO_DIR}\output\TRN_COEFFICIENTS.DBF",
FORM=10.6,FIELDS=N1,HBW,HBNW,NHB
FILEI LOOKUPI[2] = "{SCENARIO_DIR}\output\NEW_TRNCOEFF.CSV"
FILEO RECO[1] = "{SCENARIO_DIR}\output\MC_CONSTANTS.DBF",
FORM=10.6,FIELDS=N1,HBW,HBNW,NHB
FILEI LOOKUPI[1] = "{SCENARIO_DIR}\output\NEW_MCCONSTS.CSV"

zones=1
array Nconst=108, Ncoeff=54

; LOOKUP for previuos run shares
LOOKUP NAME=NewConst, LOOKUP[1]=1, RESULT=2,FAIL=0,0,0,LIST=Y,INTERPOLATE=N, LOOKUPI=1
LOOKUP NAME=Ncoef, LOOKUP[1]=1, RESULT=2,FAIL=0,0,0,LIST=Y,INTERPOLATE=N, LOOKUPI=2

LOOP _ww=1,108
; records 1 through 9 are for 9 choices for HBW purpose and 0 car households, next 9 is for HBW purpose and 1 car household....
 Nconst[_ww] = NewConst(1,_ww)
 LIST=_ww,Nconst[_ww]
ENDLOOP

LOOP _ww=1,54
 Ncoeff[_ww] = Ncoef(1,_ww)
 LIST=_ww,Ncoef[_ww]
ENDLOOP

; print REVISED modal constants
LOOP _ww=1,36
 _idx=_ww
 RO.N1=_ww
 RO.HBW=Nconst[_idx]
 RO.HBNW=Nconst[_idx+36]
 RO.NHB=Nconst[_idx+72]
 WRITE RECO=1
ENDLOOP

LOOP _ww=1,18
  RO.N1 = _ww
  RO.HBW  = Ncoeff[_ww]
  RO.HBNW = Ncoeff[_ww+18]
  RO.NHB  = Ncoeff[_ww+36]
  WRITE RECO=2
ENDLOOP

ENDRUN


RUN PGM="C:\Program Files\Citilabs\Cube\TRCOPY.bat" PARAMETERS='"{SCENARIO_DIR}\output\MC_CONSTANTS.DBF" "{CATALOG_DIR}\parameters\MC_CONSTANTS.DBF" '
ENDRUN

RUN PGM="C:\Program Files\Citilabs\Cube\TRCOPY.bat" PARAMETERS='"{SCENARIO_DIR}\output\TRN_COEFFICIENTS.DBF" "{CATALOG_DIR}\parameters\TRN_COEFFICIENTS.DBF" '
ENDRUN

; PILOT Script
; Do not change filenames or add or remove FILEI/FILEO statements using an editor. Use Cube/Application Manager.


else ; end mode choice calibration
endif
; End of PILOT Script

ENDLOOP

; Script for program MATRIX in file "D:\Data\FDOT\TransitApp\TransitModelTierBC_Delivery\APPLICATIONS\MCMAT00D.S"
; Do not change filenames or add or remove FILEI/FILEO statements using an editor. Use Cube/Application Manager.
RUN PGM=MATRIX PRNFILE="{SCENARIO_DIR}\output\MCMAT00H.PRN" MSG='Combine trip tables for assignment'
FILEO MATO[2] = "{SCENARIO_DIR}\output\TRANSITTAB_{alt}{year}.MAT",
 MO=131-136,141-146, DEC=18*s,
 NAME=PKWlkBus,PKWlkPrj,PKPNRBus,PKPNRPrj,PKKNRBus,PKKNRPrj,
      OPWlkBus,OPWlkPrj,OPPNRBus,OPPNRPrj,OPKNRBus,OPKNRPrj
FILEO MATO[1] = "{SCENARIO_DIR}\output\HWYTTAB_TMP.MAT",
 MO=121-126, NAME=TRKIEII,SOVIEII,HOVIEII,TRKEE,SOVEE,HOVEE, DEC=6*s

FILEI MATI[3] = "{SCENARIO_DIR}\output\NHB_{alt}{year}.MAT"
FILEI MATI[2] = "{SCENARIO_DIR}\output\HBO_{alt}{year}.MAT"
FILEI MATI[1] = "{SCENARIO_DIR}\output\HBW_{alt}{year}.MAT"

PAR ZONEMSG=100
DistributeINTRASTEP ProcessID="TMDist", ProcessList=1-3

FILLMW MW[1]  = MI.1.1,2,3,4,5,6,7,8,9;,10,11,12   ; - HBW trips
FILLMW MW[21] = MI.2.1,2,3,4,5,6,7,8,9;,10,11,12   ; - HBNW trips
FILLMW MW[41] = MI.3.1,2,3,4,5,6,7,8,9;,10,11,12   ; - NHB trips

; PEAK TRANSIT
MW[131]=MW[4]
MW[132]=MW[5]
MW[133]=MW[6]
MW[134]=MW[7]
MW[135]=MW[8]
MW[136]=MW[9]

; OFF-PEAK TRANSIT
MW[141]=MW[24] + MW[44]
MW[142]=MW[25] + MW[45]
MW[143]=MW[26] + MW[46]
MW[144]=MW[27] + MW[47]
MW[145]=MW[28] + MW[48]
MW[146]=MW[29] + MW[49]

ENDRUN


