
; Do not change filenames or add or remove FILEI/FILEO statements using an editor. Use Cube/Application Manager.
RUN PGM=NETWORK PRNFILE="{SCENARIO_DIR}\Output\TPNET00L.PRN" MSG='Transit speeds for off-peak period'
FILEI LINKI[1] = "{SCENARIO_DIR}\output\unloaded_{alt}{year}.net"
FILEO PRINTO[1] = "{SCENARIO_DIR}\Output\XY_{alt}{year}.DAT"
FILEI LOOKUPI[1] = "{CATALOG_DIR}\parameters\TSPDOP.CSV"
FILEO NETO = "{SCENARIO_DIR}\output\unloaded2_{alt}{year}.net"

PROCESS  PHASE=NODEMERGE

  print list=n(6.0),x(20.2),y(20.2),printo=1
ENDPROCESS

PROCESS PHASE=LINKMERGE

  ;If auto travel time is not present or is zero, a default value of 15 mph is used.
  IF (TIME>0)
     _AUTOSPEED=60*DISTANCE/TIME
  ELSE
     _AUTOSPEED=15
  ENDIF

  ; TRANPLAN-style transit speed calculation
  LOOKUP name=CURVE,
     lookup[1]=1, result=15,
     lookup[2]=2, result=16,
     lookup[3]=3, result=17,
     lookup[4]=4, result=18,
     lookup[5]=5, result=19,
     lookup[6]=6, result=20,
     lookup[7]=7, result=21,
     lookup[8]=8, result=22,
     lookup[9]=9, result=23,
     lookup[10]=10, result=24,
     lookup[11]=11, result=25,
     lookup[12]=12, result=26,
     lookup[13]=13, result=27,
     lookup[14]=14, result=28,
     interpolate=y, list=y, lookupi=1

;read,
; FILE = "{SCENARIO_DIR}\OUTPUT\CURVES.TXT"

 ;**************************************************************
;BEGIN POTENTIAL SCRIPT ADJUSTMENT
;**************************************************************
 
;************************************************************************************************
;* DEFAULT TRANSIT SPEEDS SET EQUAL TO AUTO SPEEDS. APPLY APPROPRIATE TRANSIT SPEED CURVES HERE.*
;************************************************************************************************

  IF(_AUTOSPEED>0)
     _TSPD21=_AUTOSPEED  ; speeds
     _TSPD22=_AUTOSPEED  ;
     _TSPD23=_AUTOSPEED  ;
     _TSPD24=_AUTOSPEED  ;
     _TSPD25=_AUTOSPEED  ;
     _TSPD26=_AUTOSPEED  ;
     _TSPD27=_AUTOSPEED  ;

     M21TIMEOP=60*DISTANCE/_AUTOSPEED
     M22TIMEOP=60*DISTANCE/_AUTOSPEED
     M23TIMEOP=60*DISTANCE/_AUTOSPEED
     M24TIMEOP=60*DISTANCE/_AUTOSPEED
     M25TIMEOP=60*DISTANCE/_AUTOSPEED
     M26TIMEOP=60*DISTANCE/_AUTOSPEED
     M27TIMEOP=60*DISTANCE/_AUTOSPEED
      
  ENDIF

;**************************************************************
;END POTENTIAL SCRIPT ADJUSTMENT
;**************************************************************

  ; Bus time overrides
  IF (TBSSPEED>0 && TBSTIME==0) TBSTIME = (DISTANCE/TBSSPEED)*60.0
  IF (TBSTIME>0)
     M21TIMEOP=TBSTIME
     M22TIMEOP=TBSTIME
     M23TIMEOP=TBSTIME      
  ENDIF

  ; Fixed-guideway time overrides
  IF (TFGSPEED>0 && TFGTIME==0) TFGTIME = (DISTANCE/TFGSPEED)*60.0
  IF (TFGTIME>0&&TFGMODE=21) M21TIMEOP=TFGTIME
  IF (TFGTIME>0&&TFGMODE=22) M22TIMEOP=TFGTIME
  IF (TFGTIME>0&&TFGMODE=23) M23TIMEOP=TFGTIME
  IF (TFGTIME>0&&TFGMODE=24) M24TIMEOP=TFGTIME
  IF (TFGTIME>0&&TFGMODE=25) M25TIMEOP=TFGTIME
  IF (TFGTIME>0&&TFGMODE=26) M26TIMEOP=TFGTIME
  IF (TFGTIME>0&&TFGMODE=27) M27TIMEOP=TFGTIME

  ; WALK CONTROLS
  WALKTIME=60*DISTANCE/{AVGWLKSPD}
  ADJDISTANCE=DISTANCE
  IF (FTYPE=10-19,70-99)
     WALKTIME=999.99
  ENDIF

  IF (FTYPE=59) 
     WALKTIME=1
     distance=0.05
     ADJDISTANCE = DISTANCE
  ENDIF

  ; Debug speeds for given A and B nodes. Set {FromNode} and {ToNode} to required A and B nodes in catalog keys
  IF ((A={FromNode}) && (B={ToNode}))

     list="\n\n"
     list="     An     Bn   Dist   ASpd   Atim   TSpd   Ttim    Crv"
     list=A(7.0),B(7.0),DISTANCE(7.2),_AUTOSPEED(7.2),TIME(7.2),_TSPD21(7.2),M21TIMEOP(7.2),_CURVEMODE21(7.0)," MODE21"
     list=A(7.0),B(7.0),DISTANCE(7.2),_AUTOSPEED(7.2),TIME(7.2),_TSPD22(7.2),M22TIMEOP(7.2),_CURVEMODE22(7.0)," MODE22"
     list=A(7.0),B(7.0),DISTANCE(7.2),_AUTOSPEED(7.2),TIME(7.2),_TSPD23(7.2),M23TIMEOP(7.2),_CURVEMODE23(7.0)," MODE23"
     list=A(7.0),B(7.0),DISTANCE(7.2),_AUTOSPEED(7.2),TIME(7.2),_TSPD24(7.2),M24TIMEOP(7.2),_CURVEMODE24(7.0)," MODE24"
     list=A(7.0),B(7.0),DISTANCE(7.2),_AUTOSPEED(7.2),TIME(7.2),_TSPD25(7.2),M25TIMEOP(7.2),_CURVEMODE25(7.0)," MODE25"
     list=A(7.0),B(7.0),DISTANCE(7.2),_AUTOSPEED(7.2),TIME(7.2),_TSPD26(7.2),M26TIMEOP(7.2),_CURVEMODE26(7.0)," MODE26"
     list=A(7.0),B(7.0),DISTANCE(7.2),_AUTOSPEED(7.2),TIME(7.2),_TSPD27(7.2),M27TIMEOP(7.2),_CURVEMODE27(7.0)," MODE27"
     list="\n\n"
  ENDIF

ENDPROCESS

ENDRUN
