; Do not change filenames or add or remove FILEI/FILEO statements using an editor. Use Cube/Application Manager.
RUN PGM=MATRIX PRNFILE="{SCENARIO_DIR}\output\TSMAT00F.PRN" MSG='Create auto-access vehicle trip table'
FILEI MATI[4] = "{SCENARIO_DIR}\output\TLOADOP_{alt}{year}.mat"
FILEI MATI[1] = "{SCENARIO_DIR}\output\TLOADPK_{alt}{year}.mat"
FILEI MATI[6] = "{SCENARIO_DIR}\output\STATIONOP3_{alt}{year}.DBF",
PATTERN=IJ:V, FIELDS=I,J,FROMNODE

FILEI MATI[5] = "{SCENARIO_DIR}\output\STATIONOP2_{alt}{year}.DBF",
PATTERN=IJ:V, FIELDS=I,J,FROMNODE

FILEI MATI[3] = "{SCENARIO_DIR}\output\STATIONPK3_{alt}{year}.DBF",
PATTERN=IJ:V, FIELDS=I,J,FROMNODE

FILEI MATI[2] = "{SCENARIO_DIR}\output\STATIONPK2_{alt}{year}.DBF",
PATTERN=IJ:V, FIELDS=I,J,FROMNODE

FILEI LOOKUPI[1] = "{SCENARIO_DIR}\output\STATION_{alt}{year}.DAT"
FILEO RECO[1] = "{SCENARIO_DIR}\output\TTAAPK_{alt}{year}.DBF",
FIELDS=I,J,M,AutoAccess

FILEO RECO[2] = "{SCENARIO_DIR}\output\TTAAOP_{alt}{year}.DBF",
FIELDS=I,J,M,AutoAccess


;DistributeINTRAStep ProcessID="FSUTMSdist" ProcessList=1-4

PARAMETERS ZONEMSG=100

ARRAY buspk={ZONESA} prjpk={ZONESA} busop={ZONESA} prjop={ZONESA}

FILLMW MW[11]=MI.1.3,4
FILLMW MW[21]=MI.2.1
FILLMW MW[31]=MI.3.1
FILLMW MW[41]=MI.4.3,4
FILLMW MW[51]=MI.5.1
FILLMW MW[61]=MI.6.1

LOOKUP NAME=NearestZone,
   LOOKUP[1]=2, RESULT=3,
   INTERPOLATE=N, FAIL=0,0,0,
   LIST=T, LOOKUPI=1

LOOP x=1,{ZONESA}
  buspk[x]=0, prjpk[x]=0
  busop[x]=0, prjop[x]=0
ENDLOOP

JLOOP
  ; sum up all auto access trips from all the zones
  IF (MW[11]>0)
    _statj=NearestZone(1,MW[21])
    IF (_statj>0) buspk[_statj] = buspk[_statj] + MW[11]
  ENDIF
  IF (MW[12]>0)
    _statj=NearestZone(1,MW[31])
    IF (_statj>0) buspk[_statj] = buspk[_statj] + MW[12]
  ENDIF
  IF (MW[41]>0)
    _statj=NearestZone(1,MW[51])
    IF (_statj>0) busop[_statj] = busop[_statj] + MW[41]
  ENDIF
  IF (MW[42]>0)
    _statj=NearestZone(1,MW[61])
    IF (_statj>0) busop[_statj] = busop[_statj] + MW[42]
  ENDIF
ENDJLOOP

;prepare auto access trips DBF
LOOP x=1,{ZONESA}
  IF (buspk[x]>0 || prjpk[x]>0)
    RO.I = I
    RO.J = x
    AutoBus  = buspk[x] / {OCTA}
    AutoProj = prjpk[x] / {OCTA}
    RO.AutoAccess = AutoBus + AutoProj
    WRITE RECO=1
  ENDIF
  IF (busop[x]>0 || prjop[x]>0)
    RO.I = I
    RO.J = x
    AutoBus  = busop[x] / {OCTA}
    AutoProj = prjop[x] / {OCTA}
    RO.AutoAccess = AutoBus + AutoProj
    WRITE RECO=2
  ENDIF
ENDLOOP

ENDRUN
